#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



void
main()
{
      int    flag ,ret ;
      int    jj, kk, wct ;
      int    dct, gct ,rct ;
      unsigned int stat;
      unsigned char   buff[16386] ; 
      char   *cary[30] ;
      char dict[8], rnum[12] ;
      CFile  *fpt , *dpt;
      int Rid ;
      char *wdenv ;
      char file[512] ;
      int  len ;
      char work[500000] ;
      

      InitEdrTbl() ;

      wdenv = (char *)getenv( "WORD_DB" ) ;
      if ( wdenv != NULL ) {
        len = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[len++] = '/' ;
      }
      else {
        len = 0 ;
      }
      /* 쥳ֹ椫饰롼ףɣĤ򸡺 */
      strcpy( &file[len], "R2G_DB" ) ;
      fpt = Create_IXT( file, 'b', 10000 , -1, 32) ;

      /* 롼ףɣĤ쥳ֹΥꥹȤ򸡺 */
      strcpy( &file[len], "G2R_IX" ) ;
      dpt = Create_IXT( file, 'b', 10000 , -1, 48) ;

      dct = 0 ;
      gct = 1 ;
      rct = 0 ;
      wct = 0 ;
      while( gets(buff) != NULL ){
          if ( strncmp( buff, "#####", 5) == 0 ) {
            if ( dct == 0 )
              continue ;
            ret = Add_IXT_DATA( dpt, (char *)&gct, 4, work, wct) ;
            wct = 0 ;
            gct++ ;
            dct = 0 ;
            continue ;
	  }
          if ( buff[0] == '\0' )
            continue ;
          if (( rct % 10000 ) == 0 ) {
            fprintf(stderr, "Put %d   \n",rct) ;
            /* system("date") ; */
          }
          //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;  
          ret = split1( '\t', buff, cary) ;
          Rid = GetCode2Wid( cary[0], dict, rnum) ;
          if ( dict[0] == '\0' && rnum[0] == '\0' ) {
            return ;
          }
          /* 쥳ֹ椫饰롼ףɣĤ뤿Σģ¤ */
          ret = Put_IXT(fpt, (char *)&Rid, 4, (char *)&gct, 4) ;
          /* printf("Put_IXT(Rid=>Gid): ret=%d\n",ret) ; */

          /* 롼ףɣĤ쥳ֹΥꥹȤ */
          put4byte( Rid , &work[wct] ) ; /* 쥳ֹ */
          wct += 4 ;
          rct++ ;
          dct++ ;
          continue ;
      }
      if ( wct != 0 )
          ret = Add_IXT_DATA( dpt, (char *)&gct, 4, work, wct) ;

      Close_IXT( fpt ) ;
      Close_IXT( dpt ) ;
      printf("gct=%d\n",gct) ;
}


