#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



int
main(int argc,  char **argv)
{
      int    flag ,ret ;
      int    jj, kk ;
      int    dct ;
      unsigned int stat;
      unsigned char   buff[16386] ; 
      unsigned char   buff2[16386] ;
      char  HFileName[256], CFileName[256], YFileName[256], WFileName[256] ;
      char  work[1024], work1[1024], work0[1024] ;
      char  putd[16] ;
      char   *cary[30], *cp ;
      CFile  *fpt , *dpt, *ypt, *cpt;
      FILE   *hfp, *yfp, *cfp ;
      int Rid ;
      char *wdenv ;
      char file[512] ;
      int len ;
      int dbflag = 0 ;

      InitEdrTbl() ;

      /*** DBե륪ץ ***/
      wdenv = (char *)getenv( "WORD_DB" ) ;
      if ( wdenv != NULL ) {
        len = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[len++] = '/' ;
      }
      else {
        len = 0 ;
      }
      strcpy( &file[len], "HDWD_IX" ) ;
      dpt = Create_IXT( file, 's', 20000 , 4, 48) ;
      strcpy( &file[len], "YOMI_IX" ) ;
      ypt = Create_IXT( file, 's', 20000 , 12, 48) ;
      strcpy( &file[len], "CP2W_IX" ) ;
      cpt = Create_IXT( file, 's', 10000 , -1, 48) ;
      strcpy( &file[len], "JWD" ) ;
      fpt = Create_IXT( file, 'b', 100000 , -1, 128) ;

      /*** ե륪ץ ***/
      file[len] = '\0' ;
      strcpy(HFileName, file);
      strcat(HFileName, "HLIST.wk");
      strcpy(YFileName, file);
      strcat(YFileName, "YLIST.wk");
      strcpy(CFileName, file);
      strcat(CFileName, "CLIST.wk");
      strcpy(WFileName, file);
      strcat(WFileName, "WORK.wk");

      if ( ( hfp = fopen( HFileName, "w" ) ) == NULL ) {
         fprintf( stderr,"Cannot open work file[%s]\n", HFileName ) ;
         return ;
      }
      if ( ( yfp = fopen( YFileName, "w" ) ) == NULL ) {
         fprintf( stderr,"Cannot open work file[%s]\n", YFileName ) ;
         return ;
      }
      if ( ( cfp = fopen( CFileName, "w" ) ) == NULL ) {
         fprintf( stderr,"Cannot open work file[%s]\n", CFileName ) ;
         return ;
      }
      GRAM_DB_Open() ;
      //DB_FileOpen() ;

      /*** եɤ߹ ***/
      dct = 0 ;
      while( gets(buff) != NULL ){
          if ( strncmp( buff, "Copyright", 9) == 0 ) {
            continue ;
	  }
          if ( strncmp( buff, "JWD", 3) != 0 ) {
            fprintf( stderr, "ERROR(CreateJWD):[%s]\n",buff ) ;
            continue ;
	  }
          dct++ ;
          if (( dct % 10000 ) == 0 ) {
            fprintf(stderr, "Put %d   \n",dct) ;
            //system("date") ;
          }
          //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
          len = CreateRec( dbflag, buff, buff2, 16386 ) ;
          if ( len == 0 ) {
            fprintf( stderr, ":[%s]\n",buff ) ; 
            continue ;
          }
          else if ( len < 0 ) {
            fprintf(stderr, "ERROR(CreateJWD):[%s]\n",buff ) ;
            continue ;
          }
          Rid = *(int *)buff2 ;
          ret = Put_IXT(fpt, buff2, 4, buff2, len) ;
          ret = StartPts(buff2,len,cary) ;
          /*** ɽǥå ***/
          if ( cary[6] != NULL && strcmp( cary[6], "\"\"") != 0 ) { 
             ret = GetFirstWd( cary[6] , work1, 1024) ;
             ret = EDR_StrStrip(work, work1) ;
             ret = Conv2Big(work0, work) ;
             if ( ret < 0 ) {
               printf("ERROR:HDWD:Conv2Big:IN>[%s](%d)\n",buff,strlen(buff)) ;
             }
             fprintf( hfp,"%s\t%d\t%d\t%d\t%d\n", work0, Rid, *cary[1], *cary[2], *cary[3] ) ;
	  }
          /*** ɤߥǥå(ɽ) ***/
          if ( cary[7] != NULL && strcmp( cary[7], "\"\"") != 0 ) { 
             ret = EDR_StrStrip(work, cary[7] ) ;
             cp = skip_ptr( '/', work )  ;
             ret = copy_word( work1, 1024 , work, cp ) ;
             ret = Conv2Big(work, work1) ;
             if ( ret < 0 ) {
               printf("ERROR:YOMI:Conv2Big:IN>[%s](%d)\n",buff,strlen(buff)) ;
             }
             fprintf( yfp,"%s\t%d\t%d\t%d\t%d\n", work, Rid, *cary[1], *cary[2], *cary[3] ) ;
	  }
          /*** ǰɣĥǥå ***/
          if ( cary[5] != NULL && strcmp( cary[5], "\"\"") != 0 ) { 
             fprintf( cfp,"%s\t%d\n", cary[5], Rid ) ;
	  }
      }
      fclose( hfp ) ;
      fclose( yfp ) ;
      fclose( cfp ) ;

      /*** ɽǥå ***/
      fprintf(stderr, "ɽǥå    ...\r");
      msort(HFileName, WFileName);
      ret = Create_HIndex( WFileName, dpt );
      if ( ret < 0 )
         return 1 ;
      remove(HFileName);

      /*** ɤߥǥå ***/
      fprintf(stderr, "ɤߥǥå    ...\r");
      msort(YFileName, WFileName);
      ret = Create_HIndex( WFileName, ypt );
      if ( ret < 0 )
         return 1 ;
      remove(YFileName);

      /*** ǰǥå ***/
      fprintf(stderr, "ǰǥå    ...\r");
      msort(CFileName, WFileName);
      ret = Create_CIndex( WFileName, cpt );
      if ( ret < 0 )
         return 1 ;
      remove(CFileName);
      remove(WFileName);

      GRAM_DB_Close() ;

      Close_IXT( dpt ) ;
      Close_IXT( ypt ) ;
      Close_IXT( fpt ) ;
      Close_IXT( cpt ) ;
      return 0 ;
}









