#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



void
main(int argc,  char **argv)
{
      int   vflag = 2 ,ret1, ret2 ;
      int   jj ;
      char  work[1024], work1[1024] ;
      CFile *fpt1 , *dpt1;
      CFile *fpt2 , *dpt2;
      char  *wdenv ;
      char  file[512] ;
      MorphInfo  morph[4096] ;

      if ( argc > 1 ) {
        if ( strcmp( *(argv+1), "-EDR" ) == 0 ) 
          vflag = 0 ;
        if ( strcmp( *(argv+1), "-FV" ) == 0 ) 
          vflag = 1 ;
        if ( strcmp( *(argv+1), "-V" ) == 0 ) 
          vflag = 2 ;
      }


      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */

      wdenv = (char *)getenv( "WORD_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "CP2W_IX" ) ;
      dpt1 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "JWD" ) ;
      fpt1 = Open_IXT( file, 'b' ) ;

      wdenv = (char *)getenv( "TECH_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "TCP2W_IX" ) ;
      dpt2 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "TJWD" ) ;
      fpt2 = Open_IXT( file, 'b' ) ;

      DB_FileOpen() ;
   
      while( gets( work ) != NULL ){
          printf("IN>[%s](%d)\n",work,strlen(work)) ;
          /* 쥳ֹΤߤ */
          ret1 = GetRecIDFromHdwd(0, dpt1, work, &morph[0], 4096 ) ;
          if ( ret1 != 0 ) {
            printf("----------------------------------------ܸ--------------\n") ;
            for( jj= 0 ; jj < ret1 ; jj++) {
              if ( vflag == 0 )
                PrnRecFromRID(stdout, fpt1,morph[jj].rno) ;  /* ţģҼɽ */
              else if ( vflag == 1 )
                PrnFVRecFromRID(stdout, fpt1,morph[jj].rno) ;/* FIELDVALUEɽ */
              else
                PrnVRecFromRID(stdout, fpt1,morph[jj].rno) ; /* VALUEɽ */
              printf("\n") ;
	    }
          }
          ret2 = GetRecIDFromHdwd(0, dpt2, work, &morph[0], 4096 ) ;
          if ( ret2 != 0 ) {
            printf("----------------------------------------Ѹ--------------\n") ;
            for( jj= 0 ; jj < ret2 ; jj++) {
              if ( vflag == 0 )
                PrnRecFromRID(stdout, fpt2,morph[jj].rno) ;  /* ţģҼɽ */
              else if ( vflag == 1 )
                PrnFVRecFromRID(stdout, fpt2,morph[jj].rno) ;/* FIELDVALUEɽ */
              else
                PrnVRecFromRID(stdout, fpt2,morph[jj].rno) ; /* VALUEɽ */
              printf("\n") ;
	    }
          }
          if ( ret1 == 0 && ret2 == 0 ) 
            printf("쥳[%s]¸ߤޤ\n",work) ;
      }

      DB_FileClose() ;
      if ( dpt1 != NULL ) Close_IXT( dpt1 ) ;
      if ( dpt2 != NULL ) Close_IXT( dpt2 ) ;
      if ( fpt1 != NULL ) Close_IXT( fpt1 ) ;
      if ( fpt2 != NULL ) Close_IXT( fpt2 ) ;
}



