#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



void
main(int argc,  char **argv)
{
      int    jj ;
      char  work[1024] ;
      char  *cp ;
      CFile  *fpt1 ;
      CFile  *fpt2 ;
      char *wdenv ;
      char file[512] ;
      int  did, vflag = 2 ;

      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */
      LoadRensetduTbl() ;        /* Ϣܥơ֥ɤ߹ */


      if ( argc > 1 ) {
        if ( strcmp( *(argv+1), "-EDR" ) == 0 ) 
          vflag = 0 ;
        if ( strcmp( *(argv+1), "-FV" ) == 0 ) 
          vflag = 1 ;
        if ( strcmp( *(argv+1), "-V" ) == 0 ) 
          vflag = 2 ;
      }

      wdenv = (char *)getenv( "WORD_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "JWD" ) ;
      fpt1 = Open_IXT( file, 'b' ) ;

      wdenv = (char *)getenv( "TECH_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "TJWD" ) ;
      fpt2 = Open_IXT( file, 'b' ) ;

      DB_FileOpen() ;
   
      while( gets( work ) != NULL ){
          printf("IN>ID=[%s]\n",work) ;
          did = atoi(work) ;
          if ( vflag == 0 ) {
            PrnRecFromRID(stdout, fpt1,did) ;  /* ţģҼɽ */
            PrnRecFromRID(stdout, fpt2,did) ;  /* ţģҼɽ */
          }
          else if ( vflag == 1 ) {
            PrnFVRecFromRID(stdout, fpt1,did) ;/* FIELDVALUEɽ */
            PrnFVRecFromRID(stdout, fpt2,did) ;/* FIELDVALUEɽ */
          }
          else {
            PrnVRecFromRID(stdout, fpt1,did) ; /* VALUEɽ */
            PrnVRecFromRID(stdout, fpt2,did) ; /* VALUEɽ */
          }
          printf("\n") ;
      }
      DB_FileClose() ;
      if ( fpt1 != NULL ) Close_IXT( fpt1 ) ;
      if ( fpt2 != NULL ) Close_IXT( fpt2 ) ;
}








