#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



void
main(int argc,  char **argv)
{
      int   vflag = 0 ,ret1, ret2 ;
      int   ii, jj, nct, wct ;
      char  work[1024], work1[1024] ;
      CFile *fpt1 , *dpt1 ;
      CFile *fpt2 , *dpt2 ;
      char  *wdenv ;
      char  file[512], cid[32] ;
      MorphInfo  morph[4096] ;
      char  *cidpt[512], *hdwd[512], cids[8192] ;
      int   cidct = 0, cct = 0 ;
      char  *cpt[128] ;


      if ( argc > 1 ) {
        if ( strcmp( *(argv+1), "-FV" ) == 0 ) 
          vflag = 1 ;
        if ( strcmp( *(argv+1), "-V" ) == 0 ) 
          vflag = 2 ;
      }


      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */
      DB_FileOpen() ;            /* ʸˡģ¤ȳǰģ¤򥪡ץ */
   

      wdenv = (char *)getenv( "WORD_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "HDWD_IX" ) ;
      dpt1 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "JWD" ) ;
      fpt1 = Open_IXT( file, 'b' ) ;

      wdenv = (char *)getenv( "TECH_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
        strcpy( &file[jj], "THDWD_IX" ) ;
        dpt2 = Open_IXT( file, 's') ;
        strcpy( &file[jj], "TJWD" ) ;
        fpt2 = Open_IXT( file, 'b' ) ;
      }
      else {
        dpt2 = fpt2 = NULL ;
      }

      while( gets( work ) != NULL ){
          printf("IN>[%s](%d)\n",work,strlen(work)) ;
          wct = split1( '\t', work, cpt) ;              /* ʸ */
          cidct = cct = 0 ;
          for ( ii = 0 ; ii < wct ; ii++ ) {
            ret1 = Conv2Big(work1, cpt[ii]) ;
            /* 쥳ֹΤߤ */
            ret1 = GetRecIDFromHdwd(0, dpt1, work1, &morph[0], 4096 ) ;
            if ( ret1 != 0 ) {
              printf("----------------------------------ܸ(׸)-[%s]-------------\n",cpt[ii]) ;
              for( jj = 0 ; jj < ret1 ; jj++) {
                PrnVRecFromRID(stdout, fpt1,morph[jj].rno) ;       /* VALUEΤߤɽ */
                if ( SingleWord(fpt1,morph[jj].rno) < 0 )
                  continue ;
                GetCidfromWREC(fpt1,morph[jj].rno, &cids[cct] ) ; /* ñ켭γǰID */
                nct = add_strary1( &cids[cct], cidpt, cidct) ;
                if ( nct != cidct ) {
                  cct += strlen( &cids[cct] ) + 1 ;
                  hdwd[cidct++] = &cids[cct] ;
                  strcpy( &cids[cct], work1 );
                  cct += strlen( work1 ) + 1 ;
                }
                printf("\n") ;
	      }
	    }
            /* 쥳ֹΤߤ */
            ret2 = GetRecIDFromHdwd(0, dpt2, work1, &morph[ret1], 4096 ) ;
            if ( ret2 != 0 ) {
              printf("----------------------------------Ѹ(׸)-[%s]-------------\n",cpt[ii]) ;
              for( jj = 0 ; jj < ret2 ; jj++) {
                PrnVRecFromRIDT(stdout, fpt2,morph[jj+ret1].rno) ;       /* VALUEΤߤɽ */
                if ( SingleWord(fpt2,morph[jj+ret1].rno) <= 0 )
                  continue ;
                GetCidfromWREC(fpt2,morph[jj+ret1].rno, &cids[cct] ) ; /* ñ켭γǰID */
                nct = add_strary1( &cids[cct], cidpt, cidct) ;
                if ( nct != cidct ) {
                  cct += strlen( &cids[cct] ) + 1 ;
                  hdwd[cidct++] = &cids[cct] ;
                  strcpy( &cids[cct], work1 );
                  cct += strlen( work1 ) + 1 ;
                }
                printf("\n") ;
	      }
	    }
            if ( ret1 == 0 && ret2 == 0 ) 
              printf("쥳[%s]¸ߤޤ\n",work1) ;
          }
          printf("----------------------------------η------------------------\n",cpt[ii]) ;
          PrnPathRecFromRID( cidpt, hdwd, cidct ) ;                  /* ǰηϤɽ */
      }

      DB_FileClose() ;


      if ( dpt1 != NULL ) Close_IXT( dpt1 ) ;
      if ( dpt2 != NULL ) Close_IXT( dpt2 ) ;
      if ( fpt1 != NULL ) Close_IXT( fpt1 ) ;
      if ( fpt2 != NULL ) Close_IXT( fpt2 ) ;

}





