#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



void
main(int argc,  char **argv)
{
      int    flag ,ret1, ret2 ;
      int    jj, ii, kk ;
      char  work[1024], work1[1024] ;
      char  *cp ;
      CFile  *fpt1 , *dpt1 ;
      CFile  *fpt2 , *dpt2;
      int Rid , Rids[1024] ;
      char *wdenv ;
      char file[512] ;
      int len, dct ;
      MorphInfo *mordata[1024] ;
      MorphInfo  morph[4096] ;
      int wlflag = 0 ;

      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */
      LoadRensetduTbl() ;        /* Ϣܥơ֥ɤ߹ */

      if ( argc > 1 ) {
        if ( strcmp( *(argv+1), "-WL" ) == 0 ) 
          wlflag = 1 ;
        if ( strcmp( *(argv+1), "-WLN" ) == 0 ) 
          wlflag = 2 ;
        if ( strcmp( *(argv+1), "-OWL" ) == 0 )
          wlflag = -1 ;
      }
      wdenv = (char *)getenv( "WORD_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "HDWD_IX" ) ;
      dpt1 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "JWD" ) ;
      fpt1 = Open_IXT( file, 'b' ) ;

      wdenv = (char *)getenv( "TECH_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "THDWD_IX" ) ;
      dpt2 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "TJWD" ) ;
      fpt2 = Open_IXT( file, 'b' ) ;

      DB_FileOpen() ;
   
      while( gets( work ) != NULL ){
          if ( *work == '\0' )
            continue ;
          printf("IN>[%s](%d)\n",work,strlen(work)) ;
          ret1 = Conv2Big(work1, work) ;
          dct = 0 ;
          cp = &work1[0] ;
          while( *cp != '\0' ) {
            //printf("----------------------------- --------------\n") ;
            //PrnMorFromHdwd(dpt, fpt, cp ) ;     /*  ǲϾ */
            mordata[ cp - work1 ] = NULL ;
            /* 쥳ֹΤߤ */
            ret1 = GetRecIDFromHdwd(1, dpt1, cp, &morph[dct], 4096 - dct) ;
            if ( ret1 != 0 ) {
              if ( wlflag >= 0 )
                printf("--------------------------- ܸʬס------------\n") ;
              mordata[ cp - work1 ] = &morph[dct] ;
              for( jj= 0 ; jj < ret1 ; jj++) {
                if ( wlflag >= 0 )
                  PrnMorFromRID( cp, &morph[dct+jj]) ;   /* ǲϾɽ */
                  /* ǥɥꥹȤɽ뤿˷ǲϾ¤Τ˥å */
                //SetMorFromRID(fpt1,morph[dct+jj].rno,&morph[dct+jj]) ; 
                morph[dct+jj].off = cp - work1 ;
                morph[dct+jj].next = &morph[dct+jj+1] ;
              }
              dct += ret1 ;
            }           
            /* 쥳ֹΤߤ */
            ret2 = GetRecIDFromHdwd(1, dpt2, cp, &morph[dct], 4096 - dct) ;
            if ( ret2 != 0 ) {
              if ( wlflag >= 0 )
                printf("--------------------------- Ѹʬס------------\n") ;
              if ( mordata[ cp - work1 ] == NULL )
                mordata[ cp - work1 ] = &morph[dct] ;
              for( jj= 0 ; jj < ret2 ; jj++) {
                if ( wlflag >= 0 )
                  PrnMorFromRID( cp, &morph[dct+jj]) ;   /* ǲϾɽ */
                  /* ǥɥꥹȤɽ뤿˷ǲϾ¤Τ˥å */
                //SetMorFromRID(fpt2,morph[dct+jj].rno,&morph[dct+jj]) ; 
                morph[dct+jj].off = cp - work1 ;
                morph[dct+jj].next = &morph[dct+jj+1] ;
              }
              dct += ret2 ;
            }           
            if ( ret1 != 0 || ret2 != 0 ) {
              morph[dct-1].next = NULL ;
            }
            if ( (*cp & 0x80) == 0)
              cp++ ;
            else {
              mordata[ cp - work1 +1] = NULL ;
              cp += 2 ;
            }
	  }
          /* ɥꥹȤɽ */
          if ( wlflag > 0 )
            PrintWordList(wlflag,work1,mordata) ;
          if ( wlflag < 0 )
            PrintWordList(2,work1,mordata) ;
      }
      DB_FileClose() ;

      if ( dpt1 != NULL ) Close_IXT( dpt1 ) ;
      if ( dpt2 != NULL ) Close_IXT( dpt2 ) ;
      if ( fpt1 != NULL ) Close_IXT( fpt1 ) ;
      if ( fpt2 != NULL ) Close_IXT( fpt2 ) ;

}


void Oginotest(CFile *dt, int id, MorphInfo *mp)
{
  char data[8192], hyoki[512] ,hyoki2[512];
  int  ret ;
  int i , j , kk;
  char *cary[64] ;


//  ret = Get_IXT(dt, (char *)&id, 4, data, 8192) ;
//  ret = StartPts( data, ret, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

  mp->lcon = GetLconID( "JLN5" ) ;  /* Ϣܾ              */
  mp->rcon = GetRconID( "JRM1" ) ;      /* Ϣܾ              */
  mp->pos  = GetJPoSID( "JN7" ) ;      /* ʻ                    */
  mp->grmid  = -1 ;          /* ʸˡɣ                */
  mp->leng =  4        ;  /* ʸĹ                */
  mp->cid = -1 ; /* ǰɣ       */
  mp->flag = 0 ; /* ե饰å   */
}





