/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "aconst.h"


/**************************************************************
 ѼԤȲäʤ顢쥳ɤɽ롣     ǰη
**************************************************************/
extern int  CurBRecIDs[8192] ;  /*** ȥ쥳ֹǼꥢ ***/
extern int  CurBRecBCt ;        /*** ȥ쥳ɿ             ***/
extern int  CurBParCID[8192] ;  /*** ̳ǰɣĳǼꥢ ***/
extern int  CurBChiCID[8192] ;  /*** ̳ǰɣĳǼꥢ ***/

extern int  CurTRecIDs[8192] ;  /*** ȥ쥳ֹǼꥢ ***/
extern int  CurTRecBCt ;        /*** ȥ쥳ɿ             ***/
extern int  CurTParCID[8192] ;  /*** ̳ǰɣĳǼꥢ ***/
extern int  CurTChiCID[8192] ;  /*** ̳ǰɣĳǼꥢ ***/


extern int  ENV_FLAGS ;         /*** оݡʴܸ졿Ѹˤλ ***/


/*** Template ***/
void  HelpInput() ;
void  PrnEDRCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf )  ;
void  PrnEDRCPCDOWN(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf )  ;
void  PrnTopDownCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) ;
void  PrnHokiCPCUP( FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf )  ;
void  PrnHokiCPCDOWN(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf )  ;
void  PrintJWDinCPC( FILE *fp, char *cp, int curlev) ;
void  SetAccessDict( char *cp ) ;
void  SetPrintMode( char *cp ) ;
int   Access_by_date( CFile *log, char *date ) ;
int   ChkConceptNode( char dict, char *node) ;

int AccessEDRCPC( char dict, char *cid ) ;
int PrintTOPDNCPC( FILE *fp, int com, char dict, char *cid, int lev ) ;
int PrintTREECPC( FILE *fp, int com, char dict, char *cid, int lev ) ;
int PrintHOKICPC( FILE *fp, int com, char dict, char *cid, int lev ) ;
int PrintEDRCPC( FILE *fp, int com, char dict, char *cid, int lev ) ;
char ExistCPC( char *node ) ;

void
main(int argc,  char **argv)
{
      int   ret1, ret2 ;
      int   lev, com;
      char  work[1024];
      char  *ary[64] ;
      FILE  *fp ;
      char dict ;
      /*
         ưĶ
      */

      InitEnv() ;                /* ɽ⡼ɤʤɴĶ */
      DB_FileOpen() ;
      WORD_DB_Open() ;
      TWORD_DB_Open() ;
      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */

      while( 1 ) {
          fprintf( stderr,">>> Input command\n" ) ;
          if ( gets( work ) == NULL )
            break ;
          if ( (com = InputCom(work,ary)) <= 0 )
            continue ;
          //printf("com=%d,ary[1] = %d\n",com,ary[1]) ;
          lev = 1 ;
          /* Find & Print records */
          CurBRecBCt = 0 ;
          if ( ary[2] != NULL ) {
            if ( *ary[2] == '*' )
              lev = -1 ;
            else
              lev = atoi( ary[2] ) ;
          }
          if ( ary[3] != NULL ) {
            if ( (fp = fopen( ary[3], "w")) == NULL ) {
              fprintf(stderr,"[%s]ץǤޤ\n",ary[3]) ;
              continue ;
            }
          }
          else fp = stdout ;
          dict = ExistCPC( ary[1] ) ;
          if ( dict == '\0' ) {
            fprintf( stderr, "ERROR:Don't exist CID[%s]\n", ary[1] ) ;
            continue ;
          }
          if ( (ENV_FLAGS & OUT_TOPDN ) != 0) {  /* ȥåץ */
            if ( com != 2 )
              ret1 = AccessEDRCPC( dict, ary[1] ) ;
            ret2 = PrintTOPDNCPC( fp, com, dict, ary[1], lev ) ;
          }
          else if ( (ENV_FLAGS & OUT_TREE ) != 0 ) { /* ɽ⡼:ɽ⡼ɤ */
            ret2 = PrintTREECPC( fp, com, dict, ary[1], lev ) ;
          }
          else if ( (ENV_FLAGS & OUT_HOOKI ) != 0 ) { /* ɽ⡼:ɽ⡼ɤ */
            ret2 = PrintHOKICPC( fp, com, dict, ary[1], lev ) ;
          }
          else {  /* ţģҼ */
            ret2 = PrintEDRCPC( fp, com, dict, ary[1], lev ) ;
          }
          if ( ary[3] != NULL ) 
            fclose( fp ) ;
      }

      WORD_DB_Close() ;
      DB_FileClose() ;

      return ;
}







/*** Ϥ줿ʸʬϤ ***/
int InputCom(char *work, char **ary) 
{
  char *cp ;
  int  ret ;

  cp = skip_non_sp( work ) ;
  if ( cp == NULL)
    return 0 ;
  if ( *cp == '?' ) {
    HelpInput() ;
    return 0 ;
  }
  ary[0] = cp ;
  ary[1] = ary[2] = NULL ;

  if (*cp == 'F' || *cp == 'f' ) {
    cp++ ;
    if ( *cp == 'U' || *cp == 'u' )        /* ؤθ */
      ret = 1 ; 
    else if ( *cp == 'D' || *cp == 'd')    /* ؤθ */
      ret = 2 ; 
    else if ( *cp == ' ' || *cp == '\t' )  /* 岼ξؤθ */
      ret = 3 ;
    else {
      return -1 ;
    }
    cp++ ;
    ary[1] = skip_non_sp( cp ) ;       /* Set pointer for Cid */
    cp = skip_a_word( ary[1] ) ;
    if ( cp == NULL || *cp == '\0') {
      ary[2] = ary[3] = NULL ;
      return ret ;
    }
    *cp = '\0' ;
    cp++ ;
    ary[2] = skip_non_sp( cp ) ;  
    if ( ary[2] == NULL ) {            /* F  Cid */
      ary[3] = NULL ;
      return ret ;
    }
    if ( *ary[2] == '>' ) {            /* F Cid > outfile */
      cp = ary[2] + 1 ;
      ary[3] = skip_non_sp( cp ) ;
      cp = skip_a_word( ary[3] ) ;
      if ( cp != NULL && *cp != '\0') 
        *cp = '\0' ;
      ary[2] = NULL ;
      return ret ;
    }
    cp = skip_a_word( ary[2] ) ;
    if ( cp == NULL || *cp == '\0') {
      ary[3] = NULL ;
      return ret ;
    }
    *cp = '\0' ;
    cp++ ;
    ary[3] = skip_non_sp( cp ) ;
    if ( ary[3] == NULL ) {            /* Set Cid level */
      return ret ;
    }
    if ( *ary[3] == '>' ) {
      cp = ary[3] + 1 ;
      ary[3] = skip_non_sp( cp ) ;
    }
    cp = skip_a_word( ary[3] ) ;
    if ( cp != NULL) {
      *cp = '\0' ;
      cp++ ;
    }
    return ( ret ) ;
  }
  if (*cp == 'P' || *cp == 'p' ) {
    cp++ ;
    if ( *cp == 'M' || *cp == 'm' ) {
      cp++ ;
      SetPrintMode(cp) ;   /* ץȥ⡼ɤ */
      return 0 ;
    }
  }
  ary[1] = cp ;
  return 3 ;
}






int InitEnv()
{
  ENV_FLAGS = 0 ;
  ENV_FLAGS |= ACCE_B | ACCE_T ;   /* ܸѸξ򥢥 */
  ENV_FLAGS |= OUT_TREE ;          /* ɽ⡼:ɽ⡼ɤ */
  //ENV_FLAGS |= OUT_HOOKI ;
  ENV_FLAGS |= OUT_J | OUT_E ;     /* ɽ⡼:ǰηϤɽоݤ */
  //ENV_FLAGS |= OUT_J ;   
  return 1 ;
}



/* ɽ⡼ɤ */
void SetPrintMode( char *cp )
{
  cp = skip_non_sp( cp ) ;

  if ( ( strncmp(cp,"TREE",4) == 0 ||
         strncmp(cp,"tree",4) == 0 ) && *(cp+4) <= ' ') {
    ENV_FLAGS &= ~(OUT_EDR | OUT_HOOKI ) ; 
    ENV_FLAGS |= OUT_TREE ;
    return ;
  }
  if ( ( strncmp(cp,"EDR",3) == 0 ||
         strncmp(cp,"edr",3) == 0 ) && *(cp+3) <= ' ') {
    ENV_FLAGS &= ~(OUT_TREE | OUT_HOOKI) ; 
    ENV_FLAGS |= OUT_EDR ;
    return ;
  }
  if ( ( strncmp(cp,"HOOKI",5) == 0 ||
         strncmp(cp,"hooki",5) == 0 ) && *(cp+5) <= ' ') {
    ENV_FLAGS &= ~(OUT_TREE | OUT_EDR) ; 
    ENV_FLAGS |= OUT_HOOKI ;
    return ;
  }
  if ( ( *cp == 'J' || *cp == 'j' ) && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~( OUT_J | OUT_E ) ; 
    ENV_FLAGS |= OUT_J ;
    return ;
  }
  if ( ( *cp == 'E' || *cp == 'e' ) && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~( OUT_J | OUT_E ) ; 
    ENV_FLAGS |= OUT_E ;
    return ;
  }
  if ( ( strncmp(cp,"JE",2) == 0 ||
         strncmp(cp,"je",2) == 0 ||
         strncmp(cp,"EJ",2) == 0 ||
         strncmp(cp,"ej",2) == 0 ) && *(cp+2) <= ' ') {
    ENV_FLAGS &= ( OUT_J | OUT_E ) ; 
    return ;
  }
  fprintf( stderr,"ERROR(SetPrintMode):Unknown[%s]\n",cp) ;
}




/********************************************************/
void  HelpInput()
{
  fprintf( stderr,"*** COMMANDS **************************************\n") ;
  fprintf( stderr,"FU  ConceptID  [level] [> file] ؤθ\n") ;
  fprintf( stderr,"FD  ConceptID  [level] [> file] ؤθ\n") ;
  fprintf( stderr,"F   ConceptID  [level] [> file] 岼ؤθ\n") ;

  fprintf( stderr,"PM  {TREE}/EDR         ץȥ⡼ɤ\n") ;
  fprintf( stderr,"---------------------------------------------------\n") ;
  fprintf( stderr," Ƽ拾ޥɤϾʸǤɤ\n") ;
  fprintf( stderr," levelϾάġͤϣ\n") ;
  fprintf( stderr,"\n") ;
}







/* 뼭ꤹ */
void SetAccessDict( char *cp )
{
  if ( ( *cp == 'B' || *cp == 'b') && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~ACCE_T ; 
    ENV_FLAGS |= ACCE_B ;
    return ;
  }
  if ( ( *cp == 'T' || *cp == 't') && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~ACCE_B ; 
    ENV_FLAGS |= ACCE_T ;
    return ;
  }
  if ( ( strncmp(cp,"BT",3) == 0 ||
         strncmp(cp,"bt",3) == 0 ||
         strncmp(cp,"TB",3) == 0 ||
         strncmp(cp,"tb",3) == 0   ) && *(cp+3) <= ' ') {
    ENV_FLAGS |= ACCE_B | ACCE_T ;
    return ;
  }
  fprintf( stderr,"ERROR(SetAccessDict):Unknown[%s]\n",cp) ;
}






