#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/


int
main(int argc,  char **argv)
{
  int ret ;
  CFile  *dpt ;
  char *wdenv ;
  char file[512], work[128], outbuff[128] ;
  int len ,ii ;
  int dbflag = 0 ;
  int val ;

      wdenv = (char *)getenv( "CONT_DB" ) ;
      if ( wdenv != NULL ) {
        len = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[len++] = '/' ;
      }
      else {
        len = 0 ;
      }
      strcpy( &file[len], "CONT_DB" ) ;
      ControlDB = Open_IXT( file, 's' ) ;
      if ( ControlDB != NULL ) {
        fprintf( stderr,"μ١ģ¡CONT_DBˤ¸ߤޤ\n") ;
        fprintf( stderr,"ΤǤСμ١ģ¡CONT_DBˤƤ\n") ;
        return 1 ;
      }
      dpt = Create_IXT( file, 's', 10 , -1, 32) ;

      /*  롼ףɣĽ */
      ret = SetFANDV(dpt, "GROUP_ID", 700000 ) ;
      
      /*  ñ쥳ɣɣĽ */
      ret = SetFANDV(dpt, "WORD_RID", 700000 ) ;

      /*  ǰФ 쥳ɣɣĽ */
      ret = SetFANDV(dpt, "CPH_RID", 700000 ) ;

      /*  ǰηϡ 쥳ɣɣĽ */
      ret = SetFANDV(dpt, "CPC_RID", 700000 ) ;

      /*  ǰҡ 쥳ɣɣĽ */
      ret = SetFANDV(dpt, "CPT_RID", 700000 ) ;

      /*  ǰɣĽ */
      ii = HextoBin( "700000" ) ;
      ret = SetFANDV(dpt, "CP_B_F_ID", ii ) ;
      ii = HextoBin( "77ffff" ) ;
      ret = SetFANDV(dpt, "CP_B_T_ID", ii ) ;
      ii = HextoBin( "780000" ) ;
      ret = SetFANDV(dpt, "CP_T_F_ID", ii ) ;
      ii = HextoBin( "7fffff" ) ;
      ret = SetFANDV(dpt, "CP_T_T_ID", ii ) ;



      /* Ƴǧ 
      ret = Get_IXT( dpt, "GROUP_ID", strlen( "GROUP_ID" ) , work, 128 ) ;
      printf( "GROUP_ID : DB[%d]\n",*(int *)work) ;
      ret = Get_IXT( dpt, "WORD_RID", strlen( "WORD_RID" ) , work, 128 ) ;
      printf( "WORD_RID : DB[%d]\n",*(int *)work) ;
      ret = Get_IXT( dpt, "CPH_RID", strlen( "CPH_RID" ) , work, 128 ) ;
      printf( "CPH_RID :  DB[%d]\n",*(int *)work) ;
      ret = Get_IXT( dpt, "CPC_RID", strlen( "CPC_RID" ) , work, 128 ) ;
      printf( "CPC_RID :  DB[%d]\n",*(int *)work) ;
      ret = Get_IXT( dpt, "CPT_RID", strlen( "CPT_RID" ) , work, 128 ) ;
      printf( "CPT_RID :  DB[%d]\n",*(int *)work) ;

      ret = Get_IXT( dpt, "CP_B_F_ID", strlen( "CP_B_F_ID" ) , work, 128 ) ;
      ret = BintoHex( 4, work, outbuff) ;
      printf( "CID_START : DB[%s]\n",outbuff) ;
      ret = Get_IXT( dpt, "CP_B_T_ID", strlen( "CP_B_T_ID" ) , work, 128 ) ;
      ret = BintoHex( 4, work, outbuff) ;
      printf( "CID_END   : DB[%s]\n",outbuff) ;
      ret = Get_IXT( dpt, "CP_T_F_ID", strlen( "CP_T_F_ID" ) , work, 128 ) ;
      ret = BintoHex( 4, work, outbuff) ;
      printf( "CID_START : DB[%s]\n",outbuff) ;
      ret = Get_IXT( dpt, "CP_T_T_ID", strlen( "CP_T_T_ID" ) , work, 128 ) ;
      ret = BintoHex( 4, work, outbuff) ;
      printf( "CID_END   : DB[%s]\n",outbuff) ;
      */

      Close_IXT( dpt ) ;

      fprintf( stderr,"μ١ģ¡%sˤޤ\n", file) ;
      
      return 0 ;
}


int SetFANDV( CFile *dpt, char *key, int  val) 
{
  int ret ;

   ret = Put_IXT(dpt, key, strlen(key), (char *)&val, sizeof(int) ) ;

   return ret ;

}



