/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include <fcntl.h>
#include <malloc.h>

#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "sconst.h"
#include "edrcorp.h"


extern FILE *Hfp ;
extern FILE *Cfp ;

unsigned char GetCorpusREL( char *rel ) ;
unsigned char GetJCorpPoSID( unsigned char *jval ) ;
void syntacpp(FILE *fp, int flag, char *in) ;
int exist_char( char kokka, char *start, char *stop) ;

extern char DATA0[] ;  // 80000
extern int  DATA0CT ;
extern char DATA1[] ;  // 32768
extern int  DATA1CT ;
extern char DATA2[] ;  // 32768
extern int  DATA2CT ;


/****************************************************************
    ţģҷܸ쥳ѥ˴ؤؿ
****************************************************************/

/****************************************************************
*   Ǽ쥳ɺ
*   USAGE:		PutJCorpRec( CFile *jcfp, char *indata)
*   SYNOPSIS:		CFile *jcfp    (IN)   쥳ɳǼܥƥե
*        		char  *indata  (IN)   ܸñʣţģҼ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥ򡢴ܥƥե˳Ǽ롣
*       ʲƥեɤˤǼǤ롣
*
*       ʸ              °̾{ bu }
*           | ƥֹ\0 | ŵ\0 | ʸ\0 |
*           |  (n)           | (n)        | (n)  |
*
*       ʸ      °̾{ wd }
*           | ǿ |   |
*           |  (2)       |           |
*         :
*           | ֹ | ʻ | ɽ\tɽ\tǰ\0 |
*           |  (2)         | (1)  | (n)                        |
*         ֹ
*             0<n : nΤޤ޹ֹȤƻѤǤ롣
*             0>n : ʣ粽ʸ򼨤(-1)*nͤI#nȤʤˡ
*
*       ʸ            °̾{ st }
*           | ʸ |
*           |  (n)   |
*
*       ̣            °̾{ im }
*           | ̣ե졼 |
*           |  (n)         |
*
*   RETURN:		˽λС쥳ֹ
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PutJCorpRec( CFile *jcfp, char *str)
{
  char buff2[16386] ;
  char dict[8], rnum[12] ;
  int  tb, Rid = -1 ;
  char  *bptr[1024] ;
  unsigned char jcat ;
  short ct , wid ;
  char *st ;
  int   ret, len, sz, ii ;
  CData cur ;

  //printf("PutJCorpRec:IN>[%s](%d)\n",str,strlen(str)) ;
  if ( strncmp( str, "JCO", 3) != 0 ) 
    return ( -1 ) ;

  tb = split1( '\t', str, bptr ) ;
  Rid = GetCode2Wid( bptr[0], dict, rnum) ;
  /*if ( dict[0] == '\0' && rnum[0] == '\0' ) {   ADDѤֹ椬ʤƤOKȤ */
  /*  return ( -1 ) ;                                                           */
  //printf("dict=[%s],rnum=[%s],  Rid=[%d]\n",dict,rnum,Rid);

  /* ʸ */
  len = strlen(bptr[1]) + strlen(bptr[2]) + strlen(bptr[3]) +3 ;
  *(bptr[1]+len) = '\0' ;
  PutJCorpProp( jcfp, Rid, "bu", bptr[1], len, "", 0 ) ; /* ƥֹ\0ŵ\0ʸ γǼ */

  /* Ǿ */
  st = &buff2[2] ;
  sz = 2 ;
  ii = 5 ;        /* '{' 򥹥åפ롣 */
  for( ct = 0  ; strcmp(bptr[ii],"}") != 0 ; ct++ ) {
    if ( *bptr[ii] == 'I' )
      wid = (-1) * atoi( bptr[ii] + 2 ) ;
    else 
      wid = atoi( bptr[ii] ) ;
    jcat = GetJCorpPoSID( bptr[ii+3] ) ;
    if ( jcat == 255 ) {
      fprintf(stderr,"ERROR(PutJCorpRec): ʻ[%s]ϡͤǤ\n",bptr[ii+3] ) ;
      return ( -1 ) ;
    }

    if ( jcat != 9  /**/ &&
         jcat != 10 /**/ &&
         jcat != 11 /*ư*/ &&
         jcat != 13 /**/ &&
         jcat != 14 /**/ &&
         jcat != 7  /*Ƭ*/ &&
         jcat != 8  /**/ ) {
      /*** ɽǥå ***/
      //ret = HdwdIndex( bptr[ii+1], Rid) ;
      fprintf( Hfp,"%s\t%s\t%d\n", bptr[ii+1], bptr[ii+3], Rid ) ;
      /*** ǰɣĥǥå ***/
      //ret = CIDIndex( bptr[ii+4], Rid) ;
      if ( ChkHex(bptr[ii+4]) > 0 )
        fprintf( Cfp,"%s\t%d\n", bptr[ii+4], Rid ) ;
    }
  
    len = 2 + strlen( bptr[ii+1] ) + strlen( bptr[ii+2] ) 
           + 1 + strlen( bptr[ii+4] ) + 3 ;
    if ( (sz + len ) >= 16386 ) {
      fprintf(stderr,"ERROR(PutJCorpRec): Work buffer is too small!\n") ;
      return ( -1 ) ;
    }
    put2byte( wid, st) ; /* ֹ楻å */
    *(st+2) = jcat ;     /* ʻ쥻å */
    sprintf( st+3, "%s\t%s\t%s",bptr[ii+1],bptr[ii+2],bptr[ii+4]) ;
    st += len  ;
    sz += len  ;
    ii += 5 ;
    //printf ("  next=%d ct=%d\n",ii,ct) ;
  }
  put2byte( ct, buff2) ; /* ֹ楻å */
  PutJCorpProp( jcfp, Rid, "wd", buff2, sz, "", 0 ) ; /* ֹ ɽ  ɽ  ʻ  ǰ γǼ */
  ii++ ;

  /* Ǿ */
  len = IgouseiStr( buff2, bptr[ii] ) ;
  if ( len != 0 ) {
    PutJCorpProp( jcfp, Rid, "gg", buff2, strlen(buff2) + 1, "", 0) ;
  }
  ii++ ; 

  /* ʸ */
  len = SSex2BinSSex(bptr[ii]) ;
  PutJCorpProp( jcfp, Rid, "st", bptr[ii], len, "", 0) ; /* ʸ γǼ */
  ii++ ;

  /* ̣ */
  //printf("Sem=[%s]\n",bptr[ii]) ;
  PutJCorpProp( jcfp, Rid, "im", bptr[ii], strlen(bptr[ii]) + 1, "", 0) ; /* ̣ե졼 γǼ */
  ii++ ;

  /*  */
  strcpy( buff2, bptr[ii] ) ;
  strcat( buff2, ";FORM=EDR" ) ;
  PutJCorpRETC( jcfp, Rid, buff2 ) ; /* γǼ */
  return Rid ;
}




int IgouseiStr( char *out, char *keitai)
{
  int  ii ;
  char *cp = keitai ;

  *out = '\0' ;
  for ( ii = 1 ; *cp != '\0' ; ii++ ) {
    if ( *(cp +1) == '\0' )  /* Iʤ */
      return 0 ;
    if ( strncmp( cp +1, "{I#" , 3 ) == 0 ) {
      strcpy(out, cp+1) ;
      return ( strlen(out)  ) ;
    }
    if ( ii != atoi( cp +1 ) ) {
      fprintf( stderr,"ERROR(IgouseiStr): format error(number)!\n") ;
      fprintf( stderr,"ERROR(IgouseiStr): data=[%s]\n",keitai) ;
      strcpy(out, keitai ) ;
      return ( strlen(out) ) ;
    }
    for( cp++ ; *cp != '\0'; cp++) {
      if ( *cp == '/' )
        break ;
    }
    if ( *cp == '\0' ) {
      fprintf( stderr,"ERROR(IgouseiStr): format error!\n") ;
      fprintf( stderr,"ERROR(IgouseiStr): data=[%s]\n",keitai) ;
      strcpy(out, keitai ) ;
      return ( strlen(out) ) ;
    }
  }
  fprintf( stderr,"ERROR(IgouseiStr): format error!\n") ;
  fprintf( stderr,"ERROR(IgouseiStr): data=[%s]\n",keitai) ;
  strcpy(out, keitai ) ;
  return ( strlen(out) ) ;
}





int PutJCorpProp( CFile *fp, int recid, char *prop, char *data, int  dsz, char *etcda, int etcsz) 
{
  int   ret ;
  CData cur ;

  cur.textno = recid ;
  cur.data = data ;
  cur.datasize = dsz ;
  cur.databfsz = 0 ;
  cur.subF = etcda ;
  cur.subFbfsz = etcsz ;
  cur.subR = NULL ;
  cur.subRbfsz = 0 ;
  cur.field = prop ;
  ret = PutData_BSYSFile( fp, &cur ) ;
  return ret ;
}



int PutJCorpRETC( CFile *fp, int recid, char *data)
{
  int   ret ;
  CData cur ;

  cur.textno = recid ;
  cur.data = NULL ;
  cur.datasize = 0 ;
  cur.subF = NULL ;
  cur.subFbfsz = 0 ;
  cur.subR = data ;
  cur.subRbfsz = 0 ;
  cur.field = NULL ;
  ret = PutData_BSYSFile( fp, &cur ) ;
  return ret ;
}








/****************************************************************
*   ʻͤɣĲ롣
*   USAGE:		GetJCorpPoSID( char *jval )
*   SYNOPSIS:		char  *jval   (IN)   ʻ°
*
*   DESCRIPTION:	
*	Ϳ줿ܸͤ쥳ѥʻ°ơ֥ˤС
*       ɣĤ֤
*       ޤͤʻ°ơ֥ϿƤʤС255֤
*
*   RETURN:		0ʾ255̤: ｪλ
*                       255         : ͤʻǤϤʤ
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
unsigned char GetJCorpPoSID( unsigned char *jval )
{
  unsigned char  ii ;
  unsigned char ch3 = *(jval+2) ;

  for( ii = 0 ; J_CORPOS[ii].type1 != NULL && ii < 255 ; ii++) {
    if (ch3 == *(J_CORPOS[ii].type1+2) 
         && strcmp( jval, J_CORPOS[ii].type1) == 0 ) {
      return ii ;
    }
  }
  return 255 ;
}







/*** ɽǥå ***/
int  HdwdIndex( char *key, int Rid)
{
  char work[1024], work0[1024] ;
  int  ret ;

  ret = EDR_StrStrip(work, key) ;
  ret = Conv2Big(work0, work) ;
  if ( ret < 0 ) {
    printf("ERROR(HdwdIndex):HDWD:Conv2Big:IN>[%s](%d)\n",key,strlen(key)) ;
  }
  //printf("INDEX_HDWD:key[%s]=>val[%d]\n",work0,Rid) ;
  ret = Add_IXT_DATA2( HDWD2JCORPRecID, work0, strlen( work0 ), (char *)&Rid, 4) ;
  return ret ;
}





/*** ǰɣĥǥå ***/
int  CIDIndex( char *key, int Rid)
{
  char work[1024], work0[1024] ;
  char *cp ;
  int  ret ;

  for ( cp = key ; *cp != '\0' ; cp++) {
    if ( (*cp >= '0' && *cp <= '9' ) ||  ( *cp >= 'a' && *cp <= 'f') )
      continue ;
    return 0 ;
  }
  //printf("INDEX_CP:key[%s]=>val[%d]\n",key,Rid) ;
  ret = Add_IXT_DATA2( CHID2JCORPRecID, key, strlen(key), (char *)&Rid, 4) ;
  return ret ;
}


/*** ʸڤΰ */
int  SSex2BinSSex(char *sdata)
{
  char *cp, *op ;
  int qflag ;
  cp = op = sdata ;

  qflag = 1 ;
  while( *cp != '\0' ) {
    if ( qflag < 0 ) {
      if ( *cp == '"' ) {
        qflag *= (-1) ;
      }
      *op = *cp ; op++ ; cp++ ;
      continue ;
    }
    if ( *cp == '"' ) {
      qflag *= (-1) ;
      *op = *cp ; op++ ; cp++ ;
      continue ;
    }
    if ( (*cp & 0x80) != 0 || (*(cp + 1) & 0x80) != 0  ) {
      fprintf(stderr,"ERROR(SSex2BinSSex):[%s]\n",sdata) ;
      return 0 ;
    }
    if ( *cp == '(' ) {
      cp++ ;
      *op = 0x80 | *cp ; op++, cp++ ;
    }
    else {
      *op = *cp ; op++ ; cp++ ;
    }
  }
  *op = '\0' ; op++ ;
  return ( op - sdata ) ;
}



/*** ʸڤβ */
int  BinSSex2SSex(char *idata, char *odata)
{
  char *cp, *op ;
  int qflag ;

  cp = idata ;
  op = odata ;
  qflag = 1 ;
  while( *cp != '\0' ) {
    if ( qflag < 0 ) {
      if ( *cp == '"' ) {
        qflag *= (-1) ;
      }
      *op = *cp ; op++ ; cp++ ;
      continue ;
    }
    if ( *cp == '"' ) {
      qflag *= (-1) ;
      *op = *cp ; op++ ; cp++ ;
      continue ;
    }
    if ( (*cp & 0x80) != 0 ) {
      *op = '(' ; op++ ;
      *op = 0x7F & *cp ; op++, cp++ ;
      continue ;
    }
    *op = *cp ; op++ ; cp++ ;
  }
  *op = '\0' ; op++ ;
  return ( op - odata ) ;
}




/*** ̣ΰ */
int  Sem2BinSem(char *sdata)
{
  char *cp, *op, *sp ;
  char work[256] ;
  int  ii ;

  cp = op = sdata ;
  while( *cp != '\0' ) {
    if ( *cp == '[' ) {
      if ( *(cp+1) != '[' ) {
        *op = *cp ; op++ ; cp++ ;
        for( sp = cp, ii = 0 ; *sp != '\0' && ii < 256 ; sp++ ) {
          if ( *sp == ' ' || *sp == '[' || *sp == ']' )
            break ;
          work[ii++] = *sp ;
        }
        if ( *sp == '\0' )
          return -1 ;
        ii = GetCorpusREL(work) ;
        if ( ii == 255 ) {
          continue ;
        }
        *op = 0x80 | ii ;
        cp = sp ;
      }
      *op = *cp ; op++ ; cp++ ;
    }
    else {
      *op = *cp ; op++ ; cp++ ;
    }
  }
  *op = '\0' ; op++ ;
  return ( op - sdata ) ;
}



/*** ʸڤβ */
int  BinSem2Sem(char *idata, char *odata)
{
  char *cp, *op ;
  char *bp ;
  int qflag ;

  cp = idata ;
  op = odata ;
  qflag = 1 ;
  while( *cp != '\0' ) {
    if ( qflag < 0 ) {
      if ( *cp == '"' ) {
        qflag *= (-1) ;
      }
      *bp = *op = *cp ; op++ ; cp++ ;
      continue ;
    }
    if ( *cp == '"' ) {
      qflag *= (-1) ;
      *bp = *op = *cp ; op++ ; cp++ ;
      continue ;
    }
    if ( (*cp & 0x80) != 0 ) {
      if ( *bp == '[' ) {
        strcpy( op, J_COOCREL[ ( *cp & 0x7f ) ].type1) ;
        op += strlen( op ) ;
        *bp = *cp ;
        cp++ ;
        continue ;
      }
    }
    *bp = *op = *cp ; op++ ; cp++ ;
  }
  *op = '\0' ; op++ ;
  return ( op - odata ) ;
}



/****************************************************************
*   ̣δطҤɣĲ롣
*   USAGE:		GetCorpusREL( char *rel )
*   SYNOPSIS:		char  *rel   (IN)   ط
*
*   DESCRIPTION:	
*	Ϳ줿طҤطҥơ֥ˤСΣɣĤ֤
*       ޤͤطҥơ֥ϿƤʤС255֤
*
*   RETURN:		0ʾ255̤: ｪλ
*                       255         : ͤϳѾǤϤʤ
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
unsigned char GetCorpusREL( char *rel )
{
  unsigned char  ii ;

  for( ii = 0 ; J_COOCREL[ii].type1 != NULL && ii < 255 ; ii++) {
    if ( *rel == *(J_COOCREL[ii].type1) 
         && strcmp( rel, J_COOCREL[ii].type1) == 0 ) {
      return ii ;
    }
  }
  return 255 ;
}




/****************************************************************
*   쥳ɽʸʸ
*   USAGE:		PrnEDRJCorpRecTe( FILE *fp, CFile *jcfp, int Rid, int flag )
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*                       int    flag    (IN)   ϥǡե饰
*                                             0x01 : ƥֹ
*                                             0x02 : ŵ
*                                             0x04 : ʸ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥ򡢴ܥƥե˳Ǽ롣
*       ʲƥեɤˤǼǤ롣
*
*       ʸ              °̾{ bu }
*           | ƥֹ\0 | ŵ\0 | ʸ\0 |
*           |  (n)           | (n)        | (n)  |
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnEDRJCorpRecTe( FILE *fp, CFile *jcfp, int Rid, int flag)
{
  char *st ;
  int   outf = 0 ,ret ;
  CData cur ;
  char  fname[64] ;

  if ( jcfp == NULL)
    return ( -1 ) ;

  /* ʸ : ƥֹ\0ŵ\0ʸ  */
  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "bu" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 ) {
    return 0 ;
  }
  if ( cur.datasize > 0 ) {
    st = DATA0 + strlen( DATA0 ) + 1 ;
    st += strlen( st ) + 1 ;
    fprintf(fp," %s\n",st) ;
  }
  return 1 ;
}





/****************************************************************
*   쥳ɽʸ
*   USAGE:		PrnEDRJCorpRecBu( FILE *fp, CFile *jcfp, int Rid, int flag )
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*                       int    flag    (IN)   ϥǡե饰
*                                             0x01 : ƥֹ
*                                             0x02 : ŵ
*                                             0x04 : ʸ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥʸɽ롣
*       ʲƥեɤˤǼǤ롣
*
*       ʸ              °̾{ bu }
*           | ƥֹ\0 | ŵ\0 | ʸ\0 |
*           |  (n)           | (n)        | (n)  |
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnEDRJCorpRecBu( FILE *fp, CFile *jcfp, int Rid, int flag )
{
  char *st ;
  int   outf = 0 ,ret ;
  CData cur ;
  char  fname[64] ;

  //printf("PrnEDRJCorpRecBu:IN>flag[%x]\n",flag) ;
  if ( jcfp == NULL)
    return ( -1 ) ;

  /* ʸ : ƥֹ\0ŵ\0ʸ  */
  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "bu" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 ) {
    //fprintf(fp,"%%%%%%쥳ֹ%%%%%%\n") ;
    //fprintf(fp,"%%%%%%ƥֹ%%%%%%\n") ;
    //fprintf(fp,"%%%%%%ŵ%%%%%%\n") ;
    //fprintf(fp,"%%%%%%ʸ%%%%%%\n") ;
    return 0 ;
  }
  if ( cur.datasize <= 0 ) {
    fprintf(fp,"%%%%%%쥳ֹ%%%%%%\n") ;
    fprintf(fp,"%%%%%%ƥֹ%%%%%%\n") ;
    fprintf(fp,"%%%%%%ŵ%%%%%%\n") ;
    fprintf(fp,"%%%%%%ʸ%%%%%%\n") ;
  }
  else {
    fprintf(fp,"%%%%%%쥳ֹ%%%%%%\n") ;
    fprintf(fp," JCO%07d\n",Rid) ;
    fprintf(fp,"%%%%%%ƥֹ%%%%%%\n") ;
    fprintf(fp," %s\n",DATA0) ;
    st = DATA0 + strlen( DATA0 ) + 1 ;
    fprintf(fp,"%%%%%%ŵ%%%%%%\n") ;
    fprintf(fp," %s\n",st) ;
    st += strlen( st ) + 1 ;
    fprintf(fp,"%%%%%%ʸ%%%%%%\n") ;
    fprintf(fp," %s\n",st) ;
  }
  if ( cur.subFsize > 0 ) {
    fprintf(fp,"#\n") ;
    DATA1[cur.subFsize] = '\0' ;
    fprintf(fp," %s\n",DATA1) ;
  }
  /***
  if ( cur.subRsize > 0 ) {
    if ( outf == 0 ) {
      fprintf(fp,"#\n") ;
      outf = 1 ;
    }
    fprintf(fp,"\t%s\n",DATA2) ;
  }
  ***/
  return 1 ;
}












/****************************************************************
*   쥳ɽʹǾ
*   USAGE:		PrnEDRJCorpRecWd( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥιǾɽ롣
*       ʲƥեɤˤǼǤ롣
*
*       ʸ      °̾{ wd }
*           | ǿ |   |
*           |  (2)       |           |
*         :
*           | ֹ | ʻ | ɽ\tɽ\tǰ\0 |
*           |  (2)         | (1)  | (n)                        |
*         ֹ
*             0<n : nΤޤ޹ֹȤƻѤǤ롣
*             0>n : ʣ粽ʸ򼨤(-1)*nͤI#nȤʤˡ
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnEDRJCorpRecWd( FILE *fp, CFile *jcfp, int Rid)
{
  char *st, *stn ;
  int   wct, cat ;
  short wid ;
  int   outf = 0 ,ret, ii ;
  int   ct = 0 ;
  char  *bptr[1024] ;
  char  wordlist[2048] ;
  CData cur ;
  char  fname[64] ;
  int   ict = 0 ;

  if ( jcfp == NULL)
    return ( -1 ) ;

  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "wd" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 ) {
    fprintf(fp,"%%%%%%Ǿ%%%%%%\n") ;
    fprintf(fp,"%%%%%%Ǿ%%%%%%\n") ;
    return 0 ;
  }
  if ( cur.datasize <= 0 ) {
    fprintf(fp,"%%%%%%Ǿ%%%%%%\n") ;
  }
  else {
    fprintf(fp,"%%%%%%Ǿ%%%%%%\n") ;
    /* Ǿ */
    wct = get2byte( DATA0 ) ; /* ǿ */
    if ( wct != 0 ) {
      st = DATA0+2 ;
      for( ii = 0 ; ii < wct ; ii++ ) {
        wid = get2byte( st ) ; /* ֹ */
        cat = *(st +2) ;       /* ʻID */
        stn = st + strlen( st + 3 ) +4 ;
        ret = split1( '\t', st+3, bptr ) ;
        if ( wid < 0 ) {
          wid *= (-1) ;
          fprintf( fp, " I#%d\t%s\t%s\t%s\t%s\n",wid,bptr[0],bptr[1],J_CORPOS[cat].type1,bptr[2]) ;
          ict++ ;
        }
        else {
          fprintf( fp, " %d\t%s\t%s\t%s\t%s\n",wid,bptr[0],bptr[1],J_CORPOS[cat].type1,bptr[2]) ;
          sprintf( &wordlist[ct],"/%d:%s",wid, bptr[0] ) ;
          ct += strlen( &wordlist[ct] ) ;
        }
        st = stn ;
      }
    }
  }
  if ( cur.subFsize > 0 ) {
    fprintf(fp,"#\n") ;
    outf = 1 ;
    DATA1[cur.subFsize] = '\0' ;
    fprintf(fp," %s\n",DATA1) ;
  }
  if ( ct != 0 ) {
    wordlist[ct++] = '/' ;
    wordlist[ct++] = '\0' ;
  }
  fprintf(fp,"%%%%%%Ǿ%%%%%%\n") ;
  fprintf(fp, " %s\n",wordlist) ;
  if ( ict != 0 )
    PrnEDRJCorpRecGg( fp, JCORPRecId2Val, Rid ) ;
  return wct ;
}



/****************************************************************
*   쥳ɽʷǾ
*   USAGE:		PrnEDRJCorpRecGg( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥιʸɽ롣
*       ʲƥեɤˤǼǤ롣
*
*
*       Ǿ            °̾{ gg }
*           | Ǿ |
*           |  (n)       |
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnEDRJCorpRecGg( FILE *fp, CFile *jcfp, int Rid)
{
  char *st ;
  int   wct, cat ;
  int   outf = 0 ,ret, ii ;
  CData cur ;
  char  fname[64] ;
  

  if ( jcfp == NULL)
    return ( -1 ) ;

  /* Ǿ */
  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "gg" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( cur.datasize > 0 ) {
    DATA0[cur.datasize] = '\0' ;
    fprintf(fp," %s\n",DATA0) ;
  }
  if ( cur.subFsize > 0 ) {
    fprintf(fp,"#\n") ;
    outf = 1 ;
    DATA1[cur.subFsize] = '\0' ;
    fprintf(fp," %s\n",DATA1) ;
  }
  return 1 ;
}






/****************************************************************
*   쥳ɽʹʸ
*   USAGE:		PrnEDRJCorpRecSt( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥιʸɽ롣
*       ʲƥեɤˤǼǤ롣
*
*
*       ʸ            °̾{ st }
*           | ʸ |
*           |  (n)   |
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnEDRJCorpRecSt( FILE *fp, CFile *jcfp, int Rid)
{
  char *st ;
  int   wct, cat ;
  int   outf = 0 ,ret, ii ;
  char  *cp ;
  CData cur ;
  char  fname[64] ;
  

  if ( jcfp == NULL)
    return ( -1 ) ;

  /* ʸ(ʸ) */
  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "st" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( cur.datasize <= 0 ) {
    fprintf(fp,"%%%%%%ʸ%%%%%%\n") ;
  }
  else {
    fprintf(fp,"%%%%%%ʸ%%%%%%\n") ;
    DATA0[cur.datasize] = '\0' ;
    cp = malloc( (cur.datasize * 2 )) ;
    if ( cp == NULL ) {
      fprintf(stderr,"ERROR(PrnEDRJCorpRecSt):malloc....\n") ;
      return -1 ;
    }
    BinSSex2SSex(DATA0, cp ) ;
    syntacpp( fp, SYN, cp) ;
    free( cp ) ;
  }

  if ( cur.subFsize > 0 ) {
    fprintf(fp,"#\n") ;
    outf = 1 ;
    DATA1[cur.subFsize] = '\0' ;
    fprintf(fp," %s\n",DATA1) ;
  }
  /***
  if ( cur.subRsize > 0 ) {
    if ( outf == 0 ) {
      fprintf(fp,"#\n") ;
      outf = 1 ;
    }
    fprintf(fp,"\t%s\n",DATA2) ;
  }
  ***/
  return 1 ;
}




/****************************************************************
*   쥳ɽʰ̣
*   USAGE:		PrnEDRJCorpRecSt( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥΰ̣ɽ롣
*       ʲƥեɤˤǼǤ롣
*
*
*       ̣            °̾{ im }
*           | ̣ե졼 |
*           |  (n)         |
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnEDRJCorpRecIm( FILE *fp, CFile *jcfp, int Rid)
{
  char *st ;
  int   wct, cat ;
  int   outf = 0 ,ret, ii ;
  CData cur ;
  char  fname[64] ;
  

  if ( jcfp == NULL)
    return ( -1 ) ;

  /* ̣(̣ե졼) */
  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "im" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( cur.datasize <= 0 ) {
    fprintf(fp,"%%%%%%̣%%%%%%\n") ;
  }
  else {
    fprintf(fp,"%%%%%%̣%%%%%%\n") ;
    DATA0[cur.datasize] = '\0' ;
    syntacpp( fp, SEM, DATA0) ;
  }

  if ( cur.subFsize > 0 ) {
    fprintf(fp,"#\n") ;
    outf = 1 ;
    DATA1[cur.subFsize] = '\0' ;
    fprintf(fp," %s\n",DATA1) ;
  }
  return 1 ;
}


/****************************************************************
*   쥳ɽʥ쥳ɴ
*   USAGE:		PrnEDRJCorpRecRE( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥΥ쥳ɴɽ롣
*       ʲƥեɤˤǼǤ롣
*
*
*       ̣            °̾{ im }
*           | ̣ե졼 |
*           |  (n)         |
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnEDRJCorpRecRE( FILE *fp, CFile *jcfp, int Rid)
{
  char *st ;
  int   ret ;
  CData cur ;
  char  fname[64] ;

  //printf("PrnEDRJCorpRecBu:IN>flag[%x]\n",flag) ;
  if ( jcfp == NULL)
    return ( -1 ) ;

  /* ʸ : ƥֹ\0ŵ\0ʸ  */
  cur.textno = Rid ;  /*  ʸֹ                           */
  cur.field = NULL ;
  cur.data = NULL ;
  cur.subF = NULL ;
  cur.subR = DATA2 ;
  cur.databfsz = 0 ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = 0 ;
  ret = GetData_BSYSFile( jcfp, RETC , &cur ) ;
  if ( ret == 0 ) {
    return -1 ;
  }
  if ( cur.datasize <= 0 ) {
    fprintf(fp,"%%%%%%%%%%%%\n") ;
  }
  else {
    fprintf(fp,"%%%%%%%%%%%%\n") ;
    fprintf(fp," %s\n",DATA2) ;
  }
  return 1 ;
}





/* ʸ(Ӽץƥץ) */
void syntacpp(FILE *fp, int flag, char *in)
{
    int ct, lev, kokka, ret ;
    int nct, ss ;
    char *node[4096] ;
    int   cul[4096] ;
    char  work[1024] ;

    if ( flag == SYN ) 
        nct = split_syn_sex(in, node) ;
    else if ( flag == SEM ) 
        nct = split_sem_sex(in, node) ; 

    lev = 0 ;
    cul[lev] = 0 ;
    for (ct = 0 ; ct < nct ; ) {
        //printf("ct=%d(nct=%d)  lev=%d cul[lev]=%d\n",ct,nct,lev,cul[lev]) ;
        if ( flag == SYN ) {
          kokka = exist_char(')', node[ct], node[ct+1]) ;
        }
        if ( flag == SEM ) {
          kokka = exist_char(']', node[ct], node[ct+1])  ;
        }
        if ( kokka > 0 ) {
            kokka-- ;
            ret = copy_word( work, 1024 , node[ct], node[ct+1] ) ;
            fprintf (fp, " %s\n", work) ;
            lev -= kokka ;
            // print ("kokka=$kokka  lev=$lev\n");
            for (ss = 0 ; ss < cul[lev] ; ss++) {
              fprintf (fp, " ") ;
            }
            ct++ ;
            continue ;
        }
        ret = copy_word( work, 1024 , node[ct], node[ct+1] ) ;
        fprintf (fp, " %s", work) ;
        cul[lev+1] = cul[lev] + strlen( work )+1 ;
        //printf ("               lev=%d  len=%d\n",$lev,length($node[$ct]));
        lev++ ;
        ct++ ;
    }
    // fprintf (fp, "\n") ;
}






int split_syn_sex( char *in , char **cptr )
{
  int  wkc ;
  char *st, *st1 ;

  st = in ;
  wkc = 0 ;
  while( st != NULL ) {
    cptr[wkc] = skip_ptr( '(', st ) ;
    if ( cptr[wkc] == NULL )
      break ;
    if ( *(cptr[wkc]+1) == 'S' || 
         *(cptr[wkc]+1) == 't' ||
         *(cptr[wkc]+1) == 'M' ||
         *(cptr[wkc]+1) == 'W' ||
         *(cptr[wkc]+1) == 'N' ||
         *(cptr[wkc]+1) == 'I' ) {
      st = cptr[wkc] + 1 ;
      wkc++ ;
      continue ;
    }
    st = cptr[wkc] + 1 ;
  }
  cptr[wkc] = NULL ;
  return wkc ;
}




int split_sem_sex( char *in , char **cptr )
{
  int  wkc ;
  char *st, *st1 ;

  st = in ;
  wkc = 0 ;
  while( st != NULL ) {
    cptr[wkc] = skip_ptr( '[', st ) ;
    if ( cptr[wkc] == NULL )
      break ;
    st = cptr[wkc] + 1 ;
    wkc++ ;
  }
  cptr[wkc] = NULL ;
  return wkc ;
}



//#Ĥ̤οؿ
int exist_char( char kokka, char *start, char *stop)
{
  char *st ;
  int ct = 0 ;

  for ( st = start ; st != stop && *st != '\0' ; st++ ) {
    if ( kokka == *st ) {
       ct++ ;
    }
  }
  return ct ;
}







/****************************************************************
*   쥳ɽʸ
*   USAGE:		PrnEDRFJCorpRecBu( FILE *fp, CFile *jcfp, int Rid, int flag )
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*                       int    flag    (IN)   ϥǡե饰
*                                             0x01 : ƥֹ
*                                             0x02 : ŵ
*                                             0x04 : ʸ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥʸEDRɽ롣
*       ʲƥեɤˤǼǤ롣
*
*       ʸ              °̾{ bu }
*           | ƥֹ\0 | ŵ\0 | ʸ\0 |
*           |  (n)           | (n)        | (n)  |
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnEDRFJCorpRecBu( FILE *fp, CFile *jcfp, int Rid, int flag )
{
  char *st ;
  int   ret ;
  CData cur ;
  char  fname[64] ;

  //printf("PrnEDRJCorpRecBu:IN>flag[%x]\n",flag) ;
  if ( jcfp == NULL)
    return ( -1 ) ;

  /* ʸ : ƥֹ\0ŵ\0ʸ  */
  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "bu" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 ) {
    return 0 ;
  }
  if ( cur.datasize <= 0 ) {
    return -1 ;
  }
  else {
    fprintf(fp,"JCO%07d\t%s\t",Rid,DATA0) ;
    st = DATA0 + strlen( DATA0 ) + 1 ;
    fprintf(fp,"%s\t",st) ;
    st += strlen( st ) + 1 ;
    fprintf(fp,"%s\t",st) ;
  }
  return 1 ;
}




/****************************************************************
*   쥳ɽʹǾ
*   USAGE:		PrnEDRFJCorpRecWd( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥιʸɽ롣
*       ʲƥեɤˤǼǤ롣
*
*       ʸ      °̾{ wd }
*           | ǿ |   |
*           |  (2)       |           |
*         :
*           | ֹ | ʻ | ɽ\tɽ\tǰ\0 |
*           |  (2)         | (1)  | (n)                        |
*         ֹ
*             0<n : nΤޤ޹ֹȤƻѤǤ롣
*             0>n : ʣ粽ʸ򼨤(-1)*nͤI#nȤʤˡ
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnEDRFJCorpRecWd( FILE *fp, CFile *jcfp, int Rid)
{
  char  *st, *stn ;
  int   wct, cat, from, to ;
  short wid ;
  int   ret, ii, jj ;
  int   ct = 0 ;
  char  *bptr[1024] ;
  char  wordlist[2048] ;
  CData cur ;
  char  fname[64] ;
  int   ict = 0 ;
  
  if ( jcfp == NULL)
    return ( -1 ) ;

  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "wd" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 ) {
    return -1 ;
  }
  if ( cur.datasize <= 0 ) 
    return -1 ;

  /* Ǿ */
  wct = get2byte( DATA0 ) ; /* ǿ */
  fprintf( fp,"{\t") ;
  if ( wct != 0 ) {
    st = DATA0+2 ;
    for( ii = 0 ; ii < wct ; ii++ ) {
      wid = get2byte( st ) ; /* ֹ */
      cat = *(st +2) ;       /* ʻID */
      stn = st + strlen( st + 3 ) +4 ;
      ret = split1( '\t', st+3, bptr ) ;
      if ( wid < 0 ) {
        wid *= (-1) ;
        fprintf( fp, "I#%d\t%s\t%s\t%s\t%s\t",wid,bptr[0],bptr[1],J_CORPOS[cat].type1,bptr[2]) ;
        ict++ ;
      }
      else {
        fprintf( fp, "%d\t%s\t%s\t%s\t%s\t",wid,bptr[0],bptr[1],J_CORPOS[cat].type1,bptr[2]) ;
        sprintf( &wordlist[ct],"/%d:%s",wid, bptr[0] ) ;
        ct += strlen( &wordlist[ct] ) ;
      }
      st = stn ;
    }
  }
  fprintf( fp,"}\t") ;
  if ( ct != 0 ) {
    wordlist[ct++] = '/' ;
    wordlist[ct++] = '\0' ;
    if ( ict > 0 ) {  /* 㤨ФΤ褦ʽ: {I#1//3:/4://I#2//9:ī/10:Ⱦ//} */
      fprintf( fp, "%s", wordlist ) ;
      ret = PrnEDRFJCorpRecGg( fp, JCORPRecId2Val, Rid ) ;
    }
    else {
      fprintf( fp, "%s\t", wordlist ) ; 
    }
  }
  else {
    fprintf( fp, "\"\"\t" ) ;
  }

  return wct ;
}





/****************************************************************
*   쥳ɽʷǾ
*   USAGE:		PrnEDRFJCorpRecGg( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥηǾɽ롣
*       ʲƥեɤˤǼǤ롣
*
*
*       ʸ            °̾{ gg }
*           | Ǿ |
*           |  (n)       |
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnEDRFJCorpRecGg( FILE *fp, CFile *jcfp, int Rid)
{
  char *st ;
  int   wct, cat ;
  int   ret, ii ;
  char  *bptr[1024] ;
  CData cur ;
  char  fname[64] ;
  

  if ( jcfp == NULL)
    return ( -1 ) ;

  /* ʸ(ʸ) */
  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "gg" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( cur.datasize < 0 ) {
    return -1 ;
  }
  else {
    DATA0[cur.datasize] = '\0' ;
    fprintf(fp,"%s\t",DATA0) ;
  }

  return 1 ;
}







/****************************************************************
*   쥳ɽʹʸھ
*   USAGE:		PrnEDRFJCorpRecSt( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥιʸڤɽ롣
*       ʲƥեɤˤǼǤ롣
*
*
*       ʸ            °̾{ st }
*           | ʸ |
*           |  (n)   |
*
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnEDRFJCorpRecSt( FILE *fp, CFile *jcfp, int Rid)
{
  char *st ;
  int   wct, cat ;
  int   ret, ii ;
  unsigned char  *cp ;
  CData cur ;
  char  fname[64] ;
  

  if ( jcfp == NULL)
    return ( -1 ) ;

  /* ʸ(ʸ) */
  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "st" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( cur.datasize <= 0 ) {
    return -1 ;
  }
  else {
    DATA0[cur.datasize] = '\0' ;
    cp = malloc( (cur.datasize * 2 )) ;
    if ( cp == NULL ) {
      fprintf(stderr,"ERROR(PrnEDRFJCorpRecSt):malloc....\n") ;
      return -1 ;
    }
    BinSSex2SSex(DATA0, cp ) ;
    fprintf(fp,"%s\t",cp) ;
    free( cp ) ;
  }

  return 1 ;
}




/****************************************************************
*   쥳ɽʰ̣
*   USAGE:		PrnEDRFJCorpRecSt( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥ򡢴ܥƥե˳Ǽ롣
*       ʲƥեɤˤǼǤ롣
*
*
*       ̣            °̾{ im }
*           | ̣ե졼 |
*           |  (n)         |
*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnEDRFJCorpRecIm( FILE *fp, CFile *jcfp, int Rid)
{
  char *st ;
  int   wct, cat ;
  int   ret, ii ;
  CData cur ;
  char  fname[64] ;
  

  if ( jcfp == NULL)
    return ( -1 ) ;

  /* ̣(̣ե졼) */
  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "im" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( jcfp, FETC | RETC | FVALUE, &cur ) ;
  if ( cur.datasize <= 0 ) {
    return -1 ;
  }
  else {
    DATA0[cur.datasize] = '\0' ;
    fprintf(fp,"%s\t", DATA0) ;
  }

  return 1 ;
}





/****************************************************************
*   쥳ɽ
*   USAGE:		PrnJCorpRecETC( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥΥ쥳ɤɽ롣

*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnJCorpRecETC( FILE *fp, CFile *jcfp, int Rid)
{
  char *st ;
  int   ret ;
  CData cur ;
  char  fname[64] ;

  //printf("PrnEDRJCorpRecBu:IN>flag[%x]\n",flag) ;
  if ( jcfp == NULL)
    return ( -1 ) ;

  /* ʸ : ƥֹ\0ŵ\0ʸ  */
  cur.textno = Rid ;  /*  ʸֹ                           */
  cur.field = NULL ;
  cur.data = NULL ;
  cur.subF = NULL ;
  cur.subR = DATA2 ;
  cur.databfsz = 0 ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = 0 ;
  ret = GetData_BSYSFile( jcfp, RETC , &cur ) ;
  if ( ret == 0 ) {
    return -1 ;
  }
  if ( cur.datasize <= 0 ) {
    return -1 ;
  }
  else {
    fprintf(fp,"%s\n",DATA2) ;
  }
  return 1 ;
}



/****************************************************************
*   쥳ɽ
*   USAGE:		PrnJCorpRecRELETC( FILE *fp, CFile *jcfp, int Rid)
*   SYNOPSIS:		FILE  *fp      (IN)   եݥ󥿡
*                       CFile *jcfp    (IN)   쥳ɳǼܥƥե
*                       int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ţģҷܸ쥳ѥΥ쥳ɤɽ롣

*
*   RETURN:		˽λС1
*                       쥳ɤ¸ߤʤС 0
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  PrnJCorpRecRELETC( FILE *fp, CFile *jcfp, int Rid)
{
  char *st ;
  int   ret ;
  CData cur ;
  char  fname[64] ;

  //printf("PrnEDRJCorpRecBu:IN>flag[%x]\n",flag) ;
  if ( jcfp == NULL)
    return ( -1 ) ;

  /* ʸ : ƥֹ\0ŵ\0ʸ  */
  cur.textno = Rid ;  /*  ʸֹ                           */
  cur.field = NULL ;
  cur.data = NULL ;
  cur.subF = NULL ;
  cur.subR = DATA2 ;
  cur.databfsz = 0 ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = 0 ;
  ret = GetData_BSYSFile( jcfp, RETC , &cur ) ;
  if ( ret == 0 ) {
    return -1 ;
  }
  if ( cur.datasize <= 0 ) {
    return -1 ;
  }
  else {
    CutPropertyETCRecord( DATA2, "CDATE" ) ;
    CutPropertyETCRecord( DATA2, "FORM" ) ;
    fprintf(fp,"%s\n",DATA2) ;
  }
  return 1 ;
}



int  CreTextInfo( char *buff, int rid, int mode, char *value, int vct ) 
{
  char *st ;
  int   ret ;
  CData cur ;
  char  fname[64] ;
  char  *cp1, *cp2, *cp3 ;

  //printf("PrnEDRJCorpRecBu:IN>flag[%x]\n",flag) ;
  if ( JCORPRecId2Val == NULL)
    return ( -1 ) ;

  /* ʸ : ƥֹ\0ŵ\0ʸ  */
  cur.textno = rid ;  /*  ʸֹ                           */
  strcpy( fname, "bu" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( JCORPRecId2Val, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 || cur.datasize <= 0 ) { /* ǡʤ */
    if ( mode == TEXT_ID )   /* ƥֹ */
      ret = CreDataBu( buff, value, NULL, NULL ) ;
    else if ( mode == FROM_INFO )   /* ŵ */
      ret = CreDataBu( buff, NULL, value, NULL ) ;
    else if ( mode == TEXT_STR )   /* ʸ */
      ret = CreDataBu( buff, NULL, NULL, value ) ;
    else {
      fprintf(stderr,"ERROR(CreTextInfo): mode error!\n") ;
      return -1 ;
    }
    return ret ;
  }
  cp1 = DATA0 ;
  cp2 = cp1 + strlen(cp1) + 1 ;
  cp3 = cp2 + strlen(cp2) + 1 ;
  if ( mode == TEXT_ID )   /* ƥֹ */
    ret = CreDataBu( buff, value, cp2, cp3 ) ;
  else if ( mode == FROM_INFO )   /* ŵ */
    ret = CreDataBu( buff, cp1, value, cp3 ) ;
  else if ( mode == TEXT_STR )   /* ʸ */
    ret = CreDataBu( buff, cp1, cp2, value ) ;
  else {
    fprintf(stderr,"ERROR(CreTextInfo): mode error!\n") ;
    return -1 ;
  }
  return ( ret ) ;
}



int CreDataBu( char *out, char *tno, char *syut, char *genb)
{
  char *st = out ;

  if ( tno == NULL)
    *out = '\0' ;
  else 
    strcpy( out, tno ) ;
  out += strlen( out ) + 1 ;

  if ( syut == NULL)
    *out = '\0' ;
  else
    strcpy( out, syut ) ;
  out += strlen( out ) + 1 ;

  if ( genb == NULL)
    *out = '\0' ;
  else
    strcpy( out, genb ) ;
  out += strlen( out ) + 1 ;
    
  return ( out - st ) ;
}








/****************************************************************
*   ǥåʹǾ
*   USAGE:		ClearIXEDRJCorp(int Rid)
*   SYNOPSIS:		int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ꤵ줿ܸ쥳ѥιǾ򻲾Ȥǥå
*     롣
*
*       ʸ      °̾{ wd }
*           | ǿ |   |
*           |  (2)       |           |
*         :
*           | ֹ | ʻ | ɽ\tɽ\tǰ\0 |
*           |  (2)         | (1)  | (n)                        |
*         ֹ
*             0<n : nΤޤ޹ֹȤƻѤǤ롣
*             0>n : ʣ粽ʸ򼨤(-1)*nͤI#nȤʤˡ
*
*
*   RETURN:	       ˣ
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  ClearIXEDRJCorp( int Rid)
{
  char *st, *stn ;
  int   wct, cat ;
  short wid ;
  int   outf = 0 ,ret, ii ;
  char  *bptr[1024] ;
  CData cur ;
  char  fname[64] ;
  char  val[8] ;

  if ( JCORPRecId2Val == NULL)
    return ( -1 ) ;

  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "wd" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( JCORPRecId2Val, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 ) {
    return 1 ;
  }
  if ( cur.datasize <= 0 ) {
    return 1;
  }
  wct = get2byte( DATA0 ) ; /* ǿ */
  if ( wct != 0 ) {
    put4byte( Rid, &val[1] ) ;
    st = DATA0+2 ;
    for( ii = 0 ; ii < wct ; ii++ ) {
      val[0] = *(st +2) ;       /* ʻID */
      stn = st + strlen( st + 3 ) +4 ;
      ret = split1( '\t', st+3, bptr ) ;
      if ( val[0] != 9  /**/ &&
           val[0] != 10 /**/ &&
           val[0] != 11 /*ư*/ &&
           val[0] != 13 /**/ &&
           val[0] != 14 /**/ &&
           val[0] != 7  /*Ƭ*/ &&
           val[0] != 8  /**/ ) {
        ret = Rem_IXT_DATA( HDWD2JCORPRecID, bptr[0], strlen( bptr[0] ) ,  &val[0], 5)  ;
        if ( ChkHex( bptr[2]) > 0 ) {
          ret = Rem_IXT_DATA( CHID2JCORPRecID, bptr[2], strlen( bptr[2] ) ,  (char *)&Rid, 4)  ;
        }
      }
      st = stn ;
    }
  }
  return 1;
}






/****************************************************************
*   ǥåʹǾ󤫤
*   USAGE:		SetIXEDRJCorp(int Rid)
*   SYNOPSIS:		int    Rid     (IN)   쥳ֹ
*
*   DESCRIPTION:	
*	ꤵ줿ܸ쥳ѥιǾ򻲾Ȥǥå
*     롣
*
*       ʸ      °̾{ wd }
*           | ǿ |   |
*           |  (2)       |           |
*         :
*           | ֹ | ʻ | ɽ\tɽ\tǰ\0 |
*           |  (2)         | (1)  | (n)                        |
*         ֹ
*             0<n : nΤޤ޹ֹȤƻѤǤ롣
*             0>n : ʣ粽ʸ򼨤(-1)*nͤI#nȤʤˡ
*
*
*   RETURN:	       ˣ
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  SetIXEDRJCorp( int Rid)
{
  char *st, *stn ;
  int   wct, cat ;
  short wid ;
  int   outf = 0 ,ret, ii ;
  char  *bptr[1024] ;
  CData cur ;
  char  fname[64] ;
  char  val[8] ;

  if ( JCORPRecId2Val == NULL)
    return ( -1 ) ;

  cur.textno = Rid ;  /*  ʸֹ                           */
  strcpy( fname, "wd" ) ;
  cur.field = fname ;
  cur.data = DATA0 ;
  cur.subF = DATA1 ;
  cur.subR = DATA2 ;
  cur.databfsz = DATA0MAX ;
  cur.subRbfsz = DATA2MAX ;
  cur.subFbfsz = DATA1MAX ;
  ret = GetData_BSYSFile( JCORPRecId2Val, FETC | RETC | FVALUE, &cur ) ;
  if ( ret == 0 ) {
    return 1 ;
  }
  if ( cur.datasize <= 0 ) {
    return 1;
  }
  wct = get2byte( DATA0 ) ; /* ǿ */
  if ( wct != 0 ) {
    put4byte( Rid, &val[1] ) ;
    st = DATA0+2 ;
    for( ii = 0 ; ii < wct ; ii++ ) {
      val[0] = *(st +2) ;       /* ʻID */
      stn = st + strlen( st + 3 ) +4 ;
      if ( val[0] != 9  /**/ &&
           val[0] != 10 /**/ &&
           val[0] != 11 /*ư*/ &&
           val[0] != 13 /**/ &&
           val[0] != 14 /**/ &&
           val[0] != 7  /*Ƭ*/ &&
           val[0] != 8  /**/ ) {
        ret = split1( '\t', st+3, bptr ) ;
        ret = Add_IXT_DATA2( HDWD2JCORPRecID, bptr[0], strlen( bptr[0] ) , &val[0], 5)  ;
        if ( ChkHex( bptr[2]) > 0 )
          ret = Add_IXT_DATA2( CHID2JCORPRecID, bptr[2], strlen( bptr[2] ) ,  (char *)&Rid, 4)  ;
      }
      st = stn ;
    }
  }
  return 1;
}




