#include <stdio.h>
#include <fcntl.h>

#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/


/*** ʸˡģ ƽϴؿ : ʸˡɣ */

int PrGram2ID(FILE *outfp,char *kbuff,int ksz, char *rbuff, int rsz)
{
  int i ;
  i = *(int *)rbuff ;
  fprintf( outfp, "KEY=[%s] VAL=[%d]\n",kbuff,i) ;
  return i  ;
}



/*** ʸˡģ ƽϴؿ : ɣġʸˡ */

int PrID2Gram(FILE *outfp, char *kbuff,int ksz, char *rbuff, int rsz)
{
  int i ;
  i = *(int *)kbuff ;
  fprintf( outfp, "KEY=[%d] VAL=[%s]\n",i,rbuff) ;
  return i  ;
}




/* ǰФ */
int PrRid2EDRCPH(FILE *outfp, char *kbuff,int ksz, char *rbuff, int rsz) 
{
  int i, ct, len ;
  int ret, Gid ;
  unsigned char *cary[64] ;
  char buff[8192] ;
  char work[1024] ;
  char work1[8192] ;
  char *cpt[512] ;

  ret = StartPtsCPH( rbuff, rsz, cary) ;
  /*        | Rec-ID | ǰID\0 | ǰФ(E)\0 |    */
  /*        |  (4)   | (n)      | (n)             |  */
  /*                                                   */
  /*        | ǰФ(J)\0 | ǰ(E)\0 | ǰ(J) | \0 |  */
  /*        | (n)             | (n)           | (n)    )    | (n)        |  */

  i = *(int *)kbuff ;                      /* 쥳ֹ */
  sprintf( buff,"CPH%07d",i) ;
  buff[10] = '\t' ;
  ct = 11 ;                                /* ǰID */
  len =  copy_word( &buff[ct], 8192 - ct, cary[1], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /* ǰФ(E) */
  len =  copy_word( &buff[ct], 8192 - ct, cary[2], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /* ǰФ(J) */
  len =  copy_word( &buff[ct], 8192 - ct, cary[3], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /* ǰ(E) */
  len =  copy_word( &buff[ct], 8192 - ct, cary[4], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /* ǰ(J) */
  len =  copy_word( &buff[ct], 8192 - ct, cary[5], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /*  */
  len =  copy_word( &buff[ct], 8192 - ct, cary[6], NULL ) ;
  ct += len ;
  buff[ct] = '\0' ;
  fprintf( outfp, "%s\n", buff ) ;
  return len  ;
}




/*** ǥåեƽϴؿ : 쥳ɣɣ */

int PrKey2ID(FILE *outfp, char *kbuff,int ksz, char *rbuff, int rsz)
{
  int i , j ;

  fprintf( outfp, "KEY=[%s](rsz=%d) : ",kbuff,rsz) ;
  for ( j = 0 ; j < rsz ; j += 4 ) {
    i = get4byte( rbuff + j ) ;
    fprintf( outfp, " [%d]",i) ;
  }
  fprintf( outfp, "\n" ) ;
  return j  ;
}




