/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  EGramAttr[]= {
	{ "ENC",	 "Ļ	Countable " },
	{ "ENU",	 "ԲĻ	Uncountable " },
	{ "ENUC",	 "Ļ/ԲĻ	Countable/Uncountable" },
	{ "ENG",	 "̾	Collective noun" },
	{ "ENM",	 "̾	Masculine" },
	{ "ENF",	 "̾	Feminine" },
	{ "ENNE",	 "̾	Neuter" },
	{ "ENCM",	 "̾	Common" },
	{ "ENARF",	 "˴ؤ¤ʤ	Does not have restriction on the article" },
	{ "ENWAR",	 "ɬȤ	Always takes an article" },
	{ "ENWDEF",	 "ɬ괧Ȥ	Always takes a definite article" },
	{ "ENWINF",	 "ɬ괧Ȥ	Always takes an indefinite article" },
	{ "ENNODEF",	 "괧ϤȤʤ	Never occurs with a definite article" },
	{ "ENNOINF",	 "괧ϤȤʤ	Never occurs with an indefinite article" },
	{ "ENNOAR",	 "̵	Never occurs with an article" },
	{ "ENRQSG",	 "ɬñ	Always occurs in singular form" },
	{ "ENRQPL",	 "ɬʣ	Always occurs in plural form" },
	{ "ENASG",	 "ưȤοΰפˤơñ	Always treated as singular in subject - verb agreement" },
	{ "ENAPL",	 "ưȤοΰפˤơʣ	Always treated as plural in subject - verb agreement " },
	{ "ENAHM",	 "ưȤοΰפˤơñʣΤ	Treated as either singular or plural in subject - verb agreement" },
	{ "EANOPOS",	 "ʤ	Does not occur in positive degree form" },
	{ "EANOCMP",	 "ӵʤ	Does not occur in comparative degree form" },
	{ "EANOSUP",	 "Ǿʤ	Does not occur in superlative degree form " },
	{ "EDNOPOS",	 "ʤ	Does not occur in positive degree form" },
	{ "EDNOCMP",	 "ӵʤ	Does not occur in comparative degree form" },
	{ "EDNOSUP",	 "Ǿʤ	Does not occur in superlative degree form" },
	{ "EVNOPASS",	 "Բ	Allows no passive voice" },
	{ "EVEXPASS",	 "ɬȷѤ	Occurs only in passive voice" },
	{ "EVNOPRG",	 "ʹԷԲ	Allows no progressive tense " },
	{ "EVEXPRG",	 "ɬʹԷѤ	Occurs only in progressive tense" },

	{ "EDIGIT",	 "	Numeral" },
	{ "EROMAN",	 "޿	Roman Numeral" },
        { NULL,  NULL }} ;





