/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

/*  */
CharTable  J_aspect[]= {
	{ "JA11",	 "ؤƤ٤ܤʤ	ؤƤ The expression does not follow. " },
	{ "JA12",	 "ؤǤ٤ܤơ֡ɽ	ؤǤ The expression follows and signifies a state or property. " },
	{ "JA13",	 "ؤǤ٤ܤơưݤʹԾ֤Ǥ뤳Ȥɽ	ؤǤ The expression follows and signifies a progressive      state of actions or phenomena." },
	{ "JA14",	 "ؤǤ٤ܤơưݤδλ֡ޤϡưη̤ξ֤ɽ	ؤǤ The expression follows and signifies a perfect state of actions or phenomena, or a resulting state of actions or events. " },
	{ "JA20",	 "ؤƤ٤ܤʤޤϡܤƤŪ³Τߤɽ	ؤƤ The  expression  does not  follow, or follows and simply signifies a temporal continuity. " },
	{ "JA21",	 "ؤǤ٤ܤơŪ³ΤߤǤʤܤơŪ³ΤߤǤʤ̵ջ֤ȯѲɽ	ؤǤ  The expression follows and  signifies not only a temporal continuity but also unconscious occurrences  or  changes  in  state." },
	{ "JA22",	 "ؤǤ٤ܤơŪ³ΤߤǤʤͭջ֤ξŪưɽ	ؤǤ The  expression follows and  signifies not only a temporal continuity but also intentional spatial movements. " },
        { NULL,  NULL }} ;


