/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  J_POS[]= {
	{ "JN1",	 "̾	Common nouns" },
	{ "JN2",	 "ͭ̾	Proper nouns" },
	{ "JN3",	 "	Numerals" },
	{ "JN4",	 "	Temporal nouns" },
	{ "JN7",	 "̾	Formal nouns" },
	{ "JVE",	 "ư	Verbs" },
	{ "JAJ",	 "ƻ	Adjectives" },
	{ "JAM",	 "ư	Adjectival nouns" },
	{ "JD1",	 "	Adverbs" },
	{ "JD2",	 "Ľ	Epistemic adverbs" },
	{ "JNM",	 "Ϣλ	Adnouns" },
	{ "JC1",	 "ʸ³	Sentence conjunctions" },
	{ "JC3",	 "ñ³	Wor conjunctions" },
	{ "JT1",	 "ƻŪƬ	Adjectival prefixes" },
	{ "JT2",	 "ŪƬ	Adverbial prefixes" },
	{ "JT3",	 "ϢλŪƬ	Adnominal prefixes" },
	{ "JT4",	 "Ƭ	Honorific prefixes" },
	{ "JN5",	 "ֽ	Counter prefixes" },
	{ "JB1",	 "	Suffixes" },
	{ "JUN",	 "ñ	Units" },
	{ "JN6",	 "ֽ	Counter suffixes" },
	{ "JEV",	 "ư	Verb endings" },
	{ "JEA",	 "ƻ	Adjective endings" },
	{ "JEM",	 "ư	Adjectival noun endings" },
	{ "JNP",	 "θ	Noun  phrases" },
	{ "JPR",	 "Ҹ	Verb  phrases" },
	{ "JAP",	 "Ϣν	Adjective phrases" },
	{ "JMP",	 "Ϣѽ	Adverbial phrases" },
	{ "JIP",	 "Ω	Independent phrases" },
	{ "JSE",	 "ʸ	Sentences" },
	{ "JJO",	 "	Particles" },
	{ "JJ1",	 "	Particle-equivalent  words" },
	{ "JJD",	 "ư	Auxiliary  verbs" },
	{ "JJP",	 "ư	Auxiliary  verb-equivalent words" },
	{ "JAX",	 "Ѹ	Verbal auxiliaries" },
	{ "JIT",	 "	Interjections" },
	{ "JSY",	 "	Symbols" }, 
	{ "JN1;JVE",	 "̾	Verbal nouns (`Suru'-verb stem)" }, 
        { NULL,  NULL }} ;


