/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/

#ifndef  _FUNCTEMP
#define  _FUNCTEMP


void streetogram ( char *str, char *ret, int sz) ;


/*********** ǥåץեؿflib.c ***/
CFile  *Create_IXT( char *fname , char ktype, int hmax, int hsize, int rbsize) ;
CFile  *Open_IXT( char *fname, char ktype ) ;
void  CLose_IXT( CFile *fp) ;
int  Put_IXT(CFile *fp, char *key, int ksz, char *data, int size) ;
int  SetNewRecIXT(CFile  *fp,char *key, int ksz, char *data, int size) ;
int  write_data(CFile *fp,unsigned char *buff,int off,int  pno,char *data, int len, int npo) ;
int  CompKey(CFile  *fp, char *key, int ksz, char *work) ;
int  ReplRec(CFile  *fp, char *key, int ksz, char *data, int size, int curp, char *work) ;
int  AddRec(CFile  *fp, char *key, int ksz, char *data, int size, int priorp, char *work) ;
int  SetFreeBlock(CFile  *fp, int *freept, int freeblockct) ;
int  GetBlock(CFile  *fp, int gct, int *newpt, int nsize ) ;



/*********** ǡסʣ˥եؿflib2.c ***/
CFile  *Create_DTTA( char *fname , int emax) ;
void  CLose_DTTA( CFile *fp) ;
int  Put_DTTA(CFile *fp, char *data, int size) ;
CFile  *Open_DTTA( char *fname ) ;
int  Get_DTTA(CFile *fp, int  id, char *data, int size) ;
int  Get_Rct_DTTA(CFile *fp) ;



/*********** ϥåؿ ***/
unsigned int hash(unsigned char *str,int ksz, int ktype, int hmax, int hsize) ;


/*********** ̴ؿ ***/
int  get2byte(char *work) ;
int  put2byte(short val, char *work) ;
int  get4byte(char *work) ;
int  put4byte(int  val, char *work) ;
char *skip_ptr(char val, char *cptr ) ;
char *search_char(char val, char *cptr )  ;
char *skip_non_sp( unsigned char *cptr ) ;
char *skip_a_word( unsigned char *cptr ) ;
int  PHEXtoBIN( unsigned char h2) ;


/*********** ţģҼؿ *****/
int  EDR_JWordGram( char *str, char *out ) ;
int  EDR_JWordGramAry(char **bptr, char *buff2, int size ) ;
unsigned char GetLconID( char *jpos ) ;
unsigned char GetRconID( char *jpos ) ;
unsigned char GetJPoSID( char *jpos ) ;
int  EDR_KanaHira( unsigned char *str, unsigned char *out ) ;
int ClassNamep( char lang, char *hptr, int hlen, unsigned char lcon, unsigned char rcon) ;
void  j_katuyou( char *rcon, char *out ) ;





/*********** ģ¥եΣ쥳ɽϴؿ ***/
     /* ʸˡģ ƽϴؿ : ʸˡɣ */
int PrGram2ID(FILE *outfp, char *kbuff,int ksz, char *rbuff, int rsz) ;
     /* ʸˡģ ƽϴؿ : ɣġʸˡ */
int PrID2Gram(FILE *outfp, char *kbuff,int ksz, char *rbuff, int rsz) ;
     /* ǥåեƽϴؿ : 쥳ɣɣ */
int PrKey2ID(FILE *outfp, char *kbuff,int ksz, char *rbuff, int rsz)  ;
     /* 쥳ɥեƽϴؿ : 쥳ɣɣġ쥳 */
int PrRid2Dic(FILE *outfp, char *kbuff,int ksz, char *rbuff, int rsz) ;
     /* ţģҥ쥳ɷϴؿ */
int PrRid2EDRCPH(FILE *outfp, char *kbuff,int ksz, char *rbuff, int rsz) ;
int PrRid2EDRJWD(FILE *outfp, char dict, char *kbuff,int ksz, char *rbuff, int rsz)  ;
void PrRid2FVEDRJWD(FILE *outfp, char dict, char *kbuff,int ksz, char *rbuff, int rsz)  ;
void PrRid2VEDRJWD(FILE *outfp, char dict, char *kbuff,int ksz, char *rbuff, int rsz)  ;


/*********** ģ¥եΥ״ؿ ***/
int print_key_data_BS(char *key, int klen, char *data, int dlen) ;

int print_key_data_SBs(char *key, int klen, char *data, int dlen) ;

int print_key_data_BBs(char *key, int klen, char *data, int dlen) ;


#endif

