#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



void
main()
{
      int    flag ,ret ;
      int    jj, kk ;
      int    dct ;
      unsigned int stat;
      unsigned char   buff[16386] ; 
      unsigned char   buff2[16386] ;
      char  work[1024], work1[1024] ;
      char   *cary[30] ;
      CFile  *fpt , *dpt;
      int Rid ;

      char *wdenv ;
      char file[512] ;
      int  len ;

      InitEdrTbl() ;

      wdenv = (char *)getenv( "CONC_DB" ) ;
      if ( wdenv != NULL ) {
        len = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[len++] = '/' ;
      }
      else {
        len = 0 ;
      }
      strcpy( &file[len], "CPH_DB" ) ;
      fpt = Create_IXT( file, 'b', 100000 , -1, 64) ;

      strcpy( &file[len], "CPH_IX" ) ;
      dpt = Create_IXT( file, 's', 10000 ,  6, 32) ;

      dct = 0 ;
      while( gets(buff) != NULL ){
          if ( strncmp( buff, "Copyright", 9) == 0 ) {
            continue ;
	  }
          if ( strncmp( buff, "CPH", 3) != 0 ) {
            fprintf( stderr, "ERROR:[%s]\n",buff ) ;
            continue ;
	  }
          if (( dct % 10000 ) == 0 ) {
            fprintf(stderr, "Put %d   \n",dct) ;
            /* system("date") ; */
          }
          /* printf("IN>[%s](%d)\n",buff,strlen(buff)) ;  */
          len = CreateCphRec( buff, buff2, 16386 ) ;
          Rid = *(int *)buff2 ;
          ret = Put_IXT(fpt, buff2, 4, buff2, len) ;
          /* printf("Put_IXT(Rid=>CPH): ret=%d\n",ret) ; */
          ret = Put_IXT(dpt, &buff2[4], strlen(&buff2[4]), (char *)&Rid, 4 ) ;
          /* printf("Put_IXT(Cid=>Rid): ret=%d\n",ret) ; */
          dct++ ;
          continue ;
      }
      Close_IXT( fpt ) ;
      Close_IXT( dpt ) ;
}


