#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



int
main()
{
      int    flag ,ret ;
      int    jj, kk ;
      int    dct ;
      unsigned int stat;
      unsigned char   buff[16386] ; 
      unsigned char   buff2[16386] ;
      char  HFileName[256], LFileName[256], WFileName[256] ;
      char  work[10] ;
      char   *cary[30] ;
      CFile  *fpt , *dpt;
      FILE   *hfp ;
      int Rid ;

      char *wdenv ;
      char file[512] ;
      int  len ;

      InitEdrTbl() ;

      wdenv = (char *)getenv( "CONC_DB" ) ;
      if ( wdenv != NULL ) {
        len = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[len++] = '/' ;
      }
      else {
        len = 0 ;
      }
      strcpy( &file[len], "CPT_DB" ) ;
      fpt = Create_IXT( file, 'b', 100000 , -1, 64) ;

      strcpy( &file[len], "CPT_IX" ) ;
      dpt = Create_IXT( file, 's', 10000 ,  6, 32) ;

      /*** ե륪ץ ***/
      file[len] = '\0' ;
      strcpy(HFileName, file);
      strcat(HFileName, "HLIST.wk");
      strcpy(WFileName, file);
      strcat(WFileName, "WORK.wk");

      if ( ( hfp = fopen( HFileName, "w" ) ) == NULL ) {
         fprintf( stderr,"Cannot open work file[%s]\n", HFileName ) ;
         return ;
      }


      dct = 0 ;
      while( gets(buff) != NULL ){
          if ( strncmp( buff, "Copyright", 9) == 0 ) {
            continue ;
	  }
          if ( strncmp( buff, "CPT", 3) != 0 ) {
            fprintf( stderr, "ERROR:[%s]\n",buff ) ;
            continue ;
	  }
          if (( dct % 10000 ) == 0 ) {
            fprintf(stderr, "Put %d   \n",dct) ;
            /* system("date") ; */
          }
          //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;  
          len = CreateCptRec( buff, buff2, 16386 ) ;
          Rid = *(int *)buff2 ;
          ret = Put_IXT(fpt, buff2, 4, buff2, len) ;
          /* printf("Put_IXT(Rid=>CPC): ret=%d\n",ret) ; */
          StartPtsCPT(buff2, ret, cary) ;
          /* 긵ǰ쥳ֹ ¸ */
          fprintf( hfp,"%s\tH\t%d\n", cary[3], Rid ) ;
          /* 賵ǰ쥳ֹ ɲ */
          fprintf( hfp,"%s\tL\t%d\n", cary[4], Rid ) ;

          dct++ ;
          continue ;
      }
      Close_IXT( fpt ) ;
      fclose( hfp ) ;

      /*** 긵ǰǥå ***/
      fprintf(stderr, "ǰҥǥå    ...\r");
      msort(HFileName, WFileName);
      ret = Create_CPTIndex( WFileName, dpt );
      if ( ret < 0 )
         return 1 ;
      remove(HFileName);
      remove(WFileName);
      Close_IXT( dpt ) ;
      return 0 ;
}







int Create_CPTIndex( char *FileName, CFile  *fpt )
{
  FILE *fp ;
  int    ret ;
  int    dct, wct, tb ;
  unsigned char   buff[1024] ; 
  char   *bptr[64] ;
  char   save[1024], work[500000] ;

    if ( ( fp = fopen( FileName, "r" )) == NULL ) {
         fprintf( stderr,"Cannot open work file[%s]\n", FileName ) ;
         return -1;
    }

    dct = 1 ;
    save[0] = '\0' ;
    wct = 0 ;
    while( fgets(buff,1024, fp ) != NULL ){
        tb = split1( '\t', buff, bptr ) ;
        if ( save[0] == '\0' || strcmp( bptr[0], save) == 0 ) {
            if ( wct >= 500000 ) {
              fprintf(stderr,"ERROR:work is too small! (word=[%s])\n",bptr[0]) ;
              continue ;
            }
            put4byte( atoi(bptr[2]) , &work[wct] ) ; /* 쥳ֹ */
            if ( *bptr[1] == 'H')
                work[wct+4] = 0x02 ;           
            else
                work[wct+4] = 0x01 ;           
            wct += 5 ;
            if ( save[0] == '\0' )
              strcpy( save, bptr[0] ) ;
            continue ;
        }
        if ( wct >= 10000 ) {
            fprintf(stderr,"WORD[%s] record_count=%d\n",save,wct/5) ;
        }
        ret = Put_IXT( fpt, save, strlen( save ), work, wct) ;
        if ( ret < 0 ) {
            fprintf(stderr,"ERROR(Put_IXT): word=[%s]\n",save) ;
        }
        dct++ ;
        strcpy( save, bptr[0] ) ;
        wct = 0 ;
        put4byte( atoi(bptr[2]) , &work[wct] ) ; /* 쥳ֹ */
        if ( *bptr[1] == 'H')
            work[wct+4] = 0x02 ;           
        else
            work[wct+4] = 0x01 ;           
        wct += 5 ;
    }
    ret = Put_IXT( fpt, save, strlen( save ), work, wct) ;
    if ( ret < 0 ) {
      fprintf(stderr,"ERROR(Put_IXT): word=[%s]\n",save) ;
    }
    fclose( fp ) ;
    return dct ;
}


