#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



int
main()
{
      int    tb, flag ,ret ;
      int    dct, start ;
      unsigned int stat;
      char   *bptr[30] ;
      unsigned char   buff[16386],buff0[16386], *cp ; 
      char   out[16386] ;
      CFile  *fpt , *dpt;

      char *wdenv ;
      char file[512] ;
      int  len ;

      wdenv = (char *)getenv( "GRAM_DB" ) ;
      if ( wdenv != NULL ) {
        len = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[len++] = '/' ;
      }
      else {
        len = 0 ;
      }
      strcpy( &file[len], "GDB_ID2INF" ) ;
      dpt = Open_IXT( file, 'b' ) ;
      if ( dpt != NULL ) {
        strcpy( &file[len], "GDB_INF2ID" ) ;
        fpt = Open_IXT( file, 's') ;
      }
      else {
        dpt = Create_IXT( file, 'b', 1000 , -1, 128) ;
        strcpy( &file[len], "GDB_INF2ID" ) ;
        fpt = Create_IXT( file, 's', 1000 , -1, 128) ;
      }
      start = dct = dpt->rct ;

      
      while( gets(buff) != NULL ){
          if ( strncmp( buff, "Copyright", 9) == 0 ) {
            continue ;
	  }
          if ( buff[0] == '#' )
            continue ;
          cp = buff ;
          if ( strncmp( buff, "UPD:", 3) == 0  ||
               strncmp( buff, "ADD:", 3) == 0 ) {
            cp = skip_a_word(buff) ;
            cp = skip_non_sp( cp ) ;
            if ( cp == NULL || *cp == '\0' ) {
               fprintf( stderr, "ERROR:[%s]\n",buff ) ;
               continue ;
            }
          }

          if ( strncmp( cp, "JWD", 3) != 0  &&
               strncmp( cp, "TJWD", 4) != 0 ) {
            fprintf( stderr, "ERROR:[%s]\n",buff ) ;
            continue ;
	  }
          if (( dct % 10000 ) == 0 ) {
            fprintf(stderr, "Put %d   \n",dct) ;
            //system("date") ;
          }
          strcpy(buff0,cp) ;
          tb = split1( '\t', buff0, bptr ) ;
          ret = EDR_JWordGramAry( bptr, out, 16386 ) ;
          // printf("IN[%s]\n",buff) ;
          //printf(" ==>GRAM[%s]\n",out) ;
          if ( ret != 0 && Get_IXT( fpt, out, strlen(out), buff, 16386 ) == 0 ) { 
            if ( Get_IXT(dpt, (char *)&dct, 4, buff, 16386 ) != 0 ) {
              fprintf(stderr,"ERROR(CreateGDB): ʸˡɣĤΤϤϿѤߤˤʤäƤ롪\n") ;
              fprintf(stderr,"                : ʸˡģ¤ƤǧƤ\n") ;
              Close_IXT( dpt ) ;
              Close_IXT( fpt ) ;
              return ;
            }
            // ID=>RECORD 
            ret = Put_IXT(dpt, (char *)&dct, 4, out, strlen(out)) ; 
            // GRAM_INFO.=>ID
            ret = Put_IXT(fpt, out, strlen(out), (char *)&dct, 4) ;
            dct++ ;
          }
          continue ;
      }
      if ( start != dct && 
           (( dct - 1 ) != fpt->rct || ( dct -1 ) != dpt->rct )) {
        fprintf( stderr,"ERROR(CreateGramDB): Record Count ERROR!dct=%d fpt->rct=%d dpt->rct=%d\n",dct,fpt->rct,dpt->rct) ;
        fprintf( stderr,"dct = %d\n",dct) ;
      }
      else if (start != dct ) {
        fprintf( stderr,"(CreateGramDB): Normal End.( put %d record. )\n", dct - start - 1) ;
      }
      Close_IXT( dpt ) ;
      Close_IXT( fpt ) ;

      return 0 ;
}





