/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "aconst.h"


/**************************************************************
 ѼԤȲäʤ顢쥳ɤɽ롣     ǰФ
**************************************************************/


void
main(int argc,  char **argv)
{
      int   ret1, ret2 ;
      int   lev, com;
      char  work[1024];
      char  *ary[64] ;

      /*
         ưĶ
      */

      DB_FileOpen() ;
      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */

      while( 1 ) {
        fprintf( stderr,">>> Input command \n") ;
        if ( gets( work ) == NULL )
          break ;
        if ( work[0] == '\0' )
          continue ;
        AccessEDRIDX( work ) ;
      }

      DB_FileClose() ;

      return ;
}







/* 공ǰ̻ҤδϢǰμ */
int AccessEDRIDX( char *cid ) 
{
  int ii, ret ;
  char work[8192] ;
  char *conc[64] ;

  ret = Get_IXT(CHID2CPRecID, cid, strlen(cid), work, 8192) ;
  if ( ret == 0 ) {
    if ( TCHID2CPRecID == NULL ) {
      fprintf( stderr,"ǰ̻[ %s ]¸ߤޤ\n", cid) ;
      return -1;
    }
    ret = Get_IXT(TCHID2CPRecID, cid, strlen(cid), work, 8192) ;
    if ( ret == 0 ) {
      fprintf( stderr,"ǰ̻[ %s ]¸ߤޤ\n", cid) ;
      return -1;
    }
    ii = get4byte(work) ;
    ret = Get_IXT(TCPHRecId2Val, (char *)&ii, 4, work, 8192) ;
    if ( ret == 0 ) {
      fprintf( stderr,"REC_ID[%d] => ??????\n",ii) ;
      return -1;
    }
  }
  else {
    ii = get4byte(work) ;
    ret = Get_IXT(CPHRecId2Val, (char *)&ii, 4, work, 8192) ;
    if ( ret == 0 ) {
      fprintf( stderr,"REC_ID[%d] => ??????\n",ii) ;
      return -1;
    }
  }
  StartPtsCPH(work, ret, conc)  ;
  printf("CPH%07d\t%s\t%s\t%s\t%s\t%s\t%s\n",ii,conc[1],conc[2],conc[3],conc[4],conc[5],conc[6]) ;
  return ii ;
}






/******************************************
// DB򥢥ꤵ줿֤˹줿Τ򤹤 
int Access_by_date( CFile *log, char *date )
{
  int  ret ,ret1;
  int  i, len, hdate, Rid ;
  int  cdate,fromb,tob, dhash ;
  char work[4096], wk[32] ;
  char *ary[16] ;

  if ( log == NULL )
    return 1 ;
  //printf("ret=%d\n",ret) ;
  //printf("from=[%s]\n",ary[0]) ;
  //printf("to=[%s]\n",ary[1]) ;

  ret = split1( '-', date, ary) ;

  if ( ary[0] == '\0' ) { //  1997.1.1 
    fromb = PStrDate2PI( "19970101" ) ;
  }
  else
    fromb = PStrDate2PI( ary[0] ) ;

  if ( ret == 1) {
    tob = PackNowDateI() ;
  }
  else
    tob = PStrDate2PI( ary[1] ) ;

  //printf("from[%x], tob=[%x]\n",fromb,tob) ;
  ret = ret1 = 0 ;
  for( cdate = fromb ; cdate <= tob ;  cdate = next_Pdate( cdate ) ) {
    dhash = ConvPackDate2B( cdate ) ;
    len = Get_IXT( log, (char *)&dhash, 4, work, 4096) ;
    if ( len <= 0 )
      continue ;
    len = CDATEFromETC4byte( wk, (char *)&cdate ) ;
    printf("################# DATE [ %s ] #################\n",wk) ;
    for( i = 0 ; i < len  ; i += 4 ) {
      Rid = get4byte(work + i) ;
      printf("JWD%07d\n", Rid ) ;
      ret1++ ;
      if ( ret >= 32768 ) {
        continue ;
      }
      CurRecIDs[ret++] = Rid ;
    }
  }
  if ( ret1 >= 32768 ) {
    fprintf( stderr,"ERROR(Access_by_date):ϥ쥳ɤο¿ޤ\n") ;
    fprintf( stderr,"                      ꤹ֤ûƲ\n") ;
  }    
  CurRecCt = ret ;

  return 1;
}
******************************************/




/*** Ϥ줿ʸʬϤ ***/
int InputCom(char *work, char **ary) 
{
  char *cp ;
  int  ret ;

  cp = skip_non_sp( work ) ;
  if ( cp == NULL)
    return 0 ;
  ary[0] = cp ;
  ary[1] = ary[2] = NULL ;

  if (*cp == 'F' || *cp == 'f' ) {
    cp++ ;
    if ( *cp <= ' '  ) /* ǰҤθɽޥ */
      ret = 0 ;
    else if ( *cp == 'H' | *cp == 'h' ) /* ǰҤ濴γǰɣĤˤ븡 */
      ret = 1 ;
    else if ( *cp == 'd' | *cp == 'd' ) /* ǰҤγǰɣĤˤ븡 */
      ret = 2 ;
    else if ( strncmp(cp, "HD") == 0 ||
              strncmp(cp, "hd") == 0  ) /* ǰҤΡ濴סִطҡספγǰɣĤˤ븡 */
      ret = 3 ;
    else {
      return -1 ;
    }
    cp++ ;
    ary[1] = skip_non_sp( cp ) ;
    cp = skip_a_word( ary[1] ) ;
    if ( cp != NULL) {
      *cp = '\0' ;
      cp++ ;
    }
    ary[2] = skip_non_sp( cp ) ;
    cp = skip_a_word( ary[2] ) ;
    if ( cp != NULL) {
      *cp = '\0' ;
      cp++ ;
    }
    ary[3] = skip_non_sp( cp ) ;
    return ( ret ) ;
  }
  if (*cp == 'S' || *cp == 's' ) {
    cp++ ;
    if ( *cp == 'H' | *cp == 'h' ) /* ǰҤ濴γǰɣĤˤ룲 */
      ret = 11 ;
    else if ( *cp == 'D' | *cp == 'd' ) /* ǰҤγǰɣĤˤ룲 */
      ret = 12 ;
    else if ( *cp == 'R' | *cp == 'r' ) /* ǰҤδطҤˤ룲 */
      ret = 13 ;
    else {
      return -1 ;
    }
    cp++ ;
    ary[1] = skip_non_sp( cp ) ;
    return ( ret ) ;
  }
  if (*cp == 'P' || *cp == 'p' ) {
    return 20 ;
  }
  ary[1] = cp ;
  return 0;
}




