/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "aconst.h"


/**************************************************************
 ѼԤȲäʤ顢쥳ɤɽ롣     ǰ
**************************************************************/
int  CurRecIDs[32768] ;  /*** ȥ쥳ֹǼꥢ ***/
int  CurRecCt = 0;       /*** ȥ쥳ɿ             ***/
int  BakRecIDs[32768] ;  /*** Υȥ쥳ֹǼꥢ ***/
int  BakRecCt = 0;       /*** Υȥ쥳ɿ             ***/

int  ENV_FLAGS ;         /*** ɽĶλ ***/


/*** Template ***/
void  HelpInput() ;
void SetAccessDict( char *cp ) ;
void SetPrintMode( char *cp ) ;



void
main(int argc,  char **argv)
{
      int   ret1, ret2 ;
      int   lev, com;
      char  work[1024];
      char  *ary[64] ;
      FILE *fp ;

      /*
         ưĶ
      */

      InitEnv() ;                /* ɽ⡼ɤʤɴĶ */
      DB_FileOpen() ;
      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */

      while( 1 ) {
          fprintf( stderr,">>> Input command  (Current Record = %d)\n",CurRecCt) ;
          if ( gets( work ) == NULL )
            break ;
          if ( (com = InputCom(work,ary)) < 0 )
            continue ;
          if ( com == 20 ) { /* print cur-records */
            PrintEDRCPT( ary[4]  )  ;
            continue ;
          }
          /*
	    printf("com=%d\n",com) ;
	    printf("ary[1] = %d ary[1] =>[%s]\n",ary[1],ary[1]) ;
	    if( ary[2] == NULL )
	      printf("ary[2] = NULL\n") ;
	    else
	      printf("ary[2] = %d ary[2] =>[%s]\n",ary[2],ary[2]) ;
	    if ( ary[3] == NULL )
	      printf("ary[3] = NULL\n") ;
	    else 
	      printf("ary[3] = %d ary[3] =>[%s]\n",ary[3],ary[3]) ;
	    if ( ary[4] == NULL )
	      printf("ary[4] = NULL\n") ;
	    else 
	      printf("ary[4] = %d ary[4] =>[%s]\n",ary[4],ary[4]) ;
          */

          if ( ary[4] != NULL ) {
            if ( (fp = fopen( ary[4], "w")) == NULL ) {
              fprintf(stderr,"[%s]ץǤޤ\n",ary[4]) ;
              continue ;
            }
          }
          else fp = stdout ;
          /* Find & Print records */
          switch( com ) {   /* Find & Select records */
            case   0 :  /* 濴˷餺ǰˤ븡 */
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = AccessEDRIDX( ary[1] ) ;
                break ;
            case   1 :  /* 濴ǰˤ븡 */
            case  11 :  /* 濴ǰˤ룲 */
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = AccessEDRIDXH( ary[1] ) ;
                if ( com == 11 )
                  ret2 = IntersectEDRIDX() ;
                break ;
            case   2 :  /* 공ǰˤ븡 */
            case  12 :  /* 공ǰˤ룲 */
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = AccessEDRIDXD( ary[1] ) ;
                if ( com == 11 )
                  ret2 = IntersectEDRIDX() ;
                break ;
            case   3 :  /* 濴طҡˤ븡ɽ */
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = AccessEDRIDXP( fp, ary ) ;
                break ;
            case  13 :  /* طҤˤ룲 */
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = AccessEDRIDXR( ary[1] ) ;
                break ;
          }
          if ( ary[4] != NULL ) 
            fclose( fp ) ;
      }

      DB_FileClose() ;

      return ;
}






int BackUpCurentRec()
{
  int ii ;

  for( ii = 0 ; ii < CurRecCt ; ii++ ) 
    BakRecIDs[ii] = CurRecIDs[ii] ; 
  BakRecCt = CurRecCt ;
  return BakRecCt ;
}


int RecoverCurentRec()
{
  int ii ;
  for( ii = 0 ; ii < BakRecCt ; ii++ )
    CurRecIDs[ii] = BakRecIDs[ii] ;
  CurRecCt = BakRecCt ;
  return BakRecCt ;
}



/* 공ǰ̻ҤδϢǰμ */
int AccessEDRIDX( char *cid ) 
{
  int ii, ret ;
  char work[8192] ;

  ret = Get_IXT(CTID2CPRecID, cid, strlen(cid), work, 8192) ;
  CurRecCt = 0 ;
  for( ii = 0 ; ii < ret ; ii += 5 ) {
    CurRecIDs[CurRecCt++] = get4byte(work + ii) ;
  }
  return CurRecCt ;
}


/* 濴ǰ̻ҤδϢǰμ */
int AccessEDRIDXH( char *cid ) 
{
  int ii, ret ;
  char work[8192] ;

  ret = Get_IXT(CTID2CPRecID, cid, strlen(cid), work, 8192) ;
  CurRecCt = 0 ;
  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( ( *(work + ii + 4) & 0x02 ) != 0 )
      CurRecIDs[CurRecCt++] = get4byte(work + ii) ;
  }
  return CurRecCt ;
}


/* 공ǰ̻ҤδϢǰμ */
int AccessEDRIDXD( char *cid ) 
{
  int ii, ret ;
  char work[8192] ;

  ret = Get_IXT(CTID2CPRecID, cid, strlen(cid), work, 8192) ;
  CurRecCt = 0 ;
  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( ( *(work + ii + 4) & 0x01 ) != 0 )
      CurRecIDs[CurRecCt++] = get4byte(work + ii) ;
  }
  return CurRecCt ;
}


int IntersectEDRIDX()
{
  int ii, jj, kk ;

  kk = 0 ;
  for( ii = 0 ; ii < CurRecCt ; ii++ ) {
    for ( jj = 0 ; jj < BakRecCt ; jj++ ) {
      if ( CurRecIDs[ii] == BakRecIDs[jj] ) {
        CurRecIDs[kk++] = CurRecIDs[ii] ;
        break ;
      }
    }
  }
  CurRecCt = kk ;
  return CurRecCt ;
}




/* طҤˤ복ǰμ */
int AccessEDRIDXR( char *rel ) 
{
  int ii, kk, relid, ret ;
  char work[8192] ;

  /* طҥơ֥륵 */
  relid = GetCharTableIX( rel, &Concept_Rel[0]  ) ;

  if (relid == -1) {
    fprintf( stderr, "ǰط[%s]ϿƤޤ\n", rel ) ;
    return 0 ;
  }
  for ( ii = kk = 0 ; ii < BakRecCt ; ii++) {
    ret = Get_IXT(CPTRecId2Val, &BakRecIDs[ii], 4, work, 8192) ;
    //        | Rec-ID | FLAG | طID | 긵ǰID\0 |
    //        |  (4)   | (1)  | (1)      | (n)            |
    //
    //        | 賵ǰID\0 | \0 |
    //        | (n)            | (n)        |
    //
    //             FLAG:  Ҷʬ    
    //                    FLAG & 0x01 == 0B : Ҷʬ  I
    //                    FLAG & 0x01 == 1B : Ҷʬ  E
    //                    FLAG & 0x02 == 0B :    
    //                    FLAG & 0x02 == 1B :    

    if ( relid == work[5] ) {
      CurRecIDs[kk++] = BakRecIDs[ii] ;
    }
  }
  CurRecCt = kk ;
  return CurRecCt ;
}




/* 濴סִطҡספˤ복ǰμ */
int AccessEDRIDXP( FILE *fp, char **ary ) 
{
  int ii, jj, kk, crec, relid, ret ;
  char work[8192] ;
  int  wk[2048] ;

  CurRecCt = 0 ;
  kk = 0 ;
  if ( ary[1] != NULL && *ary[1] != '*' && *ary[1] != '\0') {
    ret = Get_IXT(CTID2CPRecID, ary[1], strlen(ary[1]), work, 8192) ;
    for( ii = 0 ; ii < ret ; ii += 5 ) {
      if ( ( *(work + ii + 4) & 0x02 ) != 0 )
        wk[kk++] = get4byte(work + ii) ;
    }
    if ( kk == 0 ) {
      return 0 ;
    }
    if ( ary[3] != NULL && *ary[3] != '*' && *ary[3] != '\0') {
      ret = Get_IXT(CTID2CPRecID, ary[3], strlen(ary[3]), work, 8192) ;
      for( ii = 0 ; ii < ret ; ii += 5 ) {
        if ( ( *(work + ii + 4) & 0x01 ) != 0 ) {
          crec = get4byte(work + ii) ;
          for( jj = 0 ; jj < kk ; jj++ ) {
            if ( wk[jj] == crec )
              CurRecIDs[CurRecCt++] = crec ;
          }
        }
      }
    }
    else {
      for( jj = 0 ; jj < kk ; jj++ ) 
        CurRecIDs[CurRecCt++] = wk[jj] ;
    }
  }
  else if ( ary[3] != NULL && *ary[3] != '*' && *ary[3] != '\0') {
    ret = Get_IXT(CTID2CPRecID, ary[3], strlen(ary[3]), work, 8192) ;
    for( ii = 0 ; ii < ret ; ii += 5 ) {
      if ( ( *(work + ii + 4) & 0x01 ) != 0 ) 
        CurRecIDs[CurRecCt++] = get4byte(work + ii) ;
    }
  }
  else {
    return 0 ;
  }
  if ( CurRecCt == 0 )
    return 0 ;

  if ( ary[2] != NULL && *ary[2] != '*' && *ary[2] != '\0') {
    /* طҥơ֥륵 */
    relid = GetCharTableIX( ary[2], &Concept_Rel[0]  ) ;

    if (relid == -1) {
      fprintf( stderr, "ǰط[%s]ϿƤޤ\n", ary[2] ) ;
      return 0 ;
    }
    for ( ii = kk = 0 ; ii < CurRecCt ; ii++) {
      ret = Get_IXT(CPTRecId2Val, &CurRecIDs[ii], 4, work, 8192) ;
      //        | Rec-ID | FLAG | طID | 긵ǰID\0 |
      //        |  (4)   | (1)  | (1)      | (n)            |
      //
      //        | 賵ǰID\0 | \0 |
      //        | (n)            | (n)        |
      //
      //             FLAG:  Ҷʬ    
      //                    FLAG & 0x01 == 0B : Ҷʬ  I
      //                    FLAG & 0x01 == 1B : Ҷʬ  E
      //                    FLAG & 0x02 == 0B :    
      //                    FLAG & 0x02 == 1B :    

      if ( relid == work[5] ) {
        CurRecIDs[kk++] = CurRecIDs[ii] ;
      }
    }
    CurRecCt = kk ;
  }
  for( ii = 0 ; ii < CurRecCt ; ii++) {
    PrRid2EDRCPT(fp , 'B', CurRecIDs[ii]) ;
  }

  return CurRecCt ;
}










/* ţģҷɽ */
int PrintEDRCPT( char *fname )
{
  int ct = 0 ;
  FILE *fp ;
 
  if ( fname == NULL || *fname == '\0' )
    fp = stdout ;
  else {
    if ( (fp = fopen( fname, "w")) == NULL ) {
      fprintf(stderr,"[%s]ץǤޤ\n", fname) ;
      return ;
    }
  }
  for( ct = 0 ; ct < CurRecCt ; ct++) {
    PrRid2EDRCPT(fp , 'B', CurRecIDs[ct]) ;
  }
  if ( fname != NULL && *fname != '\0' )
    fclose( fp ) ;

  return 1 ;
}









/******************************************
// DB򥢥ꤵ줿֤˹줿Τ򤹤 
int Access_by_date( CFile *log, char *date )
{
  int  ret ,ret1;
  int  i, len, hdate, Rid ;
  int  cdate,fromb,tob, dhash ;
  char work[4096], wk[32] ;
  char *ary[16] ;

  if ( log == NULL )
    return 1 ;
  //printf("ret=%d\n",ret) ;
  //printf("from=[%s]\n",ary[0]) ;
  //printf("to=[%s]\n",ary[1]) ;

  ret = split1( '-', date, ary) ;

  if ( ary[0] == '\0' ) { //  1997.1.1 
    fromb = PStrDate2PI( "19970101" ) ;
  }
  else
    fromb = PStrDate2PI( ary[0] ) ;

  if ( ret == 1) {
    tob = PackNowDateI() ;
  }
  else
    tob = PStrDate2PI( ary[1] ) ;

  //printf("from[%x], tob=[%x]\n",fromb,tob) ;
  ret = ret1 = 0 ;
  for( cdate = fromb ; cdate <= tob ;  cdate = next_Pdate( cdate ) ) {
    dhash = ConvPackDate2B( cdate ) ;
    len = Get_IXT( log, (char *)&dhash, 4, work, 4096) ;
    if ( len <= 0 )
      continue ;
    len = CDATEFromETC4byte( wk, (char *)&cdate ) ;
    printf("################# DATE [ %s ] #################\n",wk) ;
    for( i = 0 ; i < len  ; i += 4 ) {
      Rid = get4byte(work + i) ;
      printf("JWD%07d\n", Rid ) ;
      ret1++ ;
      if ( ret >= 32768 ) {
        continue ;
      }
      CurRecIDs[ret++] = Rid ;
    }
  }
  if ( ret1 >= 32768 ) {
    fprintf( stderr,"ERROR(Access_by_date):ϥ쥳ɤο¿ޤ\n") ;
    fprintf( stderr,"                      ꤹ֤ûƲ\n") ;
  }    
  CurRecCt = ret ;

  return 1;
}
******************************************/




/*** Ϥ줿ʸʬϤ ***/
int InputCom(char *work, char **ary) 
{
  char *cp ;
  int  ret ;

  
  cp = skip_non_sp( work ) ;
  if ( cp == NULL || *cp == '\0')
    return -1 ;
  if ( *cp == '?' ) {
    HelpInput() ;
    return -1 ;
  }
  ary[0] = cp ;
  ary[1] = ary[2] = NULL ;

  if (*cp == 'F' || *cp == 'f' ) {
    cp++ ;
    if ( *cp <= ' '  ) /* ǰҤθɽޥ */
      ret = 0 ;
    else if ( (*cp == 'H' | *cp == 'h') && *(cp+1) <= ' ' ) { /* ǰҤ濴γǰɣĤˤ븡 */
      ret = 1 ; cp++ ;
    }
    else if ( (*cp == 'd' | *cp == 'd') && *(cp+1) <= ' ' ) { /* ǰҤγǰɣĤˤ븡 */
      ret = 2 ; cp++ ;
    }
    else if ( (strncmp(cp, "HD", 2) == 0 ||
               strncmp(cp, "hd", 2) == 0  ) && *(cp+2) <= ' ' ){ /* ǰҤΡ濴סִطҡספγǰɣĤˤ븡 */
      ret = 3 ; cp += 2 ;
    }
    else {
      return -1 ;
    }
    ary[1] = skip_non_sp( cp ) ;
    cp = skip_a_word( ary[1] ) ;
    if ( cp == NULL || *cp == '\0') {
      ary[2] = ary[3] = ary[4] = NULL ;
      return ret ;
    }
    *cp = '\0' ;
    cp++ ;

    ary[2] = skip_non_sp( cp ) ;
    if ( *ary[2] == '>' ) {       /* F Cid > outfile */
      cp = ary[2] + 1 ;
      ary[4] = skip_non_sp( cp ) ;
      cp = skip_a_word( ary[4] ) ;
      if ( cp != NULL && *cp != '\0') 
        *cp = '\0' ;
      ary[2] = ary[3] = NULL ;
      return ret ;
    }
    cp = skip_a_word( ary[2] ) ;
    if ( cp == NULL || *cp == '\0') {
      ary[3] = ary[4] = NULL ;
      return ret ;
    }
    *cp = '\0' ;
    cp++ ;
    ary[3] = skip_non_sp( cp ) ;
    cp = skip_a_word( ary[3] ) ;
    if ( cp == NULL || *cp == '\0') {
      ary[4] = NULL ;
      return ret ;
    }
    *cp = '\0' ;
    cp++ ;
    ary[4] = skip_non_sp( cp ) ;
    if ( ary[4] == NULL )
      return ret ;
    if ( *ary[4] == '>' ) {       /* F Cid > outfile */
      cp = ary[4] + 1 ;
      ary[4] = skip_non_sp( cp ) ;
    }
    cp = skip_a_word( ary[4] ) ;
    if ( cp == NULL || *cp == '\0') 
      return ret ;
    *cp = '\0' ;
    return ( ret ) ;
  }
  if (*cp == 'S' || *cp == 's' ) {
    cp++ ;
    if ( *cp == 'H' | *cp == 'h' ) /* ǰҤ濴γǰɣĤˤ룲 */
      ret = 11 ;
    else if ( *cp == 'D' | *cp == 'd' ) /* ǰҤγǰɣĤˤ룲 */
      ret = 12 ;
    else if ( *cp == 'R' | *cp == 'r' ) /* ǰҤδطҤˤ룲 */
      ret = 13 ;
    else {
      return -1 ;
    }
    cp++ ;
    ary[1] = skip_non_sp( cp ) ;
    return ( ret ) ;
  }
  if (*cp == 'P' || *cp == 'p' ) {
    cp++ ;
    ary[1] = ary[2] = ary[3] = NULL ;
    ary[4] = skip_non_sp( cp ) ;
    if ( ary[4] == NULL )
      return 20 ;
    if ( *ary[4] == '>' ) {       /* P  > outfile */
      cp = ary[4] + 1 ;
      ary[4] = skip_non_sp( cp ) ;
    }
    cp = skip_a_word( ary[4] ) ;
    if ( cp == NULL || *cp == '\0') 
      return 20 ;
    *cp = '\0' ;
    return 20 ;
  }
  if ( *cp == 'B' || *cp == 'b' ) {
    cp++ ;
    if ( *cp == '\0' || skip_non_sp( cp ) == NULL ) 
      RecoverCurentRec() ;
    return -1 ;
  }
  ary[1] = cp ;
  return 0;
}






/********************************************************/
void  HelpInput()
{
  fprintf( stderr,"*** COMMANDS **************************************\n") ;
  /*
  //fprintf( stderr,"FH  ConceptID  濴γǰפꤷط뵭Ƥθ\n") ;
  //fprintf( stderr,"FD  ConceptID  γǰפꤷط뵭Ƥθ\n") ;
  */
  fprintf( stderr,"FHD ConceptID rel ConceptID  [> file]\n" ) ;
  fprintf( stderr,"               濴طҡפꤷƤθɽ\n") ;
  fprintf( stderr,"F   ConceptID  濴ספ˷餺ǰط뵭Ƥθ\n") ;

  fprintf( stderr,"SH  ConceptID  濴γǰפꤷ\n") ;
  fprintf( stderr,"SR  rel        ִطҡפꤷ\n") ;
  fprintf( stderr,"SD  ConceptID  γǰפꤷ\n") ;

  fprintf( stderr,"P [file]             ץ\n") ;
  fprintf( stderr,"---------------------------------------------------\n") ;
  fprintf( stderr," Ƽ拾ޥɤϾʸǤɤ\n") ;
  fprintf( stderr,"\n") ;
}




int InitEnv()
{
  ENV_FLAGS = 0 ;
  return 1 ;
}



