/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"

CharTable  FIELD_TBL[] = {
  { "GROUP_ID" ,   "INT" },
  { "WORD_RID" ,   "INT" },
  { "CPH_RID" ,    "INT" },
  { "CPC_RID" ,    "INT" },
  { "CPT_RID" ,    "INT" },
  { "CP_B_F_ID" ,  "HEX" },
  { "CP_B_T_ID" ,  "HEX" },
  { "CP_T_F_ID" ,  "HEX" },
  { "CP_T_T_ID" ,  "HEX" },
  { NULL ,  NULL }} ;


void
main()
{
  int  ii, ret  ;
  int  vint ;
  char fbuff[1024] ;
  char vbuff[1024] ;
  char work[1024], outbuff[1024] ;

  CONT_DB_Open() ;


  fprintf( stderr," -----------------------------------------------\n" ) ;
  fprintf( stderr," μȥΥ \n" ) ;
  dumpcont() ;
  fprintf( stderr," -----------------------------------------------\n" ) ;

  if ( ControlDB == NULL ) 
    return ;

  while( 1 ) {
    fprintf( stderr,"FIELD NAME ?\n" ) ;
    if ( gets(fbuff) == NULL || fbuff[0] < ' ' ) 
      break ;
    fprintf( stderr,"VALUE ?\n" ) ;
    if ( gets(vbuff) == NULL ) 
      continue ;
    ret = Get_IXT( ControlDB, fbuff, strlen( fbuff ) , work, 1024 ) ;
    if ( ret == 0 )
      work[0] = '\0' ;
    for( ii=0 ; FIELD_TBL[ii].type1 != NULL ; ii++ ) {
      if ( strcmp( FIELD_TBL[ii].type1, fbuff ) == 0 )
        break ;
    }
    if ( FIELD_TBL[ii].type1 == NULL ) {
      fprintf( stderr,"Unknown field[%s]\n",fbuff) ;
      continue ;
    }
    if ( strcmp(FIELD_TBL[ii].type2, "INT") == 0 ) {
      fprintf( stderr,"*** field[%s]͡ʸ[%d]ˤ[%s]ꤷޤ\n",fbuff, *(int *)work, vbuff) ;
      vint = atoi( vbuff ) ;
      ret = Put_IXT( ControlDB, fbuff, strlen(fbuff), (char *)&vint, sizeof(int) ) ;
    }
    else if ( strcmp(FIELD_TBL[ii].type2, "HEX") == 0 ) {
      ret = BintoHex( 4, work, outbuff) ;
      fprintf( stderr,"*** field[%s]͡ʸ[%s]ˤ[%s]ꤷޤ\n",fbuff, outbuff, vbuff) ;
      vint = HextoBin( vbuff ) ;
      ret = Put_IXT( ControlDB, fbuff, strlen( fbuff ) , (char *)&vint, sizeof(int) ) ;
    }
    else {
      continue ;
    }
  }

  CONT_DB_Close() ;


}




/*************** ȥΥ ********************/
int dumpcont()
{
  int ret ;
  char work[128], outbuff[128] ;

  /* Ƴǧ */
  ret = Get_IXT( ControlDB, "GROUP_ID", strlen( "GROUP_ID" ) , work, 128 ) ;
  printf( "GROUP_ID : INIT[700000] => CurDB[%d]\n",*(int *)work) ;
  ret = Get_IXT( ControlDB, "WORD_RID", strlen( "WORD_RID" ) , work, 128 ) ;
  printf( "WORD_RID : INIT[700000] => CurDB[%d]\n",*(int *)work) ;
  ret = Get_IXT( ControlDB, "CPH_RID", strlen( "CPH_RID" ) , work, 128 ) ;
  printf( "CPH_RID : INIT[700000] => CurDB[%d]\n",*(int *)work) ;
  ret = Get_IXT( ControlDB, "CPC_RID", strlen( "CPC_RID" ) , work, 128 ) ;
  printf( "CPC_RID : INIT[700000] => CurDB[%d]\n",*(int *)work) ;
  ret = Get_IXT( ControlDB, "CPT_RID", strlen( "CPT_RID" ) , work, 128 ) ;
  printf( "CPT_RID : INIT[700000] => CurDB[%d]\n",*(int *)work) ;

  ret = Get_IXT( ControlDB, "CP_B_F_ID", strlen( "CP_B_F_ID" ) , work, 128 ) ;
  ret = BintoHex( 4, work, outbuff) ;
  printf( "CP_B_F_ID : INIT[700000] => CurDB[%s]\n",outbuff) ;
  ret = Get_IXT( ControlDB, "CP_B_T_ID", strlen( "CP_B_T_ID" ) , work, 128 ) ;
  ret = BintoHex( 4, work, outbuff) ;
  printf( "CP_B_T_ID : INIT[77ffff] => CurDB[%s]\n",outbuff) ;
  ret = Get_IXT( ControlDB, "CP_T_F_ID", strlen( "CP_T_F_ID" ) , work, 128 ) ;
  ret = BintoHex( 4, work, outbuff) ;
  printf( "CP_T_F_ID : INIT[780000] => CurDB[%s]\n",outbuff) ;
  ret = Get_IXT( ControlDB, "CP_T_T_ID", strlen( "CP_T_T_ID" ) , work, 128 ) ;
  ret = BintoHex( 4, work, outbuff) ;
  printf( "CP_T_T_ID : INIT[7fffff] => CurDB[%s]\n",outbuff) ;


}



