#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/

/* ܸ쥳ѥϿ */
extern FILE *Hfp ;
extern FILE *Cfp ;

int
main(int argc,  char **argv)
{
      int    rid , ret;
      int    dct ;
      unsigned char   buff[16386] ; 
      char  HFileName[256], CFileName[256], WFileName[256] ;
      char file[512] ;
      int len ;
      char *wdenv ;
      char   *cp, *sp ;

      InitEdrTbl() ;
      
      rid = JCorpus_DB_Open() ;
      if ( rid < 0 ) 
        JCorpus_DB_Create() ;


      /*** ե륪ץ ***/
      wdenv = (char *)getenv( "CORP_DB" ) ;
      if ( wdenv != NULL ) {
        len = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[len++] = '/' ;
      }
      else {
        len = 0 ;
      }
      file[len] = '\0' ;
      strcpy(HFileName, file);
      strcat(HFileName, "HLIST.wk");
      strcpy(CFileName, file);
      strcat(CFileName, "CLIST.wk");
      strcpy(WFileName, file);
      strcat(WFileName, "WORK.wk");
      /* ɽꥹϿѥե */
      if ( ( Hfp = fopen(HFileName, "w")) == NULL ) {
        fprintf(stderr,"ERROR:ɽꥹȤϤեκ˼\n") ;
        return 1;
      }
      /* ǰIDꥹϿѥե */
      if ( ( Cfp = fopen(CFileName, "w")) == NULL ) {
        fprintf(stderr,"ERROR:ǰIDꥹȤϤեκ˼\n") ;
        return 1;
      }
      dct = 0 ;
      cp = buff ;
      while( gets(cp) != NULL ){
          if ( strncmp( buff, "Copyright", 9) == 0 ) {
            continue ;
	  }
          for ( sp = cp ; *sp != '\0' ; sp++) {
            if ( *sp == '\\' && *(sp+1) == '\0') {
              cp = sp ;
              break ;
            }
          }
          if ( cp == sp )
            continue ;
          cp = buff ;

          if ( strncmp( buff, "JCO", 3) != 0 ) {
            fprintf( stderr, "ERROR(CreateJCO):[%s]\n",buff ) ;
            continue ;
	  }
          dct++ ;
          if (( dct % 10000 ) == 0 ) {
            fprintf(stderr, "Put %d   \n",dct) ;
            //system("date") ;
          }
          //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
          rid = PutJCorpRec( JCORPRecId2Val, buff) ;
          if ( rid < 0 ) {
            fprintf( stderr, "Ͽʤä[%s]\n",buff ) ; 
            continue ;
          }
      }

      JCorpus_DB_Close() ;

      fclose( Hfp ) ;
      fclose( Cfp ) ;

      ret = JCorpus_IX_Open() ;

      /*** ɽǥå ***/
      fprintf(stderr, "ɽǥå    ...\r");
      msort(HFileName, WFileName);
      ret = Create_HIX( WFileName ) ;
      if ( ret < 0 )
         return 1 ;
      remove(HFileName);
      
      /*** ǰǥå ***/
      fprintf(stderr, "ǰǥå    ...\r");
      msort(CFileName, WFileName);
      ret = Create_CIX( WFileName ) ;
      if ( ret < 0 )
         return 1 ;
      remove(CFileName);
      remove(WFileName);

      JCorpus_IX_Close() ;
      
      return 0 ;
}




/* ܸ쥳ѥɽǥåϿ */
int Create_HIX( char *file )
{
  int    ret ;
  int    rid ;
  int    dct, wct, tb ;
  unsigned char   buff[1024] ; 
  char   *bptr[64] ;
  char   save[1024], work[500000] ;
  int    jcat ;
  FILE   *fp ;


      if ( ( fp = fopen( file, "r" )) == NULL ) {
         fprintf( stderr,"Cannot open work file[%s]\n", file ) ;
         return -1;
      }

      dct = 0 ;
      save[0] = '\0' ;
      wct = 0 ;
      while( fgets(buff, 1024, fp) != NULL ){ /* ɽꥹϿѥեɤ߹*/
          //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
          dct++ ;
          if (( dct % 100000 ) == 0 ) 
            fprintf(stderr, "Put %d   \n",dct) ;
          tb = split1( '\t', buff, bptr ) ;
          if ( save[0] == '\0' || strcmp( bptr[0], save) == 0 ) {
            if ( wct >= 500000 ) {
              fprintf(stderr,"ERROR:work is too small! (word=[%s])\n",bptr[0]) ;
              continue ;
            }
            work[wct] = GetJCorpPoSID( bptr[1] ) ;
            rid = atoi( bptr[2] ) ;
            put4byte( rid, &work[ wct+1] ) ;
            wct += 5 ;
            if ( save[0] == '\0' )
              strcpy( save, bptr[0] ) ;
            continue ;
          }
          if ( wct >= 10000 ) {
            fprintf(stderr,"WORD[%s] record_count=%d\n",save,wct/5) ;
          }
          ret = Put_IXT( HDWD2JCORPRecID, save, strlen( save ), work, wct) ;
          if ( ret < 0 ) {
            fprintf(stderr,"ERROR(Put_IXT): word=[%s]\n",save) ;
          }
          strcpy( save, bptr[0] ) ;
          wct = 0 ;
          work[wct] = GetJCorpPoSID( bptr[1] ) ;
          rid = atoi( bptr[2] ) ;
          put4byte( rid, &work[ wct+1 ] ) ;
          wct += 5 ;
      }
      ret = Put_IXT( HDWD2JCORPRecID, save, strlen( save ), work, wct) ;
      if ( ret < 0 ) {
        fprintf(stderr,"ERROR(Put_IXT): word=[%s]\n",save) ;
      }

      fclose(fp) ;
      return 1 ;
}




/* ܸ쥳ѥɽǥåϿ */
int Create_CIX( char *file )
{
  int    ret ;
  int    rid ;
  int    dct, wct, tb ;
  unsigned char   buff[1024] ; 
  char   *bptr[64] ;
  char   save[1024], work[500000] ;
  int    jcat ;
  FILE   *fp ;


      if ( ( fp = fopen( file, "r" )) == NULL ) {
         fprintf( stderr,"Cannot open work file[%s]\n", file ) ;
         return -1;
      }


      dct = 0 ;
      save[0] = '\0' ;
      wct = 0 ;
      while( fgets(buff, 1024, fp) != NULL ){      /* ǰIDꥹϿѥեɤ߹ */
          //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
          dct++ ;
          if (( dct % 100000 ) == 0 ) 
            fprintf(stderr, "Put %d   \n",dct) ;
          tb = split1( '\t', buff, bptr ) ;
          if ( save[0] == '\0' || strcmp( bptr[0], save) == 0 ) {
            if ( wct >= 500000 ) {
              fprintf(stderr,"ERROR:work is too small! (word=[%s])\n",bptr[0]) ;
              continue ;
            }
            rid = atoi( bptr[1] ) ;
            put4byte( rid, &work[ wct ] ) ;
            wct += 4 ;
            if ( save[0] == '\0' )
              strcpy( save, bptr[0] ) ;
            continue ;
          }
          /*
          if ( wct >= 8000 ) {
            fprintf(stderr,"CID[%s] record_count=%d\n",save,wct/4) ;
          }
          */
          ret = Put_IXT( CHID2JCORPRecID, save, strlen( save ), work, wct) ;
          if ( ret < 0 ) {
            fprintf(stderr,"ERROR(Put_IXT): word=[%s]\n",save) ;
          }
          strcpy( save, bptr[0] ) ;
          wct = 0 ;
          rid = atoi( bptr[1] ) ;
          put4byte( rid, &work[ wct ] ) ;
          wct += 4 ;
      }
      if ( wct >= 8000 ) {
        fprintf(stderr,"WORD[%s] record_count=%d\n",save,wct/4) ;
      }
      ret = Put_IXT( CHID2JCORPRecID, save, strlen( save ), work, wct) ;
      if ( ret < 0 ) {
        fprintf(stderr,"ERROR(Put_IXT): word=[%s]\n",save) ;
      }
     
      return 1 ;

}






