#include <stdio.h>
#include <stdlib.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "edrcorp.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/


int PutCORPLOG( char *com, char dict, int rid, int fd ) ;

/* ܸ쥳ѥ  */
void
main(int argc,  char **argv)
{
      int    ret, rid, mode ;
      unsigned char   buff[32768] ; 
      unsigned char   value[32768] ; 
      unsigned char   etcv[32768] ; 
      char  form[8] ;
      char  *cp ;
      int   vct, ect ;

      InitEdrTbl() ;
      
      ret = JCorpus_DB_Open() ;
      if ( ret < 0 ) 
        return ;

      rid = mode = -1 ;
      vct = ect = 0 ;
      while( gets(buff) != NULL ){  /* ǡ */
                                    /* mode: °̾Ф( < 0 礢) */
                                    /* value[0->vct]: °ͤޤ */
        if ( buff[0] == '\0' ) {    /* ԤǥǡγǼ򤹤 */
          if ( mode < 0 )
            mode = (-1)*mode ;
          ret = PutValue( form,  rid, mode, value, vct, etcv, ect ); 
          vct = ect = 0 ;
          rid = -1 ;
          continue ;
        }
        cp = skip_non_sp( buff ) ;
        if ( *cp == '%' ) { /* °̾ */
          if ( mode < 0 )
            mode = (-1)*mode ;
          if ( mode == RECORD_ID ) { /* ޤǤɤ߹ߤ쥳ֹξ */
            rid = GetRecordID(value,form) ;
          }
          ret = PutValue( form,  rid, mode, value, vct, etcv, ect ); 
          mode = Field_Type( cp ) ;
          if ( mode == RECORD_ID ) {
            rid = -1 ;  /* ֤˶ԤʤƤɤ */
          }
          else if ( mode == -1 || rid == -1 ) {
            ret = Print_ErrorSkip( cp, value, vct) ;
            if ( ret == 0 ) /* if EOF */
              break ;
            mode = ret ;
            rid = -1 ;
	  }
          vct = ect = 0 ;
          continue ;
	}
        if ( *cp == '#' ) { /* °Ф */
          mode *= (-1) ;  
          continue ;
        }
        if ( mode < 0 ) {
          if ( strlen(cp) + ect >= 32768 ) {
            fprintf(stderr,"ERROR: work buffer is too small!\n") ;
            ret = Print_ErrorSkip( cp, etcv, ect) ;
            if ( ret == 0 ) /* if EOF */
              break ;
            mode = ret ;
            rid = -1 ;
            vct = ect = 0 ;
            continue ;
          }
          strcpy( &etcv[ect], cp ) ;
          ect += strlen( cp ) + 1 ;
        }
        else {
          if ( strlen(cp) + vct >= 32768 ) {
            fprintf(stderr,"ERROR: work buffer is too small!\n") ;
            ret = Print_ErrorSkip( cp, value, vct) ;
            if ( ret == 0 ) /* if EOF */
              break ;
            mode = ret ;
            rid = -1 ;
            vct = ect = 0 ;
            continue ;
          }
          strcpy( &value[vct], cp ) ;
          vct += strlen( cp ) + 1 ;
        }
      }
      if ( vct != 0 || ect != 0 ) {
        if ( mode < 0 )
          mode = (-1)*mode ;
        ret = PutValue( form,  rid, mode, value, vct, etcv, ect );
      }
      JCorpus_DB_Close() ;
}


/* °̾ФͤγǼ */
int PutValue( char *form,  int rid, int mode, char *value, int vct, char *etcval, int ect)
{
  char buff[16384] ;
  char old[32768] ;
  int  ii ;
  int  len, ret ;

  if ( rid == -1 )
    return 0 ;

  if ( mode == RECORD_ID )
    return 1 ;
  if ( rid < 1000000 ) {  /** EDR FORMAT ***/
    if ( mode == WORD_INFO ) {   /* Ǿ */
      len = UpWordList( buff, value, vct ) ;  /* ǡ */
      ClearIXEDRJCorp( rid) ;                 /* ǥåĶ(ɣغ */
                                 /* ֹ ɽ ɽ ʻ ǰγǼ */
      PutJCorpProp( JCORPRecId2Val, rid, "wd", buff, len, etcval, ect ) ; 
      SetIXEDRJCorp( rid) ;                   /* ǥåĶ(ɣغ */
      PutCORPLOG( "UPD", 'J', rid, mode ) ;
      return ret ;
    }
    if ( mode == GOGIRI_INFO ) {  /* Ǿ */
      len = Gogiri( buff, value, vct ) ;
      PutJCorpProp( JCORPRecId2Val, rid, "gg",  buff, strlen(buff)+1, etcval, ect) ;
      PutCORPLOG( "UPD", 'J', rid, mode ) ;
      return len ;
    }
    if ( mode == KOBUN_INFO ) {  /* ʸھ */
      len = KobunSEX( buff, value, vct ) ;
      PutJCorpProp( JCORPRecId2Val, rid, "st",  buff, len, etcval, ect) ;
      PutCORPLOG( "UPD", 'J', rid, mode ) ;
      return len ;
    }
    if ( mode == IMI_INFO ) {    /* ̣ե졼 γǼ */
      len = ImiSEX( buff, value, vct ) ;
      PutJCorpProp( JCORPRecId2Val, rid, "im",  buff, len, etcval, ect) ;
      PutCORPLOG( "UPD", 'J', rid, mode ) ;
      return len ;
    }
    if ( mode == TEXT_ID  ||  /* ƥֹ */
         mode == FROM_INFO || /* ŵ */
         mode == TEXT_STR ) { /* ʸ */
      len = CreTextInfo( buff, rid, mode, value, vct ) ; 
      PutJCorpProp( JCORPRecId2Val, rid, "bu", buff, len, "", 0) ; /* ƥֹ\0ŵ\0ʸ γǼ */
      PutCORPLOG( "UPD", 'J', rid, mode ) ;
      return len ;
    }
    if ( mode == REC_ETC ) { /*  */
      len = CreRecETC( buff, value, vct, 16384, form ) ;
      PutJCorpRETC( JCORPRecId2Val, rid, buff ) ; /* γǼ */
      PutCORPLOG( "UPD", 'J', rid, mode ) ;
      return ret ;
    }
  } else { /*** TEI FORMAT ***/
    if ( mode == TEI_HEADER ) {   /* teiHeader */
      len = CatTag( buff, value, vct ) ;  /* ǡ */
      PutJCorpProp( JCORPRecId2Val, rid, "th", buff, len, "", 0 ) ; 
      PutCORPLOG( "UPD", 'T', rid, mode ) ;
      return ret ;
    }
    if ( mode == TEI_TEXT ) {   /* teiText */
      len = CatTag( buff, value, vct ) ;  /* ǡ */
      PutJCorpProp( JCORPRecId2Val, rid, "tt", buff, len, "", 0 ) ; 
      PutCORPLOG( "UPD", 'T', rid, mode ) ;
      return ret ;
    }
    if ( mode == TEI_HINDEX ) {   /* teiHIndex */
      len = IxHWordList( buff, value, vct ) ;  /* ǡ */
      ClearIXTEICorp( rid) ;                 /* ǥåĶ(ɣغ */
      PutJCorpProp( JCORPRecId2Val, rid, "ti", buff, len, "", 0 ) ; 
      SetIXTEICorp( rid) ;                   /* ǥåĶ(ɣغ */
      PutCORPLOG( "UPD", 'T', rid, mode ) ;
      return ret ;
    }

  }
  return 1; 
}



int GetRecordID(char *value, char *form)
{
  int rid ;
  //printf("(GetRecordID):value=[%s]\n",value) ;

  if ( strncmp( value, "JCO", 3 ) == 0 ) {
    strcpy(form, "EDR") ;
    *(form+3) = '\0' ;
    return atoi( value+3 ) ;
  }
  strcpy(form, "TEI") ;
  *(form+3) = '\0' ;
  rid = atoi( value ) ;
  if ( rid < 1000000 ) {
    fprintf(stderr,"ERROR(GetRecordID):FORMAT ERROR!\n") ;
    return -1 ;
  }
  return ( rid ) ;
}



int Field_Type( char *buff )
{
  if ( strcmp( buff, "%%%쥳ֹ%%%") == 0 )
    return  RECORD_ID ;
  if ( strcmp( buff, "%%%ƥֹ%%%") == 0 )
    return  TEXT_ID ;
  if ( strcmp( buff, "%%%ŵ%%%") == 0 )
    return  FROM_INFO ;
  if ( strcmp( buff, "%%%ʸ%%%") == 0 )
    return  TEXT_STR ;
  if ( strcmp( buff, "%%%Ǿ%%%") == 0 )
    return  WORD_INFO ;
  if ( strcmp( buff, "%%%Ǿ%%%") == 0 )
    return  GOGIRI_INFO ;
  if ( strcmp( buff, "%%%ʸ%%%") == 0 )
    return  KOBUN_INFO ;
  if ( strcmp( buff, "%%%̣%%%") == 0 )
    return  IMI_INFO ;
  if ( strcmp( buff, "%%%%%%") == 0 )
    return  REC_ETC ;
  if ( strcmp( buff, "%%%teiHeader%%%") == 0 )
    return  TEI_HEADER ;
  if ( strcmp( buff, "%%%teiText%%%") == 0 )
    return  TEI_TEXT ;
  if ( strcmp( buff, "%%%keywords%%%") == 0 )
    return  TEI_HINDEX ;

  fprintf(stderr,"ERROR:°̾ǧޤ\n") ;
  fprintf(stderr,"      °̾:[%s]\n",buff) ;
  return -1 ;
}




int  UpWordList( char *buff, char *value, int vct ) 
{
  int    ii, jj, len, ct, nct ;
  short  wid ;
  unsigned char jcat ;
  char   *cp = buff ;
  char   *ary[64] ;


  cp = buff+2 ;
  ct = 2 ;
  nct = 0 ;
  for( ii = 0 ; ii < vct ; ii += len +1 ) {
    strcpy( cp, &value[ii] ) ;
    len = strlen( &value[ii] ) ;
    jj = split1( '\t', &value[ii], ary ) ;

    if ( *ary[0] == 'I' )
      wid = (-1) * atoi( ary[0] + 2 ) ;
    else 
      wid = atoi( ary[0] ) ;
    jcat = GetJCorpPoSID( ary[3] ) ;
    if ( jcat == 255 ) {
      fprintf(stderr,"ERROR(UpWordList): ʻ[%s]ϡͤǤ\n",ary[3] ) ;
      return ( -1 ) ;
    }
    /* ΡɾΥ׻ */
    jj = 2 + strlen( ary[1] ) + strlen( ary[2] ) + 1 + strlen( ary[4] ) + 3 ;
    if ( (ct + jj ) >= 16386 ) {
      fprintf(stderr,"ERROR(UpWordList): Work buffer is too small!\n") ;
      return ( -1 ) ;
    }
    put2byte( wid, cp ) ; /* ֹ楻å */
    *(cp+2) = jcat ;      /* ʻ쥻å */
    sprintf( cp+3, "%s\t%s\t%s",ary[1],ary[2],ary[4]) ;
    cp += jj  ;
    ct += jj  ;
    nct++ ;
  }
  put2byte( nct, buff ) ; /* ֹ楻å */
  return (cp - buff) ;
}



int  Gogiri( char *buff, char *value, int vct ) 
{
  int ret ;
  int ii, len ;
  char work[2048], *cp ;

  cp = work ;
  for( ii = 0 ; ii < vct ; ii += len +1 ) {
    strcpy( cp, value+ii ) ;
    len = strlen( value+ii ) ;
    cp += len ;
  }
  ret = IgouseiStr( buff, work ) ;
  return ( ret ) ;
}



int  KobunSEX( char *buff, char *value, int vct ) 
{
  int ii ;
  char *cp = buff ;

  for( ii = 0 ; ii < vct ; ii++ ) {
    if ( value[ii] == '\0' )
      continue ;
    if ( cp != buff && value[ii] == '(' ) {
      for(  ; cp != buff ; cp-- ) {
        if ( *(cp - 1) != ' ') 
          break ;
      }
    }
    *cp = value[ii] ;
    cp++ ;
  }
  *cp = '\0';
  cp++ ;
  return (cp - buff) ;
}


int  ImiSEX( char *buff, char *value, int vct ) 
{
  int ii ;
  char *cp = buff ;

  for( ii = 0 ; ii < vct ; ii++ ) {
    if ( value[ii] == '\0' )
      continue ;
    if ( cp != buff && value[ii] == '[' ) {
      for(  ; cp != buff ; cp-- ) {
        if ( *(cp - 1) != ' ')
          break ;
      }
      if ( *(cp - 1) != '[' && *(cp - 1) != ']' ) {
        *cp = ' ' ; cp++ ;
      }
    }
    *cp = value[ii] ;
    cp++ ;
  }
  *cp = '\0';
  cp++ ;
  return (cp - buff) ;
}





int CreRecETC( char *buff, char *value, int vct, int size, char *form ) 
{
  int len ;
  char work[32] ;

  strcpy(buff,value) ;
  strcpy( work, "FORM=" ) ;
  strcpy( &work[5], form ) ;
  len = UpdSubInfo( buff, work, size ) ;
  return ( len ) ;
}


int Print_ErrorSkip(char *buff, char *value, int vct) 
{
  int  ii, mode ;

  fprintf( stderr,"----- ERROR -----\n") ;
  for( ii = 0 ; ii < vct ; ii += strlen( &value[ii] ) +1 ) {
    fprintf( stderr, "ignore(%d):%s\n", ii, &value[ii]) ;
  }
  fprintf( stderr, "IGNORE:%s\n", buff ) ;
  while( gets(buff) != NULL ){  /* ǡ */
    if ( buff[0] == '\0' ) 
      return -1 ;
    if ( buff[0] == '<' ) { /* °̾ */
      mode = Field_Type(buff) ;
      if ( mode == RECORD_ID ) 
        return mode ;
    }
    fprintf( stderr, "ignore:%s\n", buff ) ;
  }
  return 0 ;
}





/* ѥǡ Ǽ */
int PutCORPLOG( char *com, char dict, int rid, int fd )
{
  int bdate, dhash ;
  int ret ;
  char work[1024] , *user ;
  int  len ;
  
  bdate = PackNowDateI() ;
  dhash = ConvPackDate2B( bdate ) ;

  strcpy( work, com ) ; len = strlen(com) ;
  work[len++] = '\t' ;
  if ( dict == 'J' )
    sprintf(&work[len], "JCO%07d\t", rid) ;
  else if ( dict == 'E' )
    sprintf(&work[len], "ECO%07d\t", rid) ;
  else 
    sprintf(&work[len], "TEI%07d\t", rid) ;

  len += strlen(&work[len]) ;
  switch ( fd ) {
    case TEXT_ID :
      strcpy( &work[len], "<ƥֹ>\t" ) ;
      break ;
    case FROM_INFO :
      strcpy( &work[len], "<ŵ>\t") ;
      break ;
    case TEXT_STR :
      strcpy( &work[len], "<ʸ>\t") ;
      break ;
    case WORD_INFO :
      strcpy( &work[len], "<Ǿ>\t") ;
      break ;
    case GOGIRI_INFO :
      strcpy( &work[len], "<Ǿ>\t") ;
      break ;
    case KOBUN_INFO :
      strcpy( &work[len], "<ʸ>\t") ;
      break ;
    case IMI_INFO :
      strcpy( &work[len], "<̣>\t") ;
      break ;
    case REC_ETC :
      strcpy( &work[len], "<>\t") ;
      break ;
    case TEI_HEADER:
      strcpy( &work[len], "<teiHeader>\t") ;
      break ;
    case TEI_TEXT:
      strcpy( &work[len], "<teiText>\t") ;
      break ;
    case TEI_HINDEX:
      strcpy( &work[len], "<keywords>\t") ;
      break ;
  }

  len += strlen(&work[len]) ;
  user = getenv( "USER" ) ;
  strcpy( &work[len], user ); len += strlen(user) ;
  work[len++] = '\0' ;
    
  ret = Add_IXT_DATAV( UpdLogCorp, (char *)&dhash, 4, work , len) ;
  printf("Key=%x      UpdateInfo.=[%s]\n", bdate, work) ; 
  return ret ;
}



