#include <stdio.h>
#include <stdlib.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/


/* ʥ롼ףɣĤγ */
int  GetNewGroup()
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL) {
    fprintf(stderr,"ERROR(GetNewGroup):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return -1 ;
  }
  ret = Get_IXT( ControlDB , "GROUP_ID", strlen( "GROUP_ID" ) , work, 128 ) ;
  ans = *(int *)work ;
  val = ans+1 ;
  ret = Put_IXT( ControlDB , "GROUP_ID", strlen( "GROUP_ID" ) , (char *)&val, sizeof(int) ) ;
  return ans ;
}



/* ñ켭쥳ɣɣĤγ */
int  GetNewWordRID()
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(GetNewWordRID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return -1 ;
  }
  ret = Get_IXT( ControlDB , "WORD_RID", strlen( "WORD_RID" ) , work, 128 ) ;
  ans = *(int *)work ;
  val = ans +1 ;
  ret = Put_IXT( ControlDB , "WORD_RID", strlen( "WORD_RID" ) , (char *)&val, sizeof(int) ) ;
  return ans ;
}



/* ʳǰФ쥳ɣɣĤγ */
int  GetNewCPHRID()
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(GetNewCPHRID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return -1 ;
  }
  ret = Get_IXT( ControlDB , "CPH_RID", strlen( "CPH_RID" ) , work, 128 ) ;
  ans = *(int *)work ;
  val = ans +1 ;
  ret = Put_IXT( ControlDB , "CPH_RID", strlen( "CPH_RID" ) , (char *)&val, sizeof(int) ) ;
  return ans ;
}

int  SetMaxCPHRID(int rid)
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(SetMaxCPHRID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return 0;
  }
  ret = Get_IXT( ControlDB , "CPH_RID", strlen( "CPH_RID" ) , work, 128 ) ;
  ans = *(int *)work ;
  if ( rid < ans )
    return 1 ;
  ans = rid ;
  val = ans +1 ;
  ret = Put_IXT( ControlDB , "CPH_RID", strlen( "CPH_RID" ) , (char *)&val, sizeof(int) ) ;
  return ans ;
}




/* ʳǰηϥ쥳ɣɣĤγ */
int  GetNewCPCRID()
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(GetNewCPCRID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return 0;
  }
  ret = Get_IXT( ControlDB , "CPC_RID", strlen( "CPC_RID" ) , work, 128 ) ;
  ans = *(int *)work ;
  val = ans +1 ;
  ret = Put_IXT( ControlDB , "CPC_RID", strlen( "CPC_RID" ) , (char *)&val, sizeof(int) ) ;
  return ans ;
}

int  SetMaxCPCRID(int rid)
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(SetMaxCPCRID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return 0;
  }
  ret = Get_IXT( ControlDB , "CPC_RID", strlen( "CPC_RID" ) , work, 128 ) ;
  ans = *(int *)work ;
  if ( rid < ans )
    return 1 ;
  ans = rid ;
  val = ans +1 ;
  ret = Put_IXT( ControlDB , "CPC_RID", strlen( "CPC_RID" ) , (char *)&val, sizeof(int) ) ;
  return ans ;
}


/* ʳǰҥ쥳ɣɣĤγ */
int  GetNewCPTRID()
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(GetNewCPTRID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return 0;
  }
  ret = Get_IXT( ControlDB , "CPT_RID", strlen( "CPT_RID" ) , work, 128 ) ;
  ans = *(int *)work ;
  val = ans +1 ;
  ret = Put_IXT( ControlDB , "CPT_RID", strlen( "CPT_RID" ) , (char *)&val, sizeof(int) ) ;
  return ans ;
}

int  SetMaxCPTRID(int rid)
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(SetMaxCPTRID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return 0;
  }
  ret = Get_IXT( ControlDB , "CPT_RID", strlen( "CPT_RID" ) , work, 128 ) ;
  ans = *(int *)work ;
  if ( rid < ans )
    return 1 ;
  ans = rid ;
  val = ans +1 ;
  ret = Put_IXT( ControlDB , "CPT_RID", strlen( "CPT_RID" ) , (char *)&val, sizeof(int) ) ;
  return ans ;
}


/* ܸͿ뿷ʳǰɣĤγ */
int  GetNewBasicCID()
{
  int val, ret, ans ;
  int limit ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(GetNewBasicCID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return 0;
  }
  ret = Get_IXT( ControlDB , "CP_B_T_ID", strlen( "CP_B_T_ID" ) , work, 128 ) ;
  limit = *(int *)work ;

  ret = Get_IXT( ControlDB , "CP_B_F_ID", strlen( "CP_B_F_ID" ) , work, 128 ) ;
  ans = *(int *)work ;
  val = ans+1 ;
  if ( val > limit ) {
    fprintf( stderr,"ERROR(GetNewBasicCID): ʳǰɣĤͿ뤳ȤǤޤǤ\n") ;
    fprintf( stderr,"ERROR(GetNewBasicCID): 󶡤복ǰɣĤϰϤꤷƤ\n") ;
    return -1 ;
  }
  ret = Put_IXT( ControlDB , "CP_B_F_ID", strlen( "CP_B_F_ID" ) , (char *)&val, sizeof(int) ) ;
  return ans ;
}


/* ѸͿ뿷ʳǰɣĤγ */
int  GetNewTechCID()
{
  int val, ret, ans ;
  int limit ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(GetNewTechCID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return 0;
  }
  ret = Get_IXT( ControlDB , "CP_T_T_ID", strlen( "CP_T_T_ID" ) , work, 128 ) ;
  limit = *(int *)work ;

  ret = Get_IXT( ControlDB , "CP_T_F_ID", strlen( "CP_T_F_ID" ) , work, 128 ) ;
  ans = *(int *)work ;
  val = ans+1 ;
  if ( val > limit ) {
    fprintf( stderr,"ERROR(GetNewBasicCID): ʳǰɣĤͿ뤳ȤǤޤǤ\n") ;
    fprintf( stderr,"ERROR(GetNewBasicCID): 󶡤복ǰɣĤϰϤꤷƤ\n") ;
    return -1 ;
  }
  ret = Put_IXT( ControlDB , "CP_T_F_ID", strlen( "CP_T_F_ID" ) , (char *)&val, sizeof(int) ) ;
  return ans ;
}

/* ==================================================  Υ쥳ID ===*/



/* Υ롼ףɣĤγ */
int  NextNewGroup()
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL) {
    fprintf(stderr,"ERROR(NextNewGroup):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return -1 ;
  }
  ret = Get_IXT( ControlDB , "GROUP_ID", strlen( "GROUP_ID" ) , work, 128 ) ;
  ans = *(int *)work ;
  return ans ;
}



/* ñ켭쥳ɣɣĤγ */
int  NextNewWordRID()
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(NextNewWordRID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return -1 ;
  }
  ret = Get_IXT( ControlDB , "WORD_RID", strlen( "WORD_RID" ) , work, 128 ) ;
  ans = *(int *)work ;
  return ans ;
}



/* γǰФ쥳ɣɣĤγ */
int  NextNewCPHRID()
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(NextNewCPHRID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return -1 ;
  }
  ret = Get_IXT( ControlDB , "CPH_RID", strlen( "CPH_RID" ) , work, 128 ) ;
  ans = *(int *)work ;
  return ans ;
}



/* γǰηϥ쥳ɣɣĤγ */
int  NextNewCPCRID()
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(NextNewCPCRID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return -1 ;
  }
  ret = Get_IXT( ControlDB , "CPC_RID", strlen( "CPC_RID" ) , work, 128 ) ;
  ans = *(int *)work ;
  return ans ;
}


/* γǰҥ쥳ɣɣĤγ */
int  NextNewCPTRID()
{
  int val, ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(NextNewCPTRID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return -1 ;
  }
  ret = Get_IXT( ControlDB , "CPT_RID", strlen( "CPT_RID" ) , work, 128 ) ;
  ans = *(int *)work ;
  return ans ;
}


/* ܸͿ뼡γǰɣĤγ */
int  NextNewBasicCID()
{
  int val, ret, ans ;
  int limit ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(NextNewBasicCID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return -1 ;
  }
  ret = Get_IXT( ControlDB , "CP_B_T_ID", strlen( "CP_B_T_ID" ) , work, 128 ) ;
  limit = *(int *)work ;

  ret = Get_IXT( ControlDB , "CP_B_F_ID", strlen( "CP_B_F_ID" ) , work, 128 ) ;
  ans = *(int *)work ;
  val = ans+1 ;
  if ( val > limit ) {
    fprintf( stderr,"ERROR(NextNewBasicCID): γǰɣĤͿ뤳ȤǤޤǤ\n") ;
    return -1 ;
  }
  return ans ;
}


/* ѸͿ뼡γǰɣĤγ */
int  NextNewTechCID()
{
  int val, ret, ans ;
  int limit ;
  char work[128] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr,"ERROR(NextNewTechCID):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return -1 ;
  }
  ret = Get_IXT( ControlDB , "CP_T_T_ID", strlen( "CP_T_T_ID" ) , work, 128 ) ;
  limit = *(int *)work ;

  ret = Get_IXT( ControlDB , "CP_T_F_ID", strlen( "CP_T_F_ID" ) , work, 128 ) ;
  ans = *(int *)work ;
  val = ans+1 ;
  if ( val > limit ) {
    fprintf( stderr,"ERROR(NextNewBasicCID): γǰɣĤͿ뤳ȤǤޤǤ\n") ;
    fprintf( stderr,"ERROR(NextNewBasicCID): 󶡤복ǰɣĤϰϤꤷƤ\n") ;
    return -1 ;
  }
  return ans ;
}



/* ==================================================  ȥģ¤ ===*/


int  SetControlDB(char *prop, int val)
{
  int  ret, ans ;
  char work[128] ;

  if ( ControlDB == NULL) {
    fprintf(stderr,"ERROR(SetControlDB):ȥ󤬳Ǽ줿ģ¤ץ󤵤Ƥޤ\n") ;
    return -1 ;
  }
  ret = Get_IXT( ControlDB , prop, strlen( prop ) , work, 128 ) ;
  if ( ret > 0 ) {
    ans = *(int *)work ;
    fprintf(stderr,"°[%s]θͤϡ[%d]\n", prop, ans ) ;
  }
  else {
    fprintf(stderr,"°[%s]θͤϡ¸ߤʤ\n" ) ;
  }
  fprintf(stderr,"°[%s]ͤ[%d]ꡣ\n", val ) ;

  ret = Put_IXT( ControlDB , prop, strlen( prop ) , (char *)&val, sizeof(int) ) ;
  return ans ;
}
