#include <stdio.h>
#include <fcntl.h>

#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/

/****************************************************************
    ţģҷγǰФ˴ؤؿ
****************************************************************/




/****************************************************************
*   Ǽ쥳ɺ
*   USAGE:		CreateCphRec( char *indata, char *outdata, int size, char **ptr)
*   SYNOPSIS:		char  *indata  (IN)   ǰФʣţģҼ
*                       char  *outdata (OUT)  쥳ɳǼ
*                       int   size            쥳ɳǼΥ
*                       char  **ptr    (OUT)  ƥեɤγǼݥ
*
*   DESCRIPTION:	
*	ţģҷΥǡ顢ģ¤˳Ǽ쥳ɤ롣
*       ʲǼ쥳ɤΥեɹǤ롣
*       ƥեɤΥɥ쥹裴˥åȤ롣
*       裴ϥեɤοʬǤɬ
*        | Rec-ID | ǰID\0 | ǰФ(E)\0 |
*        |  (4)   | (n)      | (n)             |
*
*        | ǰФ(J)\0 | ǰ(E)\0 | ǰ(J) | \0 |
*        | (n)             | (n)           | (n)    )    | (n)        |
*
*
*   RETURN:		record size
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  CreateCphRec( char *str, char *out, int size)
{
  char buff2[16386] ;
  char dict[8], rnum[12] ;
  int  Rid = -1, Cid ;
  char  *bptr[64] ;
  int  tb, ret, len ,hdlen;
  unsigned char Lcon, Rcon, JPoS ;
  char *st = out ;

  tb = split1( '\t', str, bptr ) ;
  len = strlen(bptr[1]) + strlen(bptr[2]) + strlen(bptr[3]) + strlen(bptr[4])
       + strlen(bptr[5]) + strlen(bptr[6]) + 6 + 4;
  if ( size <= len ) {
    return ( -1 ) ;
  }
  Rid = GetCode2Wid( bptr[0], dict, rnum) ;
  /*
  *if ( dict[0] == '\0' && rnum[0] == '\0' ) {
  *  return ( -1 ) ;
  *}
  */

  //printf("dict=[%s],rnum=[%s],  Rid=[%d]\n",dict,rnum,Rid);
  *(int *)out = Rid ;
  out += 4 ;
  strcpy( out, bptr[1] ) ; out += strlen(bptr[1]) + 1 ;
  strcpy( out, bptr[2] ) ; out += strlen(bptr[2]) + 1 ;
  strcpy( out, bptr[3] ) ; out += strlen(bptr[3]) + 1 ;
  strcpy( out, bptr[4] ) ; out += strlen(bptr[4]) + 1 ;
  strcpy( out, bptr[5] ) ; out += strlen(bptr[5]) + 1 ;
  strcpy( out, bptr[6] ) ; out += strlen(bptr[6]) + 1 ;
  return ( len ) ;
}





/****************************************************************
*   Ǽ쥳 եɥݥ
*   USAGE:		StartPtsCPH( char *rec, int len, char **cary)
*   SYNOPSIS:		char  *rec    (IN)   ܸñ켭Ǽ쥳
*                       int   len     (IN)   쥳ɤΥ
*                       char  **cary  (OUT)  ƥեɤγǼݥ
*
*   DESCRIPTION:	
*	γƥեɤƬݥ󥿤ᡢ裳
*       ˥åȤ롣
*       ꥿ͤϤǿ
*
*        | Rec-ID | ǰID\0 | ǰФ(E)\0 |    
*        |  (4)   | (n)      | (n)             |  
*                                                   
*        | ǰФ(J)\0 | ǰ(E)\0 | ǰ(J) | \0 |  
*        | (n)             | (n)           | (n)         | (n)        |  
*
*   RETURN:		եɿ
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int StartPtsCPH(char *rec, int len, char **cary) 
{
  int   ii ;

  cary[0] = rec ;     /* Rec-ID */
  cary[1] = rec+4 ;   /* Concept-ID */
  rec = rec + 4 + strlen(cary[1]) +1;
  cary[2] = rec ;     /* ǰФE */
  rec = rec + strlen(cary[2]) +1;
  cary[3] = rec ;     /* ǰФ(J) */
  rec = rec + strlen(cary[3]) +1;
  cary[4] = rec ;     /* ǰ(E) */
  rec = rec + strlen(cary[4]) +1;
  cary[5] = rec ;     /* ǰ(J) */
  rec = rec + strlen(cary[5]) +1;
  cary[6] = rec ;     /* (1) */
  ii = 7 ;
  while(1) {
    rec = skip_ptr( ';', rec ) ;
    if (rec == NULL) {
      break ;
    }
    rec = skip_non_sp( rec +1 ) ;
    if (rec == NULL) {
      break ;
    }
    cary[ii++] = rec ;     /* ݻii */
  }
  return ii ;
}







