/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  EfuncPosi[]= {
	{ "ENPPREN",	 "̾	Always precedes another noun" },
	{ "ENPPOSTN",	 "̾θ	Always follows another noun" },
	{ "EAUPR",	 "ˡΤ	Predicative usage only" },
	{ "EAUPREN",	 "ˡΤߤǡ̾	Attributive usage only and always precedes a noun              " },
	{ "EAUPOSTN",	 "ˡΤߤǡ̾θ	Attributive usage only and always follows a noun" },
	{ "ETWINF",	 "괧ֲ	May follow an indefinite article" },
	{ "ETNODEF",	 "괧Բ	May not follow a definite article" },
	{ "ETMCSG",	 "Ļ̾ñˤĤ	May be followed by a countable singular noun" },
	{ "ETMCPL",	 "Ļ̾ʣˤĤ	May be followed by a countable plural noun" },
	{ "ETMU",	 "Ļ̾ˤĤ	May be followed by an uncountable noun" },
	{ "ETMINFN",	 "괧ȼֲ̾	May be followed by a noun phrase beginning with an indefinite article" },
	{ "ETMDEFN",	 "괧ȼֲ̾	May be followed by a noun phrase beginning with a definite article" },
	{ "EDPT",	 "̡	Always occurs before the subject" },
	{ "EDPM",	 "̡ưľޤ be ưľ	Always occurs before main verb or immediately  after be verb" },
	{ "EDPE",	 "̡Ū졦θ塢ʤưľ	Always occurs after the object or complement - If no object or complement after the verb" },
	{ "EDMV",	 "ư򽤾	Verb modifier" },
	{ "EDMADJ",	 "ƻ򽤾	Adjective modifier" },
	{ "EDMADV",	 "򽤾	Adverb modifier" },
	{ "EDMPP",	 "ֻ򽤾	Preposition phrase modifier" },
	{ "EDMQU",	 "̾졦򽤾	Indefinite pronoun /numerical modifier" },
	{ "EDMN",	 "̾ (  ) 򽤾	Noun (phrase) modifier" },
	{ "EDMS",	 "ʸ򽤾	Sentence modifier" },
	{ NULL,	 NULL }} ;

