/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  EfuncWord[]= {
	{ "EABOUT",	 "ֻabout	about " },
	{ "EABOVE",	 "ֻabove	above " },
	{ "EACROSS",	 "ֻacross	across " },
	{ "EAFTER",	 "ֻafter	after " },
	{ "EAGAINST",	 "ֻagainst	against " },
	{ "EALONG",	 "ֻalong	along " },
	{ "EAMONG",	 "ֻamong	among " },
	{ "EAROUND",	 "ֻaround	around " },
	{ "EAS",	 "ֻas	as " },
	{ "EAT",	 "ֻat	at " },
	{ "EAWAY",	 "ֻaway	away " },
	{ "EBEFORE",	 "ֻbefore	before " },
	{ "EBEHIND",	 "ֻbehind	behind " },
	{ "EBELOW",	 "ֻbelow	below " },
	{ "EBESIDE",	 "ֻbeside	beside " },
	{ "EBETWEEN",	 "ֻbetween	between " },
	{ "EBEYOND",	 "ֻbeyond	beyond " },
	{ "EBY",	 "ֻby	by " },
	{ "EDOWN",	 "ֻdown	down " },
	{ "EDURING",	 "ֻduring	during " },
	{ "EEXCEPT",	 "ֻexcept	except " },
	{ "EFOR",	 "ֻfor	for " },
	{ "EFROM",	 "ֻfrom	from " },
	{ "EIN",	 "ֻin	in " },
	{ "EINTO",	 "ֻinto	into " },
	{ "ELIKE",	 "ֻlike	like " },
	{ "ENEAR",	 "ֻnear	near " },
	{ "ENEXT",	 "ֻnext	next " },
	{ "EOF",	 "ֻof	of " },
	{ "EOFF",	 "ֻoff	off " },
	{ "EON",	 "ֻon	on " },
	{ "EONTO",	 "ֻonto	onto " },
	{ "EOUT",	 "ֻout	out " },
	{ "EOVER",	 "ֻover	over " },
	{ "EPAST",	 "ֻpast	past " },
	{ "EPER",	 "ֻper	per " },
	{ "EROUND",	 "ֻround	round " },
	{ "ESINCE",	 "ֻsince	since " },
	{ "ETHAN",	 "ֻthan	than " },
	{ "ETHROUGH",	 "ֻthrough	through " },
	{ "ETILL",	 "ֻtill	till " },
	{ "ETO",	 "ֻto	to " },
	{ "ETOWARD",	 "ֻtoward	toward " },
	{ "EUNDER",	 "ֻunder	under " },
	{ "EUNTIL",	 "ֻuntil	until " },
	{ "EUP",	 "ֻup	up " },
	{ "EUPON",	 "ֻupon	upon " },
	{ "EWHILE",	 "ֻwhile	while " },
	{ "EWITH",	 "ֻwith	with " },
	{ "EWITHIN",	 "ֻwithin	within " },
	{ "EWITHOUT",	 "ֻwithout	without " },

	{ "ECONCERNING",	 "ֻconcerning	concerning " },
	{ "ECONSIDERING",	 "ֻconsidering	considering " },
	{ "ECONSISTING",	 "ֻconsisting	consisting " },
	{ "EDEPENDING",	 "ֻdepending	depending " },
	{ "EEXCEPTING",	 "ֻexcepting	excepting " },
	{ "EEXCLUDING",	 "ֻexcluding	excluding " },
	{ "EFOLLOWING",	 "ֻfollowing	following " },
	{ "EINCLUDING",	 "ֻincluding	including " },
	{ "EINVOLVING",	 "ֻinvolving	involving " },
	{ "EPENDING",	 "ֻpending	pending " },
	{ "EREGARDING",	 "ֻregarding	regarding " },
	{ "ERESPECTING",	 "ֻrespecting	respecting " },
	{ "EACCORDING-TO",	 "ֻaccording to	according to " },
	{ "EALONG-WITH",	 "ֻalong with	along with " },
	{ "EAS-FOR",	 "ֻas for	as for " },
	{ "EAS-REGARDS",	 "ֻas regards	as regards " },
	{ "EAS-TO",	 "ֻas to	as to " },
	{ "EBASED-ON",	 "ֻbased on	based on " },
	{ "EBASED-UPON",	 "ֻbased upon	based upon " },
	{ "EBECAUSE-OF",	 "ֻbecause of	because of " },
	{ "ECONSISTING-OF",	 "ֻconsisting of	consisting of " },
	{ "EDOWN-TO",	 "ֻdown to	down to " },
	{ "EDUE-TO",	 "ֻdue to	due to " },
	{ "EOUT-OF",	 "ֻout of	out of " },
	{ "EPRIOR-TO",	 "ֻprior to	prior to " },
	{ "EUP-TO",	 "ֻup to	up to " },
	{ "EBY-MEANS-OF",	 "ֻby means of	by means of " },
	{ "EBY-WAY-OF",	 "ֻby way of	by way of " },
	{ "EIN-FRONT-OF",	 "ֻin front of	in front of " },
	{ "EIN-RESPECT-TO",	 "ֻin respect to	in respect to " },
	{ "EIN-TERMS-OF",	 "ֻin terms of	in terms of " },
	{ "EIN-VIEW-OF",	 "ֻin view of	in view of " },
	{ "EON-ACCOUNT-OF",	 "ֻon account of	on account of " },
	{ "EON-BEHALF-OF",	 "ֻon behalf of	on behalf of " },
	{ "EON-TOP-OF",	 "ֻon top of	on top of " },
	{ "EWITH-REGARD-TO",	 "ֻwith regard to	with regard to " },
	{ "EFOR-BENEFIT-OF",	 "ֻfor the benefit of	for the benefit of " },
	{ "EFOR-PURPOSE-OF",	 "ֻfor the purpose of	for the purpose of " },
	{ "EFOR-SAKE-OF",	 "ֻfor the sake of	for the sake of " },
	{ "EIN-COURSE-OF",	 "ֻin the course of	in the course of " },
	{ "EIN-MATTER-OF",	 "ֻin the mater of	in the mater of " },
	{ "EIN-MIDDLE-OF",	 "ֻin the middle of	in the middle of " },
	{ "EIN-WAY-OF",	 "ֻin he way of	in he way of " },
	{ "EON-BASIS-OF",	 "ֻon the basis of	on the basis of " },

	{ "EABE",	 "be	be" },
	{ "EADO",	 "ư졦ưdo	do " },
	{ "EAHAVE",	 "ư졦ưhave	have " },
	{ "EACAN",	 "ư졦ưcan	can " },
	{ "EACOULD",	 "ư졦ưcould	could " },
	{ "EAMAY",	 "ư졦ưmay	may " },
	{ "EAMIGHT",	 "ư졦ưmight	might " },
	{ "EASHALL",	 "ư졦ưshall	shall " },
	{ "EASHOULD",	 "ư졦ưshould	should " },
	{ "EAWILL",	 "ư졦ưwill	will " },
	{ "EAWOULD",	 "ư졦ưwould	would " },
	{ "EAMUST",	 "ư졦ưmust	must " },
	{ "EAHAD-BETTER",	 "ư졦ưhad beter	had beter " },
	{ "EAHAVE-TO",	 "ư졦ưhave to	have to " },
	{ "EAOUGHT-TO",	 "ư졦ưought to	ought to " },
	{ "EAUSED-TO",	 "ư졦ưused to	used to " },
	{ "EABE-TO",	 "ư졦ưbe to	be to " },
	{ "EANEED",	 "ư졦ưneed	need " },
	{ "EADARE",	 "ư졦ưdare	dare " },
	{ "EABE-ABLE-TO",	 "ư졦ưbe able to	be able to " },
	{ "EABE-GOING-TO",	 "ư졦ưbe going to	be going to " },
	{ "EABE-ABOUT-TO",	 "ư졦ưbe about to	be about to " },
	{ "EACANNOT",	 "ư졦ưcannot	cannot " },

	{ "ECAFTER",	 "³ / ³ / °³after 	after  " },
	{ "ECAGAINST",	 "³ / ³ / °³against 	against  " },
	{ "ECALSO",	 "³ / ³ / °³also 	also  " },
	{ "ECAND",	 "³ / ³ / °³and 	and  " },
	{ "ECASAS",	 "³ / ³ / °³as 	as  " },
	{ "ECBECAUSE",	 "³ / ³ / °³because 	because  " },
	{ "ECBEFORE",	 "³ / ³ / °³before 	before  " },
	{ "ECBESIDE",	 "³ / ³ / °³beside 	beside  " },
	{ "ECBESIDES",	 "³ / ³ / °³besides 	besides  " },
	{ "ECBOTH",	 "³ / ³ / °³both 	both  " },
	{ "ECBUT",	 "³ / ³ / °³but 	but  " },
	{ "ECDIRECTLY",	 "³ / ³ / °³directly 	directly  " },
	{ "ECEITHER",	 "³ / ³ / °³either 	either  " },
	{ "ECELSE",	 "³ / ³ / °³else 	else  " },
	{ "ECEXCEPT",	 "³ / ³ / °³except 	except  " },
	{ "ECIF",	 "³ / ³ / °³if 	if  " },
	{ "ECIMMEDIATELY",	 "³ / ³ / °³immediately 	immediately  " },
	{ "ECINSTANTLY",	 "³ / ³ / °³instantly 	instantly  " },
	{ "ECLEST",	 "³ / ³ / °³lest 	lest  " },
	{ "ECLIKE",	 "³ / ³ / °³like 	like  " },
	{ "ECMOREOVER",	 "³ / ³ / °³moreover 	moreover  " },
	{ "ECNEITHER",	 "³ / ³ / °³neither 	neither  " },
	{ "ECNOR",	 "³ / ³ / °³nor 	nor  " },
	{ "ECNOW",	 "³ / ³ / °³now 	now  " },
	{ "ECONLY",	 "³ / ³ / °³only 	only  " },
	{ "ECONCE",	 "³ / ³ / °³once 	once  " },
	{ "ECOTHERWISE",	 "³ / ³ / °³otherwise 	otherwise  " },
	{ "ECOR",	 "³ / ³ / °³or 	or  " },
	{ "ECPROVIDED",	 "³ / ³ / °³provided 	provided  " },
	{ "ECPROVIDING",	 "³ / ³ / °³providing 	providing  " },
	{ "ECSINCE",	 "³ / ³ / °³since 	since  " },
	{ "ECSO",	 "³ / ³ / °³so 	so  " },
	{ "ECSUPPOSE",	 "³ / ³ / °³suppose 	suppose  " },
	{ "ECSUPPOSING",	 "³ / ³ / °³supposing 	supposing  " },
	{ "ECTHAN",	 "³ / ³ / °³than 	than  " },
	{ "ECTHEN",	 "³then	then " },
	{ "ECTHOUGH",	 "³ / ³ / °³though, although	though, although " },
	{ "ECTILL",	 "³ / ³ / °³till, until 	till, until  " },
	{ "ECUNLESS",	 "³ / ³ / °³unless 	unless  " },
	{ "ECWHILE",	 "³ / ³ / °³while 	while  " },
	{ "ECYET",	 "³ / ³ / °³yet 	yet  " },
	{ "ECAS-IF",	 "³ / ³ / °³as if 	as if  " },
	{ "ECAS-THOUGH",	 "³ / ³ / °³as though 	as though  " },
	{ "ECEVEN-IF",	 "³ / ³ / °³even if 	even if  " },
	{ "ECEVEN-THOUGH",	 "³ / ³ / °³even though 	even though  " },
	{ "ECIN-ORDER-THAT",	 "³ / ³ / °³in order that 	in order that  " },
	{ "ECSO-THAT",	 "³ / ³ / °³so that 	so that  " },

	{ "ERQWHO",	 "(/-/)ǽwho	who " },
	{ "ERQWHOSE",	 "(/-/)ǽwhose	whose " },
	{ "ERQWHOM",	 "(/-/)ǽwhom	whom " },
	{ "ERQWHICH",	 "(/-/)ǽwhich	which " },
	{ "ERQTHAT",	 "(/-/)ǽthat	that " },
	{ "ERQWHAT",	 "(/-/)ǽwhat	what " },
	{ "ERQHOW",	 "(/-/)ǽhow	how " },
	{ "ERQWHEN",	 "(/-/)ǽwhen	when " },
	{ "ERQWHERE",	 "(/-/)ǽwhere	where " },
	{ "ERQWHY",	 "(/-/)ǽwhy	why " },
	{ "ERQWHOEVER",	 "(/-/)ǽwhoever	whoever " },
	{ "ERQWHICHEVER",	 "(/-/)ǽwhichever	whichever " },
	{ "ERQWHATEVER",	 "(/-/)ǽwhatever	whatever " },
	{ "ERQWHEREVER",	 "(/-/)ǽwherever	wherever " },
	{ "ERQWHENEVER",	 "(/-/)ǽwhenever	whenever " },
	{ "ERQWHETHER",	 "(/-/)ǽwhether	whether " },

	{ "EFNOT",	 "not	not" },
	{ "EFNEVER",	 "never	never" },
	{ "EFMORE",	 "more	more" },
	{ "EFMOST",	 "most	most" },
	{ "EFTHAT",	 "that	that" },
	{ "EFTO",	 "to	to" },
	{ "EFNOT-TO",	 "not to	not to" },

	{ "EDEGIT",	 "	Numeral" },

	{ "ECCONSIDERING",	 "³CONSIDERING	CONSIDERING " },
	{ "ECFURTHERMORE",	 "³FURTHERMORE	FURTHERMORE " },
	{ "ECHENCE",	 "³HENCE	HENCE " },
	{ "ECHEREAT",	 "³HEREAT	HEREAT " },
	{ "ECHOWEVER",	 "³HOWEVER	HOWEVER " },
	{ "ECMEANWHILE",	 "³MEANWHILE	MEANWHILE " },
	{ "ECNEVERTHELESS",	 "³NEVERTHELESS	NEVERTHELESS " },
	{ "ECSEEING",	 "³SEEING	SEEING " },
	{ "ECSTILL",	 "³STILL	STILL " },
	{ "ECTHEREFORE",	 "³THEREFORE	THEREFORE " },
	{ "ECTHUS",	 "³THUS	THUS " },
	{ "ECWHEN",	 "³WHEN	WHEN " },
	{ "ECWHENCESOEVER",	 "³WHENCESOEVER	WHENCESOEVER " },
	{ "ECWHENEVER",	 "³WHENEVER	WHENEVER " },
	{ "ECWHERE",	 "³WHERE	WHERE " },
	{ "ECWHEREAS",	 "³WHEREAS	WHEREAS " },
	{ "ECWHEREAT",	 "³WHEREAT	WHEREAT " },
	{ "ECWHEREEVER",	 "³WHEREEVER	WHEREEVER " },
	{ "ECWHEREFORE",	 "³WHEREFORE	WHEREFORE " },
	{ "ECWHEREVER",	 "³WHEREVER	WHEREVER " },
	{ "ERQEVERYWHERE",	 "(/-/)ǽEVERYWHERE	EVERYWHERE " },
	{ "ERQHOWEVER",	 "(/-/)ǽHOWEVER	HOWEVER " },
	{ "ERQWHATSOEVER",	 "(/-/)ǽWHATSOEVER	WHATSOEVER " },
	{ "ERQWHEREABOUTS",	 "(/-/)ǽWHEREABOUTS	WHEREABOUTS " },
	{ "ERQWHEREAT",	 "(/-/)ǽWHEREAT	WHEREAT " },
	{ "ERQWHEREBY",	 "(/-/)ǽWHEREBY	WHEREBY " },
	{ "ERQWHEREFORE",	 "(/-/)ǽWHEREFORE	WHEREFORE " },
	{ "ERQWHEREFROM",	 "(/-/)ǽWHEREFROM	WHEREFROM " },
	{ "ERQWHEREIN",	 "(/-/)ǽWHEREIN	WHEREIN " },
	{ "ERQWHEREINTO",	 "(/-/)ǽWHEREINTO	WHEREINTO " },
	{ "ERQWHEREOF",	 "(/-/)ǽWHEREOF	WHEREOF " },
	{ "ERQWHEREON",	 "(/-/)ǽWHEREON	WHEREON " },
	{ "ERQWHERETHROUGH",	 "(/-/)ǽWHERETHROUGH	WHERETHROUGH " },
	{ "ERQWHERETO",	 "(/-/)ǽWHERETO	WHERETO " },
	{ "ERQWHEREUNDER",	 "(/-/)ǽWHEREUNDER	WHEREUNDER " },
	{ "ERQWHEREUPON",	 "(/-/)ǽWHEREUPON	WHEREUPON " },
	{ "ERQWHEREWITH",	 "(/-/)ǽWHEREWITH	WHEREWITH " },
	{ "ERQWHICHSOEVER",	 "(/-/)ǽWHICHSOEVER	WHICHSOEVER " },
	{ "ERQWHOMEVER",	 "(/-/)ǽWHOMEVER	WHOMEVER " },
	{ "ERQWHOMSOEVER",	 "(/-/)ǽWHOMSOEVER	WHOMSOEVER " },
	{ "ERQWHOSESOEVER",	 "(/-/)ǽWHOSESOEVER	WHOSESOEVER " },
	{ "ERQWHOSEVER",	 "(/-/)ǽWHOSEVER	WHOSEVER " },
	{ "ERQWHOSOEVER",	 "(/-/)ǽWHOSOEVER	WHOSOEVER " },

	{ "EBACK",	 "³EBACK	EBACK " },
	{ "ECNAMELY",	 "NAMELY	NAMELY " },
	{ "ECTHAT",	 "°³THAT	THAT " },
	{ "ECWHERESO",	 "³WHERESO	WHERESO " },
	{ "ECWITHOUT",	 "³WITHOUT	WITHOUT " },
	{ "EFORTH",	 "쾮FORTH	FORTH " },

	{ "EABAFT",	 "ֻABAFT	ABAFT " },
	{ "EABORD",	 "ֻABORD	ABORD " },
	{ "EAHAVE-GOT-TO",	 "ưHAVE GOT TO	HAVE GOT TO " },
	{ "EALONGSIDE",	 "ֻALONGSIDE	ALONGSIDE " },
	{ "EAMID",	 "ֻAMID	AMID " },
	{ "EASTRIDE",	 "ֻASTRIDE	ASTRIDE " },
	{ "EATOP",	 "ֻATOP	ATOP " },
	{ "EAUSED-TO",	 "ưAUSED TO	AUSED TO " },
	{ "EAWOULD-RATHER",	 "ưWOULD RATHER	WOULD RATHER " },
	{ "EBENEATH",	 "ֻBENEATH	BENEATH " },
	{ "EBESIDE",	 "ֻBESIDE	BESIDE " },
	{ "EBESIDES",	 "ֻBESIDES	BESIDES " },
	{ "ECHEZ",	 "ֻCHEZ	CHEZ " },
	{ "ECWHETHER",	 "°³WHETHER	WHETHER " },
	{ "ECWHICHEVER",	 "³WHICHEVER	WHICHEVER " },
	{ "EDESPITE",	 "ֻDESPITE	DESPITE " },
	{ "EGIVEN",	 "ֻGIVEN	GIVEN " },
	{ "EIN-SPITE-OF",	 "ֻIN SPITE OF	IN SPITE OF " },
	{ "EINSIDE",	 "ֻINSIDE	INSIDE " },
	{ "EMINUS",	 "ֻMINUS	MINUS " },
	{ "EMODULO",	 "ֻMODULO	MODULO " },
	{ "EOPPOSITE",	 "ֻOPPOSITE	OPPOSITE " },
	{ "EOR",	 "ֻOR	OR " },
	{ "EOUTSIDE",	 "ֻOUTSIDE	OUTSIDE " },
	{ "EPACE",	 "ֻPACE	PACE " },
	{ "EPLUS",	 "ֻPLUS	PLUS " },
	{ "ETHROUGHOUT",	 "ֻTHROUGHOUT	THROUGHOUT " },
	{ "ETIMES",	 "ֻTIMES	TIMES " },
	{ "EUNLIKE",	 "ֻUNLIKE	UNLIKE " },
	{ "EWORTH",	 "ֻWORTH	WORTH " },
	{ "EAFOUL-OF",	 "ֻAFOUL OF	AFOUL OF " },
        { NULL,  NULL }} ;






