/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  E_POS[]= {
	{ "EN1",	 "̾	Common noun" },
	{ "EN2",	 "ͭ̾	Proper noun" },
	{ "EN3",	 "	Cardinal number" },
	{ "EN4",	 "	Ordinal number" },
	{ "EN5",	 "	Classifier" },
	{ "EP1",	 ";̾	Personal pronoun" },
	{ "EP2",	 "̾	Interrogative pronoun" },
	{ "EP3",	 "ؼ̾	Demonstrative  pronoun" },
	{ "EP4",	 "̾	Indefinite pronoun" },
	{ "EP5",	 "ط̾	Relative pronoun" },
	{ "EVE",	 "ư	Verb" },
	{ "EBE",	 "be	Be-verb" },
	{ "EAJ",	 "ƻ	Adjective" },
	{ "ED1",	 "ط	Relative adverb" },
	{ "ED2",	 "	Interrogative adverb" },
	{ "ED3",	 "쾮	Adverbial particle" },
	{ "ED4",	 "³	Conjunctive adverb" },
	{ "ED5",	 "	Common adverb" },
	{ "EPR",	 "ֻ	Preposition" },
	{ "EPR2",	 "ֻ	Preposition equivalent" },
	{ "ET1",	 "ؼ	Demonstrative determiner" },
	{ "ET2",	 "	Indefinite  determine" },
	{ "EAR",	 "	Article" },
	{ "EAV",	 "ư	Auxiliary verb" },
	{ "EAV2",	 "ư	Auxiliary verb equivalent" },
	{ "EIT",	 "	Interjection" },
	{ "EC1",	 "³	Coordinate conjunction" },
	{ "EC12",	 "³	Coordinate conjunction equivalent " },
	{ "EC2",	 "°³	Subordinate conjunction" },
	{ "EC22",	 "°³	Subordinate conjunction equivalent" },
	{ "EPF",	 "Ƭ	Prefix" },
	{ "EEN",	 "̾	Noun  ending" },
	{ "EEV",	 "ư	Verb ending " },
	{ "EEA",	 "ƻ	Adjective ending" },
	{ "EED",	 "	Adverb ending" },
	{ "ENP",	 "̾	Noun phrase" },
	{ "EVP",	 "ư	Verb phrase" },
	{ "EAP",	 "ƻ	Adjective phrase" },
	{ "EDP",	 "	Adverb phrase" },
	{ "EPP",	 "ֻ	Preposition phrase" },
	{ "EIP",	 "Ω	Independent phrase" },
	{ "ESE",	 "ʸ	Sentence" },
	{ "EUN",	 "ñ	Symbol" },
	{ "ESY",	 "	Unit" },
	{ "EFT",	 "to       to-infinitive" },
        { NULL,  NULL }} ;



