/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"

#include "sconst.h"
#include "stemp.h"

char DATA2[32768] ;
int  DATA2CT ;
char DATA1[32768] ;
int  DATA1CT ;
char DATA0[80000] ;
int  DATA0CT ;

void
main(int argc,  char **argv)
{
      int    flag ,ret ;
      int    jj, ii, kk, ll , text_ct;
      char  work[1024], work1[1024] ;
      char  *cp ;
      CFile  *fpt , *dpt;
      int max ;
      char *wdenv ;
      char file[512] ;
      CData cur ;
      int len, dct ;
      CFile *ff ;
      char fname[32] ;
      MorphInfo *mordata[1024] ;
      MorphInfo  morph[4096] ;
      int wlflag = 0 ;

      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */
      LoadRensetduTbl() ;        /* Ϣܥơ֥ɤ߹ */


      wdenv = (char *)getenv( "WORD_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "HDWD_IX" ) ;
      dpt = Open_IXT( file, 's') ;
      strcpy( &file[jj], "JWD" ) ;
      fpt = Open_IXT( file, 'b' ) ;

      DB_FileOpen() ;

      if ( ( ff = OpenBSYSFile( "TEST.OUT" )) == NULL ) {
        fprintf( stderr,"Arya open dekinai!\n" ) ;
        return ;
      }   
      max = Get_NewRecordNo( ff ) ;
printf("max=%d\n",max) ;
      for( text_ct = 1 ; text_ct < max ; text_ct++ ) {
        cur.textno = text_ct ;  /*  ʸֹ                           */
        strcpy( fname, "BUN" ) ;
        cur.field = fname ;
        cur.data = DATA0 ;
        cur.subF = DATA1 ;
        cur.subR = DATA2 ;
        cur.databfsz = 80000 ;
        cur.subRbfsz = 32768 ;
        cur.subFbfsz = 32768 ;
        ret = GetData_BSYSFile( ff, FETC | RETC | FVALUE, &cur ) ;
        printf("++++++++++++++++ %s ++++++++++++++++++\n",cur.field ) ;
        printf("   SubRETC(%d)=[%s]\n",cur.subRsize,cur.subR ) ;
        printf("   SubFETC(%d)=[%s]\n",cur.subFsize,cur.subF ) ;
        printf("   DATA   (%d)=[%s]\n",cur.datasize,cur.data ) ;
        strcpy( fname, "DICT" ) ;

        ret = GetData_BSYSFile( ff, FETC | RETC | FVALUE, &cur ) ;
        printf("++++++++++++++++ %s ++++++++++++++++++\n",cur.field ) ;
        printf("   SubRETC(%d)=[%s]\n",cur.subRsize,cur.subR ) ;
        printf("   SubFETC(%d)=[%s]\n",cur.subFsize,cur.subF ) ;
        printf("   DATA   (%d)=[%s]\n",cur.datasize,cur.data ) ;
        strcpy( fname, "AMorph" ) ;

        ret = GetData_BSYSFile( ff, FETC | RETC | FVALUE, &cur ) ;
        printf("++++++++++++++++ %s ++++++++++++++++++\n",cur.field ) ;
        printf("   SubRETC(%d)=[%s]\n",cur.subRsize,cur.subR ) ;
        printf("   SubFETC(%d)=[%s]\n",cur.subFsize,cur.subF ) ;
        printf("   DATA   (%d)=[%s]\n",cur.datasize,cur.data ) ;
      }
printf("Start DB_FileClose\n") ;
      DB_FileClose() ;

printf("Start CLose_IXT( ff )\n") ;
      Close_IXT( ff ) ;
printf("Start CLose_IXT( dpt )\n") ;
      Close_IXT( dpt ) ;
printf("Start CLose_IXT( fpt )\n") ;
      Close_IXT( fpt ) ;
}


