/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"

#include "sconst.h"
#include "stemp.h"

char DATA2[32768] ;
int  DATA2CT ;
char DATA1[80000] ;
int  DATA1CT ;




void  PrintWordList(char *work1,MorphInfo **mordata)  ;
void WordPr(int word, int offset, MorphInfo **wdinfo, char *text, int textlen, MorphInfo **mordata) ;

void
main(int argc,  char **argv)
{
      int    flag ,ret ;
      int    jj, ii, kk, ll , text_ct;
      char  work[1024], work1[1024] ;
      char  *cp ;
      CFile  *fpt , *dpt;
      int tlen, Rid , Rids[1024] ;
      char *wdenv ;
      char file[512] ;
      CData cur ;
      int len, dct ;
      CFile *ff ;
      char fname[32] ;
      MorphInfo *mordata[1024] ;
      MorphInfo  morph[4096] ;
      int wlflag = 0 ;

      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */
      LoadRensetduTbl() ;        /* Ϣܥơ֥ɤ߹ */

      if ( argc > 1 ) {
        if ( strcmp( *(argv+1), "-WL" ) == 0 ) 
          wlflag = 1 ;
      }
      wdenv = (char *)getenv( "WORD_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "HDWD_IX" ) ;
      dpt = Open_IXT( file, 's') ;
      strcpy( &file[jj], "JWD" ) ;
      fpt = Open_IXT( file, 'b' ) ;

      DB_FileOpen() ;

      if ( ( ff = CreateBSYSFile( "TEST.OUT" )) == NULL ) {
//      if ( ( ff = OpenBSYSFile( "TEST.OUT" )) == NULL ) {
        fprintf( stderr,"Arya open dekinai!\n" ) ;
        return ;
      }   
      text_ct = 0 ;
      while( gets( work ) != NULL ){
          text_ct++ ;
          printf("IN>[%s](%d)\n",work,strlen(work)) ;
          ret = Conv2Big(work1, work) ;
          dct = 0 ;
          cp = &work1[0] ;
          DATA1CT = DATA2CT = 0 ;
          while( *cp != '\0' ) {
            printf("--------------------------- ʬ------------\n") ;
            /* 쥳ֹΤߤ */
            ret = GetRecIDFromHdwd(1,dpt, cp, &morph[dct], 4096 - dct) ;
            if ( ret == 0 ) {
              mordata[ cp - work1 ] = NULL ;
            }
            else {
              printf("[%s]\nret=%d\n",cp, ret) ;
              mordata[ cp - work1 ] = &morph[dct] ;
              for( jj= 0 ; jj < ret ; jj++) {
                TESTSetMorFromRID(fpt,morph[dct+jj].rno,&morph[dct+jj] ) ;
                morph[dct+jj].next = &morph[dct+jj+1] ;
              }
              morph[dct+jj-1].next = NULL ;
              dct += ret ;
            }           
            if ( (*cp & 0x80) == 0)
              cp++ ;
            else {
              mordata[ cp - work1 +1] = NULL ;
              cp += 2 ;
            }
	  }
          /* ɥꥹȤɽ */
          if ( wlflag != 0 )
            PrintWordList(work1,mordata) ;
          cur.textno = text_ct ;
          cur.data = &work1[0] ;
          cur.datasize = strlen( work1 ) +1 ;
          cur.databfsz = 1024 ;
          //strcpy( work, " AAAA = \"BBBBBB\" ; CCCC=sss; DDDD = \"aaaaaa;;" ) ;
          //strcpy( work, "AAAA=\"BBBBBB\";CCCC=sss;DDDD = \"aaaaaa\";;" ) ;
          //strcpy( work, "AAAA=\"BBBBBB\";CCCC=sss;DDDD = \"aaaaaa\";CDATE=\"55/3/12\"" ) ;
          //strcpy( work, "AAAA=\"BBBBBB\";CDATE=\"55/3/12\";CCCC=sss;DDDD = \"aaaaaa\"" ) ;
          //strcpy( work, "CDATE=\"55/3/12\"AAAA=\"BBBBBB\";CCCC=sss;DDDD = \"aaaaaa\"" ) ;
          strcpy( work, "CDATE=\"55/3/12\";AAAA=\"BBBBBB\";CCCC=sss;DDDD = \"aaaaaa\"" ) ;
          cur.subF = work ;
          cur.subFbfsz = 1024 ;
          cur.subR = NULL ;
          cur.subRbfsz = 0 ;
          cur.field = &fname[0] ;
          strcpy( fname, "BUN" ) ;
          ret = PutData_BSYSFile( ff, &cur ) ;
          strcpy( fname, "DICT" ) ;
          cur.data = DATA1 ;
          cur.datasize = DATA1CT+1 ;
          cur.databfsz = 80000 ;
printf("DATA1=[%s]\n",DATA1) ;
printf("###########DADA1CT=%d\n",DATA1CT);

          ret = PutData_BSYSFile( ff, &cur ) ;
          strcpy( fname, "AMorph" ) ;
          cur.data = DATA2 ;
          DATA2[DATA2CT++] = '\0' ;
          cur.datasize = DATA2CT ;
          cur.databfsz = 32768 ;
          ret = PutData_BSYSFile( ff, &cur ) ;
printf("###########DADA2CT=%d\n",DATA2CT);
      }
printf("Start DB_FileClose\n") ;
      DB_FileClose() ;

printf("Start CLose_IXT( ff )\n") ;
      Close_IXT( ff ) ;
printf("Start CLose_IXT( dpt )\n") ;
      Close_IXT( dpt ) ;
printf("Start CLose_IXT( fpt )\n") ;
      Close_IXT( fpt ) ;
}






int  TESTSetMorFromRID(CFile *dt, int id, MorphInfo *mp)
{
  char data[8192], hyoki[512] ,hyoki2[512];
  int  ret ;
  int i , j ;
  char *cary[64] ;
  char wk[8192] ;

  ret = Get_IXT(dt, (char *)&id, 4, data, 8192) ;
  ret = StartPts( data, ret, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

  mp->lcon = data[4] ;      /* Ϣܾ              */
  mp->rcon = data[5] ;      /* Ϣܾ              */
  mp->pos  = data[6] ;      /* ʻ                    */
  i = *(int *)data ;
  j = get4byte( cary[4] ) ;
  mp->grmid  = j ;          /* ʸˡɣ                */
  ret = GetFirstWd( cary[6] , hyoki, 1024) ;
  ret = EDR_StrStrip(hyoki2,hyoki) ;
  ret = Conv2Big(hyoki, hyoki2) ;
  if ( ret < 0 ) {
    ret = 0 ;
  }
  mp->leng =  ret        ;  /* ʸĹ                */
  mp->cid = SetCidValue( cary[5] ) ; /* ǰɣ       */
  mp->flag = wdflagset_etc( cary[10] ) ; /* ե饰å   */


  i = *(int *)data ;
  j = get4byte( cary[4] ) ;
  sprintf( wk, "%s\tRid[%07d]\t%d=%d(%s=%s)\t%d(%s)\tGram[%d]\tCid[%s]\n",cary[6]
           ,i,data[4],data[5],J_lcon[data[4]].type1,J_rcon[data[5]].type1
           ,data[6],J_POS[data[6]].type1,j,cary[5] ) ;
  
  i = strlen( wk ) ;
  if ( (i + DATA1CT) < 80000 ) {
    strcpy( &DATA1[DATA1CT], wk ) ;
    DATA1CT += i ;
    return i ;
  }
  return 0 ;
}








/***********************************************************
*   ɽ
*   USAGE:		PrintWordList(char *text, MorphInfo **mordata)
*   SYNOPSIS:		char       *text (IN) ʸѲΡ
*                       MorInfo    *md   (IN) ǾؤΥݥ
*
*   DESCRIPTION:	
*	ʸñζڤƬˤ˳ƷǾ󤬥󥯤
*     Ƥ롣ηǾϢܾ򸫤ʤ³å
*     ʸ˶ڤ줿Τɽ롣
*
*   RETURN:		
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
void  PrintWordList(char *work1,MorphInfo **mordata) 
{
  int off ;
  MorphInfo *wdinfo[256] ;

  WordPr(0,0,wdinfo,work1,strlen(work1),mordata) ;
  return ;
}


void WordPr(int word, int offset, MorphInfo **wdinfo, char *text, int textlen, MorphInfo **mordata)
{
  MorphInfo *mp , *wp ;
  int ii, off, leng, save ;
  int ret ;
  char work[128] ;

  //printf("WordPr: %d off=%d textlen=%d  <word=%d>\n",word,offset,textlen,word) ;
  if ( textlen == offset ) {
    save = DATA2CT ;
    off = 0 ;
    for( ii = 0 ; ii < word ; ii++ ) {
      leng = (*(wdinfo+ii))->leng ;
      ret = copy_word( work, 128, text+off, text+off+leng ) ;
      if ( ( DATA2CT + leng + 20 ) > 32768 ) {
         fprintf( stderr ," DATA2 is too small!\n" ) ;
         DATA2CT = save ;
         return ;
      }
      sprintf( &DATA2[DATA2CT],"%s(%s,%s) / ",work,J_lcon[(*(wdinfo+ii))->lcon].type1,J_rcon[(*(wdinfo+ii))->rcon].type1 ) ;
      DATA2CT += strlen( &DATA2[DATA2CT] ) ;
      off += leng ;
    }
    DATA2[DATA2CT++] = '\n' ;
    return ;
  }
  if ( *(mordata+offset) == NULL )
    return ;
  for( mp = *(mordata+offset) ; mp != NULL ; mp = mp->next ) {
    if ( word != 0 ) {
      if ( EDR_Rensetsu[ (*(wdinfo+word-1))->rcon ][mp->lcon] == 0 ) {
        //printf("%s,%s FAIL\n",J_lcon[(*(wdinfo+word-1))->rcon].type1,J_rcon[mp->lcon].type1) ;
        continue ;
      }
      //printf("%s,%s SUCCESS\n",J_lcon[(*(wdinfo+word-1))->rcon].type1,J_rcon[mp->lcon].type1) ;
    }
    for( wp = *(mordata+offset) ; wp != mp ; wp = wp->next ) {
      if ( wp->leng == mp->leng && wp->lcon == mp->lcon && wp->rcon == mp->rcon ) 
        break ;
    }
    if ( wp != mp )
      continue ;
    *(wdinfo+word) = mp ;
    WordPr(word+1,offset+(mp->leng), wdinfo, text,textlen, mordata ) ;
  }
  return ;
}


  



